#include "mostrar_lib.hpp"
/*
	Ejemplo de Labeling. Se utiliza conectividad 4 vecinos y se buscan
	los pixels que estan entre 105 y 255. La idea es detectar los arroces.
	Una vez construido el Labeling, cargo las regiones ( candidatos a arroces)
	y opara cada regin construyo un objeto de propiedades. Pinto las regiones 
	de gris 128 mediante un bicotiPixelOperatorUnary. Con el objeto de propiedad
	hallo los pixels del borde de cada regin y con esto construyo otra regin
	(pero no desde una fachada), pinto de blanco el borde de cada regin. Para
	regin calculada muestro en pantalla propiedades bsicas como contidad de pixels
	en la regin y cantidad de pixels en el borde.

*/
typedef unsigned char PixelType;
typedef bicotiCoordinate2D< INTEGER > CoordType;

void main()
{
  bicotiImage2DArrayChar imagen;

  LeerImagen( imagen.GetImplementation(), "../fotos/arroz.bmp" );
  MostrarImagen( imagen.GetImplementation() );


  imagen.BuildDexel();
  bicotiImage2DArrayChar :: Dexel * ptr_dex;
 
  ptr_dex = imagen.GetDexel();
  
  ptr_dex->UsePixelLabelingCriterionRange(105,255);
  ptr_dex->UseConnectivityLabelingStrategy4N();

  ptr_dex->BuildLabeling();
  ptr_dex->LoadRegionLabelingResult();
  ptr_dex->BuildRegionsProperties();
  ptr_dex->DestroyLabeling();

  cout << "Regiones = " << ptr_dex->GetRegionsNumber() << endl;

  bicotiPixelOperatorUnaryConstant< PixelType > * ptr_pix_oper;
  ptr_pix_oper = new bicotiPixelOperatorUnaryConstant< PixelType >( 128 );
  
  bicotiRegionProperty< CoordType, PixelType > proper;
  bicotiDexelRegion< CoordType, PixelType > border_region( imagen.GetImplementation() );

  for( unsigned region_index = 0; region_index < ptr_dex->GetRegionsNumber(); region_index++ )
    {
      ptr_pix_oper->Pixel() = 128;

      cout << "Pintando region" << region_index << endl;
      ptr_dex->GetRegion( region_index )->ModifyPixels( ptr_pix_oper );
      ptr_dex->GetRegion( region_index )->UpdateImageImplementation();
      
      cout << "Pixels in region " << ptr_dex->GetRegionProperty( region_index )->GetPixelsInRegionNumber() << endl;
      cout << "Fixing info" << endl;
      ptr_dex->GetRegionProperty( region_index )->FixInfo();
      cout << "Computing border" << endl;
      ptr_dex->GetRegionProperty( region_index )->ComputeBorder();
      cout << "Pixels in border = " <<  ptr_dex->GetRegionProperty( region_index )->GetPixelsInBorderNumber() << endl;
      
      border_region.GetRegion() =  ptr_dex->GetRegionProperty( region_index )->GetBorder();
      ptr_pix_oper->Pixel() = 255;
      border_region.ModifyPixels( ptr_pix_oper );
      border_region.UpdateImageImplementation();
      cout << "Saliendo de region " << region_index << endl;
    }
  
  MostrarImagen( imagen.GetImplementation() );
  EscribirImagen( imagen.GetImplementation(), "arroz_label.bmp");

  ptr_dex->DestroyRegions();
  imagen.DestroyDexel();
  delete ptr_pix_oper;

}       
