/*
   Este ejemplo muestra como dibujar una curva sobre una imagen ( un crculo )
   (blanco y negro)y luego borrarla.
*/

#define IMAGE_2D_ARRAY_CHAR
#include "../mostrar_lib.hpp"  
 
typedef bicotiCoordinate2D< REAL > CoordRealType;

void main()
{
  const unsigned coord_number = 100;

  CoordRealType centro( 180, 220 );
  const REAL radio = 100;

  bicotiImage2DArrayChar imagen;
 
  LeerImagen( imagen.GetImplementation(), "../Pictures/foto.bmp" );
  MostrarImagen( imagen.GetImplementation() ); 
 
  // Construyo Dexel y defino un puntero para no tener que hacer GetDexel todas las veces
  imagen.BuildDexel(); 
  bicotiImage2DArrayChar :: Dexel * ptr_dex;
  ptr_dex = imagen.GetDexel(); 

  // Construyo un circulo en la imagen
  vector< CoordRealType > lista_coordenadas(coord_number);
  for( unsigned index = 0; index < coord_number; index++ )
    {lista_coordenadas[ index ].X0() = ( centro.X0() + radio * cos( (2*pi*index / (double)coord_number) ) );
    lista_coordenadas[ index ].X1() = ( centro.X1() + radio * sin( (2*pi*index / (double)coord_number) ) );}
  ptr_dex->BuildNewCurveClosedLinear(lista_coordenadas);
  
  // Seteo puntos en la imagen sobre la curva
  for( unsigned index = 0; index < 10 * coord_number; index++ )
    ptr_dex->GetCurveClosed(0)->SetPixel( (double)index / (10*coord_number) , 255 );
  ptr_dex->GetCurveClosed(0)->UpdateImageImplementation();

  MostrarImagen( imagen.GetImplementation() );

  // Deshago los cambios en la imagen
  ptr_dex->GetCurveClosed(0)->UndoUpdateImageImplementation();

  MostrarImagen( imagen.GetImplementation() );
};
   
