//************************************************************************
//* Este archivo contiene algunos ejemplos de las diferentes estrategias *
//* de extrapolacin de imagenes                                         *
//************************************************************************  

#include "basic_fun.hpp"  

void main()
{
  unsigned filas = 4, columnas = 5;
  unsigned borde = 2;
  unsigned filas_des;
  unsigned columnas_des;
  float escala = 1;
  int default_pixel = 9;
  int ext_pix = 0;
  int option;

  cout<<"================================================================"<<endl;
  cout<<"Ingrese la cantidad de FILAS de la imagen original : ";
  cin>>filas;
  cout<<"Ingrese la cantidad de COLUMNAS de la imagen original : ";
  cin>>columnas;
  cout<<"Ingrese la cantidad de pixeles del BORDE de la imagen a extrapolar : ";
  cin>>borde;

  cout<<"================================================================"<<endl;
  cout<<" Estrategia de extrapolacin "<<endl;
  cout<<" 1 - Constant"<<endl;
  cout<<" 2 - Equal"<<endl;
  cout<<" 3 - Simetric"<<endl;
  cout<<" 4 - Ciclic"<<endl;
  cout<<"Ingrese su opcion : ";
  cin>>option;

  // Primeramente creo una imagen 2D Array de enteros 
  bicotiImageImplementation2DArray< int > * ptr_ima_src;
  ptr_ima_src = new bicotiImageImplementation2DArray< int >(default_pixel , columnas , filas , escala , single);

  filas_des = filas + 2 * borde;
  columnas_des = columnas + 2 * borde;

  // Ahora creo una imagen 2D Array de enteros ms grande, con borde
  bicotiImageImplementation2DArray< int > * ptr_ima_des;
  ptr_ima_des = new bicotiImageImplementation2DArray< int >(default_pixel , columnas_des , filas_des, escala , single);
  

  // Creo la estrategia de acuerdo a la opcin
  bicotiImageExtrapolationStrategy2D< int > * ptr_ext_strat;

  switch ( option ){
  case 1 :
    cout<<"Ingrese el valor del pixel del borde : ";
    cin>>ext_pix;
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DConstant< int >(ext_pix);
    break;
  case 2:
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DEqual< int >;
    break;
  case 3:
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DSimetric< int >;
    break;
  case 4:
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DCiclic< int >;
  };
  
  ptr_ext_strat->SetImplementation(ptr_ima_src);
  

  cout<<"================================================================"<<endl;
  // Le seteo valores aleatorios a la original y luego la muestro.
  SetRand( ptr_ima_src );
  Show( ptr_ima_src , " Imagen Original");

  // Cargo la nueva imagen a travs de la estrategia y la muestro.  
  unsigned i,j;
  for ( i = 0 ; i < filas_des ; i++ )
    for ( j = 0 ; j < columnas_des ; j++ )
      ptr_ima_des->SetPixel( j, i, (*ptr_ext_strat)( j - borde, i - borde ) );
  
  cout<<endl;
  Show( ptr_ima_des , " Imagen Extrapolada");  

  delete ptr_ima_src;
  delete ptr_ima_des;
  delete ptr_ext_strat;
}

