//************************************************************************
//* Este archivo contiene algunos ejemplos de las diferentes estrategias *
//* de extrapolacin de imagenes                                         *
//************************************************************************  

#include "../mostrar_lib.hpp"  

void main()
{

  bicotiImageImplementation2D< unsigned char > * ptr_ima_src;
  ptr_ima_src = new bicotiImageImplementation2DArray< unsigned char >(0,0,0);

  LeerImagen( ptr_ima_src,"../Pictures/foto.bmp");

  MostrarImagen( ptr_ima_src );
  
  unsigned borde;
  unsigned filas_des;
  unsigned columnas_des;
  int ext_pix = 0;
  int option;

  cout<<"================================================================"<<endl;
  cout<<"Ingrese la cantidad de pixeles del BORDE de la imagen a extrapolar : ";
  cin>>borde;

  cout<<"================================================================"<<endl;
  cout<<" Estrategia de extrapolacin "<<endl;
  cout<<" 1 - Constant"<<endl;
  cout<<" 2 - Equal"<<endl;
  cout<<" 3 - Simetric"<<endl;
  cout<<" 4 - Ciclic"<<endl;
  cout<<"Ingrese su opcion : ";
  cin>>option;

  filas_des = ptr_ima_src->GetX1Size() + 2 * borde;
  columnas_des = ptr_ima_src->GetX0Size() + 2 * borde;

  // Ahora creo una imagen 2D Array de enteros ms grande, con borde
  bicotiImageImplementation2DArray< unsigned char > * ptr_ima_des;
  ptr_ima_des = new bicotiImageImplementation2DArray< unsigned char >(0, columnas_des , filas_des );
  

  // Creo la estrategia de acuerdo a la opcin
  bicotiImageExtrapolationStrategy2D< unsigned char > * ptr_ext_strat;

  switch ( option ){
  case 1 :
    cout<<"Ingrese el valor del pixel del borde : ";
    cin>>ext_pix;
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DConstant< unsigned char >(ext_pix);
    break;
  case 2:
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DEqual< unsigned char >;
    break;
  case 3:
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DSimetric< unsigned char >;
    break;
  case 4:
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DCiclic< unsigned char >;
  };
  
  ptr_ext_strat->SetImplementation(ptr_ima_src);
  

  cout<<"================================================================"<<endl;

  // Cargo la nueva imagen a travs de la estrategia y la muestro.  
  unsigned i,j;
  for ( i = 0 ; i < filas_des ; i++ )
    for ( j = 0 ; j < columnas_des ; j++ )
      ptr_ima_des->SetPixel( j, i, (*ptr_ext_strat)( j - borde, i - borde ) );

  MostrarImagen( ptr_ima_des );

  delete ptr_ima_src;
  delete ptr_ext_strat;
};

