#include "mostrar_lib.hpp" 

//-----------------------------------------------------------------
//
//  Resumen de operaciones de bicotiImage2DArrayBool que resultan de definir bicotiImage2DArrayBool
//
//         + -> OR (Unin)
//         - -> XOR
//         . -> AND (Interseccin)
//  Negation -> ! funcion implementada en este mdulo
//
//-----------------------------------------------------------------

//-----------------------------------------------------------------
//
// MostrarConsola
//
//-----------------------------------------------------------------

void MostrarConsola( bicotiImage2DArrayBool & ima )
{
   unsigned filas = ima.GetImplementation()->GetX1Size();
   unsigned columnas = ima.GetImplementation()->GetX0Size();
   unsigned i,j;

   cout<<"->"<<endl;
   for ( i=0; i<filas; i++ )
     { for ( j=0; j<columnas; j++ )
         if (ima.GetImplementation()->GetPixel(j,i))
	   cout<<"O";
	 else
	   cout<<" ";
     cout<<endl;}; 
   cout<<"<-"<<endl;
};

//-----------------------------------------------------------------
//
// Mostrar
//
//-----------------------------------------------------------------

void Mostrar( bicotiImage2DArrayBool & ima)
{
  unsigned filas = ima.GetImplementation()->GetX1Size();
  unsigned columnas = ima.GetImplementation()->GetX0Size();
  
  bicotiImage2DArrayChar ima_show(columnas,filas);
  bicotiImage2DArrayChar::Iterator* iter_show = ima_show.CreateIterator();
  bicotiImage2DArrayBool::Iterator* iter = ima.CreateIterator();
  for( iter_show->First(), iter->First(); !iter->IsDone(); (*iter)++, (*iter_show)++){
    if ( **iter == true )
      **iter_show = 255;
    else
      **iter_show = 0;
  }

  MostrarImagen( ima_show.GetImplementation() );
  delete iter_show;
  delete iter;
}


//-----------------------------------------------------------------
//
// Negation
//
//-----------------------------------------------------------------

void Negation( bicotiImage2DArrayBool & ima )
{
   unsigned filas = ima.GetImplementation()->GetX1Size();
   unsigned columnas = ima.GetImplementation()->GetX0Size();
   unsigned i,j;

   for ( i=0; i<filas; i++ ){
     for ( j=0; j<columnas; j++ ){
       if (ima.GetImplementation()->GetPixel(j,i))
	 ima.GetImplementation()->SetPixel(j,i,0);
       else
	 ima.GetImplementation()->SetPixel(j,i,1);
     }
   }
};
//-----------------------------------------------------------------
//
// Equals: compara dos imgenes
//
//-----------------------------------------------------------------

bool Equals( bicotiImage2DArrayBool & ima1, bicotiImage2DArrayBool & ima2 )
{
   unsigned ima1_X1_size = ima1.GetImplementation()->GetX1Size();
   unsigned ima1_X0_size = ima1.GetImplementation()->GetX0Size();
   unsigned ima2_X1_size = ima2.GetImplementation()->GetX1Size();
   unsigned ima2_X0_size = ima2.GetImplementation()->GetX0Size();

   if ( (ima1_X1_size != ima2_X1_size)||(ima1_X0_size != ima2_X0_size) )
     return (false);

   for ( unsigned i=0; i < ima1_X0_size; i++ )
     for ( unsigned j=0; j < ima1_X1_size; j++ )
       if  ( (ima1.GetImplementation()->GetPixel(i,j)) != (ima2.GetImplementation()->GetPixel(i,j)) )
	return (false);
   return (true);
}

//-----------------------------------------------------------------
//
// Reflexion
//
//-----------------------------------------------------------------


void Reflexion( bicotiImage2DArrayBool & ima )
{
   unsigned X0_size = ima.GetImplementation()->GetX0Size();
   unsigned X1_size = ima.GetImplementation()->GetX1Size();
   unsigned i,j,u,v,size,aux;
   bool aux1,aux2;

   if (X0_size != X1_size)
     return;
   
   size = X0_size;
   aux = size/2;
   cout<<"size = "<<size<<endl;
   cout<<"size/2 = "<<aux<<endl;

   // Tengo que recorrer hasta la mitad de las filas, esto es hasta size/2.
   // Si size es impar no recorre la fila del medio, lo hago despus.

   //Recorre la hasta la mitad de las columnas i, excluyendo la central i=(size-1)/2.
   for ( i=0; i < size/2; i++ ){
     for ( j=0; j < size; j++ ){
       u = size-1-i;
       v = size-1-j;
       aux1 = ima.GetImplementation()->GetPixel(i,j);
       aux2 = ima.GetImplementation()->GetPixel(u,v);
       ima.GetImplementation()->SetPixel(i,j,aux2);
       ima.GetImplementation()->SetPixel(u,v,aux1);
     }
   }

   // Si size es impar tengo que recorrer la fila del medio hasta la mitad de las columnas
   if (remainder(size,2)!=0){
     i = (size-1)/2;
     for (j=0; j < (size-1)/2; j++){
       v = size-1-j;
       aux1 = ima.GetImplementation()->GetPixel(i,j);
       aux2 = ima.GetImplementation()->GetPixel(i,v);
       ima.GetImplementation()->SetPixel(i,j,aux2);
       ima.GetImplementation()->SetPixel(i,v,aux1);
     }
   }
}


//-----------------------------------------------------------------
//
//Crea un rectngulo
//
//-----------------------------------------------------------------

void Rectangulo (bicotiImage2DArrayBool & ima, unsigned borde)
{
  unsigned i,j;
  unsigned x0 = ima.GetImplementation()->GetX1Size();
  unsigned x1 = ima.GetImplementation()->GetX0Size();
  for (i=borde;i<(x0-borde);i++)
    { ima.GetImplementation()->SetPixel(i,borde,true);
      ima.GetImplementation()->SetPixel(i,(x1-borde),true);};
  for (j=borde;i<(x1-borde);i++)
    { ima.GetImplementation()->SetPixel(borde,i,true);
      ima.GetImplementation()->SetPixel((x0-borde),i,true);};
};


//-----------------------------------------------------------------
//
//Crea un rectngulo lleno
//
//-----------------------------------------------------------------

void Rectangulo_lleno (bicotiImage2DArrayBool & ima, unsigned borde)
{
  unsigned i,j;
  unsigned filas = ima.GetImplementation()->GetX1Size();
  unsigned columnas = ima.GetImplementation()->GetX0Size();

  for (i=borde; i < (filas-borde); i++){
    for (j=borde; j< (columnas-borde); j++){
     ima.GetImplementation()->SetPixel(i,j,true);
    }
  }
};

//-----------------------------------------------------------------
//
// Crea la figura del gonzalez pag. 525
//
//-----------------------------------------------------------------

void Figura ( bicotiImage2DArrayBool & ima)
{
  unsigned i,j,k;


  for (j=10; j<=14;j++){
    for (i=10; i<=35; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
    for (i=45; i<=70; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
  }


  for (j=15; j<=19; j++){
    for ( i=10; i<=35; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
    for (i=45; i<=60; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
  }

  for ( j=20; j<=24; j++ ){
    for ( i=25; i<=60; i++ )
      ima.GetImplementation()->SetPixel(i,j,true);
  }

  for ( j=25; j<=29; j++){
    for ( i=10; i<=35; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
    for ( i=45; i<=60; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
  }

  for ( j=30; j<=34; j++){
    for ( i=10; i<=35; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
    for ( i=45; i<=70; i++)
      ima.GetImplementation()->SetPixel(i,j,true);
  }
}




//-----------------------------------------------------------------
//
// Crea un circulo
//
//-----------------------------------------------------------------

void Circulo ( bicotiImage2DArrayBool & ima )
{
  unsigned i,j;
  unsigned size = ima.GetImplementation()->GetX1Size();
  double center = (size-1)/2;
  double radious = center + 0.5;

  for ( i=0; i<size; i++){
    for ( j=0; j<size; j++){
      if ( hypot( (i-center), (j-center) ) <= radious )
	ima.GetImplementation()->SetPixel(i,j,true);
      }
    }
};




//-----------------------------------------------------------------
//
// Dilatacion
//  Dilatacion(A,B) es la dialtacion de la imagen A con el elemento estructurante B
//
//-----------------------------------------------------------------


void Dilatation( bicotiImage2DArrayBool & ima, bicotiImage2DArrayBool & struct_element )
{
  unsigned struct_element_size = struct_element.GetImplementation()->GetX1Size();

  ima.BuildNeighbourFilter();
  ima.GetNeighbourFilter()->BuildLinearFilter(struct_element_size);
  
  //Carga el kernel
  for ( unsigned i=0; i<struct_element_size; i++ ){
    for ( unsigned j=0; j<struct_element_size; j++ ){
      if ( struct_element.GetImplementation()->GetPixel(i,j) )
	(*(ima.GetNeighbourFilter()->GetKernel()))(i,j)=1;
    }
  }

  //Diltatcion
  ima.GetNeighbourFilter()->Filter(); 
  ima.LoadNeighbourFilterResult();
  ima.DestroyNeighbourFilter();
}

//-----------------------------------------------------------------
//
// Erosion
//  Erosion(A,B) es la erosion de la imagen A con el elemento estructurante B
//
// Obs:
//  Anda para kernels con simetra central.
//  Faltara tener en cuenta la reflexin del kernel para s tener:
//     Erosion(A,B) = Negation( Dilatacion( Negation(A),Reflexion(B) ) )
//
//-----------------------------------------------------------------

void Erosion( bicotiImage2DArrayBool & ima, bicotiImage2DArrayBool & struct_element )
{
  unsigned struct_element_size = struct_element.GetImplementation()->GetX1Size();

  ima.BuildNeighbourFilter();
  ima.GetNeighbourFilter()->BuildLinearFilter(struct_element_size);

  //Carga el kernel
  for ( unsigned i=0; i<struct_element_size; i++ ){
    for ( unsigned j=0; j<struct_element_size; j++ ){
      if ( struct_element.GetImplementation()->GetPixel(i,j) )
	(*(ima.GetNeighbourFilter()->GetKernel()))(i,j)=1;
    }
  }
  
  // Erosion
  Negation( ima );
  ima.GetNeighbourFilter()->Filter();
  ima.LoadNeighbourFilterResult();
  Negation( ima );
  ima.DestroyNeighbourFilter();
}


//-----------------------------------------------------------------
//
// Opening
//
// Obs:
//  Anda para kernels con simetra central.
//  Faltara tener en cuenta la reflexin del kernel al hacer la erosin para s tener:
//   Opening(A,B) = Dilatacion( Erosion(A,B),B )
//                  Dilatacion( Negation( Dilatacion( Negation(A),Reflexion(B) ) ), B )
//     ... y hay que cargar el kernel dos veces con B y la reflexion de B
//
//-----------------------------------------------------------------

void Opening(bicotiImage2DArrayBool & ima, bicotiImage2DArrayBool & struct_element)
{

  unsigned struct_element_size = struct_element.GetImplementation()->GetX1Size();

  ima.BuildNeighbourFilter();
  ima.GetNeighbourFilter()->BuildLinearFilter(struct_element_size);

  //Carga el kernel
  for ( unsigned i=0; i<struct_element_size; i++ ){
    for ( unsigned j=0; j<struct_element_size; j++ ){
      if ( struct_element.GetImplementation()->GetPixel(j,i) )
	(*(ima.GetNeighbourFilter()->GetKernel()))(j,i)=1;
    }
  }

  //Erosin
  Negation( ima );
  ima.GetNeighbourFilter()->Filter();
  ima.LoadNeighbourFilterResult();
  Negation( ima );

  //Dilatacin
  ima.GetNeighbourFilter()->Filter();
  ima.LoadNeighbourFilterResult();

  ima.DestroyNeighbourFilter();

}


//-----------------------------------------------------------------
//
// Closing
//
// Obs:
//  Anda para kernels con simetra central.
//  Faltara tener en cuenta la reflexin del kernel al hacer la erosin para s tener:
//   Closing(A,B) = Erosion( Dilatacion(A,B),B )
//                  Negation( Dilatacion( Negation( dialtacion(A,B) ),Reflexion(B) ) ) )
//     ... y hay que cargar el kernel dos veces B y la reflexion de B
//
//
//-----------------------------------------------------------------

void Closing(bicotiImage2DArrayBool & ima, bicotiImage2DArrayBool & struct_element)
{

  unsigned struct_element_size = struct_element.GetImplementation()->GetX1Size();
  bicotiImage2DArrayBool  aux_ima;

  aux_ima.GetImplementation()->CopyMeFrom(ima.GetImplementation());
  ima.BuildNeighbourFilter();
  ima.GetNeighbourFilter()->BuildLinearFilter(struct_element_size);

  //Carga el kernel
  for ( unsigned i=0; i<struct_element_size; i++ ){
    for ( unsigned j=0; j<struct_element_size; j++ ){
      if ( struct_element.GetImplementation()->GetPixel(j,i) )
	(*(ima.GetNeighbourFilter()->GetKernel()))(j,i)=1;
    }
  }

  //Dilatacin
  ima.GetNeighbourFilter()->Filter();
  ima.LoadNeighbourFilterResult();

  //Erosin
  Negation( ima );
  ima.GetNeighbourFilter()->Filter();
  ima.LoadNeighbourFilterResult();
  Negation( ima );

  ima.DestroyNeighbourFilter();

}

//-----------------------------------------------------------------
//
//  Hit-or-Miss de la imagen A es el conjunto de los pixeles en que B1 (el objeto) est contenida en A
//	y simultaneamente B2 (el fondo) est contenido en Negation(A) o sea en el fondo de la imagen.
//
//		HitMiss(A,B1,B2) = Erosion(A,B1) - Dilatation( A,Reflexion(B2) )
//						 = Erosion(A,B1)  Erosion( Negation(A),B2 )
//
//
// Obs: la substraccion de booleanos es el XOR. Se implementa con  (interseccion)
//
//-----------------------------------------------------------------

void HitMiss(bicotiImage2DArrayBool & ima, bicotiImage2DArrayBool & ima_b1, bicotiImage2DArrayBool & ima_b2)
{

  bicotiImage2DArrayBool  ima_copy;
  ima_copy.GetImplementation()->CopyMeFrom(ima.GetImplementation());

//  cout<<"Objeto"<<endl;
//  MostrarConsola( ima_b1 );

//  cout<<"Fondo"<<endl;
//  MostrarConsola( ima_b2 );

//  cout<<"Erosion de la imagen con el objeto"<<endl;
  Erosion(ima,ima_b1);
//  MostrarConsola( ima );

//  cout<<"Erosion de la imagen negada con el fondo"<<endl;
  Negation(ima_copy);
  Erosion(ima_copy, ima_b2 );
//  MostrarConsola( ima_copy );


  ima.BuildOperatorMultiple();
  ima.GetOperatorMultiple()->Append( ima_copy.GetImplementation() );

  ima.GetOperatorMultiple()->Product();
  ima.DestroyOperatorMultiple();

//  cout<<"HitMiss (dentro de Hitmiss)"<<endl;
//  MostrarConsola( ima );
  
}

//-----------------------------------------------------------------
//
//  ConvexHull(A) = Union  Di = D1 + D2 + D3 + D4
//
//     D1..D4 se hallan como sigue:
//
//              Para cada Bi = B(1), B(2), B(3), B(4) dados, se realiza la siguiente iteracin
//              X(i,k) = HitMiss( X(i,k-1),B(i) ) + A
//               con:
//                   k=1,2,3,...conv.
//                   X(i,0) = A
//              Di = X(i,conv) esto es k = conv si  X(i,k) = X(i,k-1) y paro la iteracin
//
//              Luego de obtener D1, D2, D3, D4. Se hace A = Unin (Di) i=1..4
//
//  Obs: solo se le pasa la imagen ya que los elementos esturcturantes estan dados
//       Bi tiene asociado objetoi y fondoi ( Bi = [ objetoi, fondoi ] )
//
//  Descripcin de Variables:
//         - ima es A: imagen original. Construyo un OperatorMultiple para hacer la unin final de los Di.
//                   (Nota que haga la unin incluyendo a ima es lo mismo ya que Di ya incluye la unin de A.
//         - ima_X es X(i,k): es la imagen sobre la cual se itera hasta converger en Di
//         - ima_X_pre es X(i,k): memoriza ima_X antes de cada "HitMiss" para evaluar si convergi.
//         - ima_original es una copia de la imagen inicial A, para hacer el "or" despus de cada iteracin
//
//-----------------------------------------------------------------


//     Atencin cambia el algoritmo, no se hace la unin con A sino con X(i,k-1)!!!!!!!!!!!!!!!!


void ConvexHull (bicotiImage2DArrayBool & ima)
{

  unsigned count = 0; //cuenta la cantidad de iteraciones
  unsigned kernel_size = 3;
  unsigned num_bi = 3; //cantidad de Bi
  bicotiImage2DArrayBool object[num_bi];
  bicotiImage2DArrayBool background[num_bi];
  bicotiImage2DArrayBool ima_X;
  bicotiImage2DArrayBool ima_X_pre;
  bicotiImage2DArrayBool ima_original;

//Asingacin de  B1
// [ OXX ]
// [ O X ]
// [ OXX ]

  object[0].BuildImplementation(kernel_size,kernel_size);

  object[0].GetImplementation()->SetPixel(0,0,true);  
  object[0].GetImplementation()->SetPixel(0,1,true);  
  object[0].GetImplementation()->SetPixel(0,2,true);  

  object[0].GetImplementation()->SetPixel(1,0,false);
  object[0].GetImplementation()->SetPixel(1,1,false);  
  object[0].GetImplementation()->SetPixel(1,2,false);  

  object[0].GetImplementation()->SetPixel(2,0,false);
  object[0].GetImplementation()->SetPixel(2,1,false);
  object[0].GetImplementation()->SetPixel(2,2,false);  

  background[0].BuildImplementation(kernel_size,kernel_size);

  background[0].GetImplementation()->SetPixel(0,0,false);
  background[0].GetImplementation()->SetPixel(0,1,false);
  background[0].GetImplementation()->SetPixel(0,2,false);

  background[0].GetImplementation()->SetPixel(1,0,false);
  background[0].GetImplementation()->SetPixel(1,1,true);
  background[0].GetImplementation()->SetPixel(1,2,false);

  background[0].GetImplementation()->SetPixel(2,0,false);
  background[0].GetImplementation()->SetPixel(2,1,false);
  background[0].GetImplementation()->SetPixel(2,2,false);

//Asignacin de B2
// [ OOO ]
// [ X X ]
// [ XXX ]

  object[1].BuildImplementation(kernel_size,kernel_size);

  object[1].GetImplementation()->SetPixel(0,0,true);  
  object[1].GetImplementation()->SetPixel(0,1,false);  
  object[1].GetImplementation()->SetPixel(0,2,false);  

  object[1].GetImplementation()->SetPixel(1,0,true);
  object[1].GetImplementation()->SetPixel(1,1,false);  
  object[1].GetImplementation()->SetPixel(1,2,false);  

  object[1].GetImplementation()->SetPixel(2,0,true);
  object[1].GetImplementation()->SetPixel(2,1,false);
  object[1].GetImplementation()->SetPixel(2,2,false);  

  background[1].BuildImplementation(kernel_size,kernel_size);

  background[1].GetImplementation()->SetPixel(0,0,false);
  background[1].GetImplementation()->SetPixel(0,1,false);
  background[1].GetImplementation()->SetPixel(0,2,false);

  background[1].GetImplementation()->SetPixel(1,0,false);
  background[1].GetImplementation()->SetPixel(1,1,true);
  background[1].GetImplementation()->SetPixel(1,2,false);

  background[1].GetImplementation()->SetPixel(2,0,false);
  background[1].GetImplementation()->SetPixel(2,1,false);
  background[1].GetImplementation()->SetPixel(2,2,false);


// Comienzo del algoritmo

  ima_original.GetImplementation()->CopyMeFrom(ima.GetImplementation());

  ima.BuildOperatorMultiple();


  for (unsigned i = 0; i<2; i++){
    // X(i,0) = A
    ima_X.GetImplementation()->CopyMeFrom(ima.GetImplementation());
  
    // X(i,k) = HitMiss( X(i,k-1),B(i) ) + A   Rec: HitMiss es destructivo, para A uso ima_original
    do{ 
      ima_X_pre.GetImplementation()->CopyMeFrom(ima_X.GetImplementation( ));//memorizo ima_X
      cout<<"Imagen antes del Hitmiss"<<endl;
      MostrarConsola( ima_X_pre );
      HitMiss(ima_X,object[i],background[i]);
      cout<<"Imagen despues del Hitmiss"<<endl;
      MostrarConsola( ima_X );    
      ima_X.BuildOperatorMultiple();
      ima_X.GetOperatorMultiple()->Append(ima_X_pre.GetImplementation() );//el resultado de HitMiss unin A
      ima_X.GetOperatorMultiple()->Addition();
      ima_X.DestroyOperatorMultiple();
      cout<<"Resultado Hitmiss union la imagen"<<endl;
      MostrarConsola(ima_X);
      count++;
    }while (!(Equals(ima_X,ima_X_pre)));

    cout<<"count = "<<count<<endl;
    ima.GetOperatorMultiple()->Append( ima_X.GetImplementation() );
  }


//Union final de los D1..D4

  ima.GetOperatorMultiple()->Addition();
  MostrarConsola(ima);
  ima.DestroyOperatorMultiple();

// ATencion no debera liberar la memoria de los auxiliares?
}

//-----------------------------------------------------------------
//
//  Thining basico
//		Thining(A) = A - HitMiss( A,B1,B2 )
//                         = A  Negation ( HitMiss( A,B1,B2 ) )
//
// Obs: Como la substraccion de booleanos es el XOR, no podemos implementar este algorimo con la primera definicin
//    . Se implementa con la segunda definicin "" (interseccion)
//
//-----------------------------------------------------------------

void ThiningBasic (bicotiImage2DArrayBool & ima, bicotiImage2DArrayBool & ima_b1, bicotiImage2DArrayBool & ima_b2)
{

  bicotiImage2DArrayBool  ima_copy;
  ima_copy.GetImplementation()->CopyMeFrom(ima.GetImplementation());

  HitMiss( ima_copy,ima_b1,ima_b2);
  Negation(ima_copy);

  ima.BuildOperatorMultiple();
  ima.GetOperatorMultiple()->Append( ima_copy.GetImplementation() );

  ima.GetOperatorMultiple()->Product();
  ima.DestroyOperatorMultiple();  

}

//-----------------------------------------------------------------
//
//  Thining con una secuencia de elementos estructurantes  B1, B2,...B8. (Bi define object, Bio y background, Bib)
//    Definicion 
//		Thining(A) = A  ( HitMiss( A,B1(1),B2(2) ) ).( HitMiss( A,B1(1),B2(2) ) ) ......hasta que converja
//
//  Obs: solo se le pasa la imagen ya que los elementos esturcturantes estan dados
//
//  1.- Leo imagen -> ima
//  2.- Copio:  ima -> ima_auxiliar
//  3.- Trabajo sobre ima_auxiliar (le hago HitMiss con el object y background correspondiente)
//  4.- Hago ima AND ima_auxiliar y el resultado parcial queda en ima
//  5.- Copio el resultado parcial ima en ima_auxiliar y vuelvo a repetir el paso 3.
//
//-----------------------------------------------------------------

void Thining (bicotiImage2DArrayBool & ima)
{

  unsigned kernel_size = 3;
  bicotiImage2DArrayBool object(kernel_size,kernel_size), background(kernel_size,kernel_size);

  bicotiImage2DArrayBool  ima_auxiliar;

//    B1
// [     ]
// [ XOX ]
// [ OOO ]

//Cargo object B1

  object.GetImplementation()->SetPixel(0,0,false);  
  object.GetImplementation()->SetPixel(0,1,false);  
  object.GetImplementation()->SetPixel(0,2,true);  

  object.GetImplementation()->SetPixel(1,0,false);
  object.GetImplementation()->SetPixel(1,1,true);  
  object.GetImplementation()->SetPixel(1,2,true);  

  object.GetImplementation()->SetPixel(2,0,false);
  object.GetImplementation()->SetPixel(2,1,false);
  object.GetImplementation()->SetPixel(2,2,true);  

//Cargo background B1
  background.GetImplementation()->SetPixel(0,0,true);
  background.GetImplementation()->SetPixel(0,1,false);
  background.GetImplementation()->SetPixel(0,2,false);

  background.GetImplementation()->SetPixel(1,0,true);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,false);

  background.GetImplementation()->SetPixel(2,0,true);
  background.GetImplementation()->SetPixel(2,1,false);
  background.GetImplementation()->SetPixel(2,2,false);

  cout<<"B1"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

  ima_auxiliar.GetImplementation()->CopyMeFrom(ima.GetImplementation());
  HitMiss(ima_auxiliar,object,background);
  Negation(ima_auxiliar);

  ima.BuildOperatorMultiple();
  ima.GetOperatorMultiple()->Append( ima_auxiliar.GetImplementation() );
  ima.GetOperatorMultiple()->Product();
  

//    B2
// [ X   ]
// [ OO  ]
// [ OOX ]

//Cargo object B2
  object.GetImplementation()->SetPixel(0,0,false);  
  object.GetImplementation()->SetPixel(0,1,true);  
  object.GetImplementation()->SetPixel(0,2,true);  

  object.GetImplementation()->SetPixel(1,0,false);  
  object.GetImplementation()->SetPixel(1,1,true);  
  object.GetImplementation()->SetPixel(1,2,true);  

  object.GetImplementation()->SetPixel(2,0,false);  
  object.GetImplementation()->SetPixel(2,1,false);  
  object.GetImplementation()->SetPixel(2,2,false);  

//Cargo background B2
  background.GetImplementation()->SetPixel(0,0,false);
  background.GetImplementation()->SetPixel(0,1,false);
  background.GetImplementation()->SetPixel(0,2,false);

  background.GetImplementation()->SetPixel(1,0,true);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,false);

  background.GetImplementation()->SetPixel(2,0,true);
  background.GetImplementation()->SetPixel(2,1,true);
  background.GetImplementation()->SetPixel(2,2,false);
  MostrarConsola(background);

  cout<<"B2"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

//  HitMiss(ima,object,background);


//    B3
// [ OX  ]
// [ OO  ]
// [ OX  ]

//Cargo object B3
  object.GetImplementation()->SetPixel(0,0,true);
  object.GetImplementation()->SetPixel(0,1,true);
  object.GetImplementation()->SetPixel(0,2,true);

  object.GetImplementation()->SetPixel(1,0,false);
  object.GetImplementation()->SetPixel(1,1,true);
  object.GetImplementation()->SetPixel(1,2,false);

  object.GetImplementation()->SetPixel(2,0,false);
  object.GetImplementation()->SetPixel(2,1,false);
  object.GetImplementation()->SetPixel(2,2,false);

//Cargo background B3
  background.GetImplementation()->SetPixel(0,0,false);
  background.GetImplementation()->SetPixel(0,1,false);
  background.GetImplementation()->SetPixel(0,2,false);

  background.GetImplementation()->SetPixel(1,0,false);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,false);

  background.GetImplementation()->SetPixel(2,0,true);
  background.GetImplementation()->SetPixel(2,1,true);
  background.GetImplementation()->SetPixel(2,2,true);

  cout<<"B3"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

//HitMiss(ima,object,background);


//    B4
// [ OOX ]
// [ OO  ]
// [ X   ]

//Cargo object B4
  object.GetImplementation()->SetPixel(0,0,true);
  object.GetImplementation()->SetPixel(0,1,true);
  object.GetImplementation()->SetPixel(0,2,false);

  object.GetImplementation()->SetPixel(1,0,true);
  object.GetImplementation()->SetPixel(1,1,true);
  object.GetImplementation()->SetPixel(1,2,false);

  object.GetImplementation()->SetPixel(2,0,false);
  object.GetImplementation()->SetPixel(2,1,false);
  object.GetImplementation()->SetPixel(2,2,false);

//Cargo background B4
  background.GetImplementation()->SetPixel(0,0,false);
  background.GetImplementation()->SetPixel(0,1,false);
  background.GetImplementation()->SetPixel(0,2,false);

  background.GetImplementation()->SetPixel(1,0,false);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,true);

  background.GetImplementation()->SetPixel(2,0,false);
  background.GetImplementation()->SetPixel(2,1,true);
  background.GetImplementation()->SetPixel(2,2,true);

  cout<<"B4"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

//HitMiss(ima,object,background);

//    B5
// [ OOO ]
// [ XOX ]
// [     ]

//Cargo object B5
  object.GetImplementation()->SetPixel(0,0,true);
  object.GetImplementation()->SetPixel(0,1,false);
  object.GetImplementation()->SetPixel(0,2,false);

  object.GetImplementation()->SetPixel(1,0,true);
  object.GetImplementation()->SetPixel(1,1,true);
  object.GetImplementation()->SetPixel(1,2,false);

  object.GetImplementation()->SetPixel(2,0,true);
  object.GetImplementation()->SetPixel(2,1,false);
  object.GetImplementation()->SetPixel(2,2,false);

//Cargo background B5
  background.GetImplementation()->SetPixel(0,0,false);
  background.GetImplementation()->SetPixel(0,1,false);
  background.GetImplementation()->SetPixel(0,2,true);

  background.GetImplementation()->SetPixel(1,0,false);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,true);

  background.GetImplementation()->SetPixel(2,0,false);
  background.GetImplementation()->SetPixel(2,1,false);
  background.GetImplementation()->SetPixel(2,2,true);

  cout<<"B5"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

//HitMiss(ima,object,background);

//    B6
// [ XOO ]
// [  OO ]
// [   X ]

//Cargo object B6
  object.GetImplementation()->SetPixel(0,0,false);
  object.GetImplementation()->SetPixel(0,1,false);
  object.GetImplementation()->SetPixel(0,2,false);

  object.GetImplementation()->SetPixel(1,0,true);
  object.GetImplementation()->SetPixel(1,1,true);
  object.GetImplementation()->SetPixel(1,2,false);

  object.GetImplementation()->SetPixel(2,0,true);
  object.GetImplementation()->SetPixel(2,1,true);
  object.GetImplementation()->SetPixel(2,2,false);

//Cargo background B6
  background.GetImplementation()->SetPixel(0,0,false);
  background.GetImplementation()->SetPixel(0,1,true);
  background.GetImplementation()->SetPixel(0,2,true);

  background.GetImplementation()->SetPixel(1,0,false);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,true);

  background.GetImplementation()->SetPixel(2,0,false);
  background.GetImplementation()->SetPixel(2,1,false);
  background.GetImplementation()->SetPixel(2,2,false);

  cout<<"B6"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

//HitMiss(ima,object,background);

//    B7
// [ XOO ]
// [  OO ]
// [   X ]

//Cargo object B7
  object.GetImplementation()->SetPixel(0,0,false);
  object.GetImplementation()->SetPixel(0,1,false);
  object.GetImplementation()->SetPixel(0,2,false);

  object.GetImplementation()->SetPixel(1,0,false);
  object.GetImplementation()->SetPixel(1,1,true);
  object.GetImplementation()->SetPixel(1,2,false);

  object.GetImplementation()->SetPixel(2,0,true);
  object.GetImplementation()->SetPixel(2,1,true);
  object.GetImplementation()->SetPixel(2,2,true);

//Cargo background B7
  background.GetImplementation()->SetPixel(0,0,true);
  background.GetImplementation()->SetPixel(0,1,true);
  background.GetImplementation()->SetPixel(0,2,true);

  background.GetImplementation()->SetPixel(1,0,false);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,false);

  background.GetImplementation()->SetPixel(2,0,false);
  background.GetImplementation()->SetPixel(2,1,false);
  background.GetImplementation()->SetPixel(2,2,false);

  cout<<"B7"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

//  HitMiss(ima,object,background);

//    B8
// [   X ]
// [  OO ]
// [ XOO ]

//Cargo object B8
  object.GetImplementation()->SetPixel(0,0,false);
  object.GetImplementation()->SetPixel(0,1,false);
  object.GetImplementation()->SetPixel(0,2,false);

  object.GetImplementation()->SetPixel(1,0,false);
  object.GetImplementation()->SetPixel(1,1,true);
  object.GetImplementation()->SetPixel(1,2,true);

  object.GetImplementation()->SetPixel(2,0,false);
  object.GetImplementation()->SetPixel(2,1,true);
  object.GetImplementation()->SetPixel(2,2,true);

//Cargo background B8
  background.GetImplementation()->SetPixel(0,0,true);
  background.GetImplementation()->SetPixel(0,1,true);
  background.GetImplementation()->SetPixel(0,2,false);

  background.GetImplementation()->SetPixel(1,0,true);
  background.GetImplementation()->SetPixel(1,1,false);
  background.GetImplementation()->SetPixel(1,2,false);

  background.GetImplementation()->SetPixel(2,0,false);
  background.GetImplementation()->SetPixel(2,1,false);
  background.GetImplementation()->SetPixel(2,2,false);

  cout<<"B8"<<endl;
  MostrarConsola(object);
  MostrarConsola(background);

//  HitMiss(ima,object,background);


//  ima.DestroyOperatorMultiple();

}

//****************************************************************

void main()
{

  bicotiImage2DArrayBool struct_element(21,21);
  bicotiImage2DArrayBool image,cimage,ima_hitmiss,objeto,fondo;
  bicotiImage2DArrayBool ima_thin;
  bicotiImage2DArrayBool ima_convhull;
  bool b;


//Demo:  Dilatation, Erosion, Opening, Closing.
/*
  LeerImagen( cimage.GetImplementation(), "imagen.bmp" );
  cout<<"Imagen original"<<endl;
  Mostrar( cimage );

  cout<<"Imagen reflejada por el centro"<<endl;
  image.GetImplementation()->CopyMeFrom(cimage.GetImplementation());
  Reflexion(image);
  Mostrar( image );


  cout<<"Elemento estructurante"<<endl;
  Circulo( struct_element );
  Mostrar( struct_element );

  cout<<"Dilatacin"<<endl;
  image.GetImplementation()->CopyMeFrom(cimage.GetImplementation());
  Dilatation( image,struct_element );
  Mostrar( image );

  cout<<"Erosion"<<endl;
  image.GetImplementation()->CopyMeFrom(cimage.GetImplementation());
  Erosion( image,struct_element );
  Mostrar( image );

  cout<<"Opening"<<endl;
  image.GetImplementation()->CopyMeFrom(cimage.GetImplementation());
  Opening( image,struct_element );
  Mostrar( image );

  cout<<"Closing"<<endl;
  image.GetImplementation()->CopyMeFrom(cimage.GetImplementation());
  Closing( image,struct_element );
  Mostrar( image );
*/

//Demo: Hit-Miss
/*  cout<<"Hit-Miss"<<endl;
  LeerImagen( ima_hitmiss.GetImplementation(), "hitmiss.bmp" );  
  MostrarConsola( ima_hitmiss );
  LeerImagen( objeto.GetImplementation(), "b1.bmp" );  
  LeerImagen( fondo.GetImplementation(), "b2.bmp" );  
  HitMiss( ima_hitmiss,objeto,fondo );
*/

//Demo ConvexHull

//prueba operator multi

  LeerImagen( objeto.GetImplementation(), "b1.bmp" );  
  MostrarConsola(objeto);
  LeerImagen( fondo.GetImplementation(), "b2.bmp" );  
  MostrarConsola(fondo);
  objeto.BuildOperatorMultiple();
  objeto.GetOperatorMultiple()->Append(fondo.GetImplementation());
  objeto.GetOperatorMultiple()->Addition();
  MostrarConsola(objeto);


  LeerImagen( ima_convhull.GetImplementation(), "ima_convhull.bmp" );
  MostrarConsola(ima_convhull);
  cout<<"Comienzo convexhull"<<endl;
  ConvexHull(ima_convhull);
  MostrarConsola(ima_convhull);


//Prueba: Equals
/*  b = Equals(ima_hitmiss,ima_hitmiss);
  cout<<"hitmiss igual a si misma ? "<<b<<endl;
  b = Equals(ima_hitmiss,objeto);
  cout<<"hitmiss igual a objeto ? "<<b<<endl;
  b = Equals(objeto,fondo);
  cout<<"objeto igual a fondo ? "<<endl;
*/
//Demo: Thining
/*  LeerImagen( ima_thin.GetImplementation(), "ima_thin.bmp" );
  cout<<"Imagen ima_thin"<<endl;
  MostrarConsola( ima_thin );
  Thining(ima_thin);
*/
};//end main








/*
  bool a,b,c;
  a = true;
  b = false;
  cout<<"a = true"<<endl;
  cout<<"b = false"<<endl;

  c = a-a;
  cout<<"a-a="<<c<<endl;
  c = a-b;
  cout<<"a-b="<<c<<endl;
  c = b-a;
  cout<<"b-a="<<c<<endl;
  c = b-b;
  cout<<"b-b="<<c<<endl;
*/


