/*
  Este ejemplo muestra como usar un filtro de vecindad lineal para
  una imagen en blanco y negro
*/

#define IMAGE_2D_ARRAY_FLOAT
#include "../mostrar_lib.hpp"  
 
typedef bicotiImage2DArrayFloat ImaT;
          
void main()  
{ 
  unsigned frame_size = 3;

  ImaT ima; 

  LeerImagen( ima.GetImplementation(), "../Pictures/foto.bmp" ); 
  MostrarImagen( ima.GetImplementation() ); 

  // Creo la Fachada del filtro
  ima.BuildNeighbourFilter();
  
  // Declaro un puntero a la fachada
  // esto es solo por comodidad, para no escribir ima.GetNeighbourFilter()
  ImaT::NeighbourFilter * ptr_filt;
  ptr_filt = ima.GetNeighbourFilter();

  // Creo un filtro lineal
  ptr_filt->BuildLinearFilter( frame_size );

  // Le seteo valores al Kernel
  (*(ptr_filt->GetKernel()))(0,1)=-0.5;
  (*(ptr_filt->GetKernel()))(2,1)=0.5;

  //
  //   Kernel = [  0  0  0
  //             -0.5 0 0.5
  //               0  0  0  ]                            
  //

  // Elijo estrategia de borde
  ptr_filt->UseExtrapolationStrategyEqual();

  // Filtro
  ptr_filt->Filter();
  
  // Cargo el resultado
  ima.LoadNeighbourFilterResult();
  
  // Borro la fachada de filtro
  ima.DestroyNeighbourFilter();
  // Obs : NO borrar ptr_filt, porque la funcin Destroy lo hizo

  MostrarImagen( ima.GetImplementation() ); 

  // Voy a calcular el valor absoluto de la imagen, para eso uso el 
  // OperatorUnary asociado a la imagen

  ima.BuildOperatorUnary();
  ima.GetOperatorUnary()->AbsoluteValue();
  ima.DestroyOperatorUnary();

  MostrarImagen( ima.GetImplementation() );   
};
