/*
  Este ejemplo muestra como usar un filtro de vecindad no lineal para
  una imagen a colores
*/

#define IMAGE_2D_ARRAY_RGB_FLOAT
#include "../mostrar_lib.hpp"  
 
typedef bicotiImage2DArrayRGBFloat ImaT;
typedef bicotiImage2DArrayRGBFloat::Pixel PixT;
          
void main()  
{ 
  unsigned frame_size = 5;

  ImaT ima; 

  LeerImagenColor( ima.GetImplementation(), "../Pictures/foto.bmp" ); 
  MostrarImagenColor( ima.GetImplementation() ); 

  // Creo la Fachada del filtro
  ima.BuildNeighbourFilter();
  
  // Declaro un puntero a la fachada
  // esto es solo por comodidad, para no escribir ima.GetNeighbourFilter()
  ImaT::NeighbourFilter * ptr_filt;
  ptr_filt = ima.GetNeighbourFilter();

  // Creo un filtro lineal
  ptr_filt->BuildMaximumFilter( frame_size );

  // Elijo estrategia de borde
  ptr_filt->UseExtrapolationStrategyEqual();

  // Filtro
  ptr_filt->Filter();
  
  // Cargo el resultado
  ima.LoadNeighbourFilterResult();
  
  // Borro la fachada de filtro
  ima.DestroyNeighbourFilter();
  // Obs : NO borrar ptr_filt, porque la funcin Destroy lo hizo

  MostrarImagenColor( ima.GetImplementation() ); 
};
