// Este ejemplo muestra como usar la fachada de operator unary y multiple

#define IMAGE_2D_ARRAY_FLOAT
#include "../mostrar_lib.hpp"  
 
typedef bicotiImage2DArrayFloat ImaT;
          
void main()  
{ 
  unsigned frame_size = 3;

  ImaT ima1; 

  LeerImagen( ima1.GetImplementation(), "../Pictures/foto.bmp" ); 
  MostrarImagen( ima1.GetImplementation() ); 

  // Creo la fachada de Operator Unary
  ima1.BuildOperatorUnary();
  
  // Declaro un puntero a la fachada
  // esto es solo por comodidad, para no escribir ima.GetOperatorUnary()
  ImaT::OperatorUnary * ptr_oper_un;
  ptr_oper_un = ima1.GetOperatorUnary();

  // Sumo 10 a los pixeles de la imagen
  // Se puede apreciar la saturacion en el resultado
  ptr_oper_un->Addition( 10 );
  MostrarImagen( ima1.GetImplementation() );

  // Muiltiplico la imagen por 3
  // Se puede apreciar la saturacion en el resultado
  ptr_oper_un->Product( 3 );
  MostrarImagen( ima1.GetImplementation() );

  // Hago logaritmo de la imagen
  ptr_oper_un->Logarithm();
  ptr_oper_un->Product( 35 );
  MostrarImagen( ima1.GetImplementation() );

  // Borro la fachada de filtro
  ima1.DestroyOperatorUnary();
  // Obs : NO borrar ptr_oper_un, porque la funcin Destroy lo hizo

  ImaT ima2;
  LeerImagen( ima2.GetImplementation(), "../Pictures/foto.bmp" ); 
  // Tambien es posible manejar las fachadas internamente
  ima2.BuildOperatorMultiple();

  // Anexo la imagen 1 a la 2
  ima2.GetOperatorMultiple()->Append( ima1.GetImplementation() );

  // Las multiplico entre si
  ima2.GetOperatorMultiple()->Product();
  
  //No es indispensable eliminar las fachadas explicitamente.
  ima2.BuildOperatorUnary();
  ima2.GetOperatorUnary()->Product( 1.0/255 );

  MostrarImagen( ima2.GetImplementation() );  
};
