// Este ejemplo muestra como hallar la transformada de Fourier de una imagen

#define IMAGE_2D_ARRAY_FLOAT
#include "../mostrar_lib.hpp" 
 
 
typedef float PixT; 
typedef bicotiPixelComplex< float > ComT; 

typedef bicotiImage2DArrayFloat ImaT; 

typedef bicotiImageImplementation2DArray< ComT > ImpComT;
  
 
void main() 
{ 
  const unsigned filas = 256;
  const unsigned columnas = 256;
  const unsigned ancho = 16;

  unsigned i, j; 
  unsigned radio;
  float angulo,paso;
  ComT zero(0, 0); 
 
  ImaT imagen(columnas,filas); 

  paso = PI/200;

  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (PI/2) ; angulo += paso ) 
      {  j = (unsigned)( radio*sin(angulo) );
      i = (unsigned)( radio*cos(angulo) );				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}; 

  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (PI/2) ; angulo += paso ) 
      {  j = (unsigned)((columnas-1)-radio*sin(angulo));
      i = (unsigned)(radio*cos(angulo));				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}; 

  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (PI/2) ; angulo += paso ) 
      {  j = (unsigned)(radio*sin(angulo));
      i = (unsigned)((filas-1)-radio*cos(angulo));				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}; 

  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (PI/2) ; angulo += paso ) 
      {  j = (unsigned)(columnas-1-radio*sin(angulo));
      i = (unsigned)(filas-1-radio*cos(angulo));				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}; 

  ImpComT * ptr_ima_dest; 
  ptr_ima_dest = new ImpComT( zero , 1, 1 ); 
 
  MostrarImagen( imagen.GetImplementation() ); 
   
  cout << "transformando" << endl << endl; 
  bicotiTransformationFourier2D< PixT > trans( ptr_ima_dest, imagen.GetImplementation() ); 
  trans.Transform(); 
 
  cout << "Copiando resultado" << endl; 
  for( j = 0; j < filas; j++ ) 
    for( i = 0; i < columnas; i++ ) 
      imagen.GetImplementation()->SetPixel( i, j, (ptr_ima_dest->GetPixel(i, j)).Module() ); 

  // Para que sea visualizable
  imagen.BuildOperatorUnary(); 
  imagen.GetOperatorUnary()->Addition( 1 );  
  imagen.GetOperatorUnary()->Logarithm(); 
  imagen.BuildProperty(); 
  imagen.GetProperty()->BuildStatistical(); 
  float max = (imagen.GetProperty()->GetStatistical())->MaximumValue(); 
  max = 255.0 / max; 
  imagen.GetOperatorUnary()->Product( max ); 
  imagen.DestroyProperty(); 
  imagen.DestroyOperatorUnary(); 
   
  MostrarImagen( imagen.GetImplementation() ); 

  delete ptr_ima_dest; 
}  
