// Este ejemplo muestra como hallar la transformada de Fourier de una imagen

#define IMAGE_2D_ARRAY_FLOAT
#include "../mostrar_lib.hpp" 
 
 
typedef float PixT; 
typedef bicotiPixelComplex< PixT > ComT; 

typedef bicotiImage2DArrayFloat ImaT;
typedef bicotiImageImplementation2DArray< ComT > ImpComT;
  
 
void main() 
{ 
  ComT zero(0, 0); 
 
  ImaT imagen;
  LeerImagen( imagen.GetImplementation(), "../Pictures/foto.bmp" );
  MostrarImagen( imagen.GetImplementation() );
  
  ImpComT * ptr_trans = new ImpComT( zero, 1, 1 );

  bicotiTransformationFourier2D< PixT > fourier;
  fourier.SetImplementations( ptr_trans, imagen.GetImplementation() );

  bicotiImageExtrapolationStrategy< PixT > * ptr_dir_ext;
  ptr_dir_ext = new bicotiImageExtrapolationStrategy2DConstant< PixT >( 0 );
  bicotiImageExtrapolationStrategy< ComT > * ptr_inv_ext;
  ptr_inv_ext = new bicotiImageExtrapolationStrategy2DConstant< ComT >( zero );
  fourier.SetDirectExtrapolationStrategy( ptr_dir_ext );
  fourier.SetInverseExtrapolationStrategy( ptr_inv_ext );

  cout << "Transformando" << endl;
  fourier.Transform();
  cout << "Transformacion terminada" << endl;
  
  ImaT modulo;
  modulo.SetImplementation( (ImaT::Implementation *)(fourier.GetTransformedModule()) );
  
  cout << "Adaptando transformada a visualizacion" << endl;
  modulo.BuildOperatorUnary();
  modulo.GetOperatorUnary()->Addition( 1 );
  modulo.GetOperatorUnary()->Logarithm();
  modulo.BuildProperty();
  modulo.GetProperty()->BuildStatistical();
  PixT maximo = modulo.GetProperty()->GetStatistical()->MaximumValue();
  modulo.DestroyProperty();
  modulo.GetOperatorUnary()->Product( 255 / maximo );
  modulo.DestroyOperatorUnary();
  MostrarImagen( modulo.GetImplementation() );

  cout << "Antitransformando" << endl;
  fourier.Antitransform();
  cout << "Antitransformacion terminada" << endl;
  MostrarImagen( imagen.GetImplementation() );
    
  delete ptr_dir_ext;
  delete ptr_inv_ext;
  delete ptr_trans;
};
