#include <actor_image_2D_rgb_char_qt.hpp>
#include <actor.hpp>

bicotiActorImage2DRGBCharQT :: HomologousFactory factory;

class MyPanel : public bicotiActorGraphic2DPanel, public bicotiListenerPushButton, public bicotiListenerGeometry, public bicotiListenerMouse, public bicotiListenerMouseMotion, public bicotiListenerTimer
{
private:
  bicotiActorImage2DRGBCharQT :: EventLoopManager * ptr_el;

  bicotiActorGraphic2DPushButton * ptr_boton_1;
  bicotiActorGraphic2DPushButton * ptr_boton_2;
  bicotiActorGraphic2DPushButton * ptr_boton_3;
  bicotiActorGraphic2DPushButton * ptr_boton_4;
  bicotiActorGraphic2DPushButton * ptr_boton_5;

  bicotiActorTimer * ptr_timer;

  bicotiActorGraphic2D * ptr_ima1;
  bicotiActorGraphic2D * ptr_ima2;

  char nom1[10], nom2[10], nom3[10], nom4[10], nom5[10];
  char txt1[100], txt2[100], txt3[100], txt4[100], txt5[100];

public:
  MyPanel( bicotiActorImage2DRGBCharQT :: EventLoopManager * ptr_0, bicotiActorGraphic2D * ptr_1, bicotiActorGraphic2D * ptr_2, char * nombre = NULL ) : bicotiActorGraphic2DPanel( nombre )
    {
      ptr_el = ptr_0;

      ptr_ima1 = ptr_1;
      ptr_ima1->AddListenerGeometry( this );
      //      ptr_ima1->AddListenerMouse( this );
      ptr_ima1->AddListenerMouseMotion( this );

      ptr_ima2 = ptr_2;
      ptr_ima2->AddListenerGeometry( this );
      ptr_ima2->AddListenerMouse( this );

      strcpy( nom1, "boton1" );
      strcpy( nom2, "boton2" );
      strcpy( nom3, "boton3" );
      strcpy( nom4, "boton4" );
      strcpy( nom5, "boton5" );
      
      strcpy( txt1, "Hide Imagen 1" );
      strcpy( txt2, "Hide Imagen 2" );
      strcpy( txt3, "Quit" );
      strcpy( txt4, "Show Imagen 1" );
      strcpy( txt5, "Show Imagen 2" );

      SetFixedSize( 200, 300 );

      ptr_timer = new bicotiActorTimer;
      ptr_timer->AddListenerTimer( this );
      ptr_timer->SetPeriod( 5000 );
      factory.CreateHomologous( ptr_timer );

      ptr_boton_1 = new bicotiActorGraphic2DPushButton( nom1 );
      SetChild( ptr_boton_1 );
      ptr_boton_1->SetPosition( 0, 0 );
      ptr_boton_1->SetSize( 100, 100 );
      ptr_boton_1->SetText( txt1 );
      ptr_boton_1->AddListenerPushButton( this );
      
      ptr_boton_2 = new bicotiActorGraphic2DPushButton( nom2 );
      SetChild( ptr_boton_2 );
      ptr_boton_2->SetPosition( 0, 100 );
      ptr_boton_2->SetSize( 100, 100 );
      ptr_boton_2->SetText( txt2 );
      ptr_boton_2->AddListenerPushButton( this );
      
      ptr_boton_3 = new bicotiActorGraphic2DPushButton( nom3 );
      SetChild( ptr_boton_3 );
      ptr_boton_3->SetPosition( 0, 200 );
      ptr_boton_3->SetSize( 200, 100 );
      ptr_boton_3->SetFont( bicotiFont( _times, 30, _bold ) );
      ptr_boton_3->SetText( txt3 );
      ptr_boton_3->AddListenerPushButton( this );

      ptr_boton_4 = new bicotiActorGraphic2DPushButton( nom4 );
      SetChild( ptr_boton_4 );
      ptr_boton_4->SetPosition( 100, 0 );
      ptr_boton_4->SetSize( 100, 100 );
      ptr_boton_4->SetText( txt4 );
      ptr_boton_4->AddListenerPushButton( this );

      ptr_boton_5 = new bicotiActorGraphic2DPushButton( nom5 );
      SetChild( ptr_boton_5 );
      ptr_boton_5->SetPosition( 100, 100 );
      ptr_boton_5->SetSize( 100, 100 );
      ptr_boton_5->SetText( txt5 );
      ptr_boton_5->AddListenerPushButton( this );
    }

  ~MyPanel()
    {}
  
  void PushButtonClicked( bicotiActor * ptr_boton )
    {
      if ( !strcmp( ptr_boton->GetActorDescriptor().GetActorName(), "boton1" ) )
	{cout << "Haciendo invisible la imagen 1" << endl;
	ptr_ima1->SetVisible( false );}
      else
	{if ( !strcmp( ptr_boton->GetActorDescriptor().GetActorName(), "boton2" ) )
	  {cout << "Haciendo invisible la imagen 2" << endl;
	  ptr_ima2->SetVisible( false );}
	else
	  {if ( !strcmp( ptr_boton->GetActorDescriptor().GetActorName(), "boton3" ) )
	    {cout << "Saliendo de la aplicacion" << endl;
	    ptr_el->Stop();
	    /*cout << "Haciendo ima2 hija de ima1" <<endl;
	      ptr_ima1->SetChild( ptr_ima2 );*/}
	  else
	    {if ( !strcmp( ptr_boton->GetActorDescriptor().GetActorName(), "boton4" ) )
	      {cout << "Haciendo visible la imagen 1" << endl;
	      ptr_ima1->SetVisible( true );}
	    else
	      {cout << "Haciendo visible la imagen 2" << endl;
	      ptr_ima2->SetVisible( true );}}}}
    }

  void ActorResized( bicotiActor * ptr_ima, const bicotiEventGeometry& evento )
    {
      cout << "Me redimensionaron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". Ancho = " << evento.GetX() << ", alto = " << evento.GetY() << endl;
    }

  void ActorMoved( bicotiActor * ptr_ima, const bicotiEventGeometry& evento )
    {
      cout << "Me movieron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }

  void MousePressed( bicotiActor * ptr_ima, const bicotiEventMouse& evento )
    {
      cout << "Me picaron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }

  void MouseReleased( bicotiActor * ptr_ima, const bicotiEventMouse& evento )
    {
      cout << "Me despicaron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }

  void MouseMoved( bicotiActor * ptr_ima, const bicotiEventMouseMotion& evento )
    {
      cout << "El mouse esta sobre el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << "en X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }

  void TimerTic( bicotiActor * ptr_ima )
    {
      cout << "TIC" << endl;
    }
};

void main( int argc, char **argv )  
{ 
  bicotiActorImage2DRGBCharQT imagen1( 1, 1, "ima1" );
  imagen1.BuildMapper();
  imagen1.GetMapper()->BuildDeviceFile( "../Pictures/heidi.jpg" );
  imagen1.GetMapper()->BuildMapperJPEGIJG();
  imagen1.GetMapper()->Read();
  imagen1.DestroyMapper();
  imagen1.GetActor()->SetSize( imagen1.GetImplementation()->GetX0Size(), imagen1.GetImplementation()->GetX1Size() );

  bicotiActorImage2DRGBCharQT imagen2( 1, 1, "ima2" );
  imagen2.BuildMapper();
  imagen2.GetMapper()->BuildDeviceFile( "../Pictures/presto.jpg" );
  imagen2.GetMapper()->BuildMapperJPEGIJG();
  imagen2.GetMapper()->Read();
  imagen2.DestroyMapper();
  imagen2.GetActor()->SetSize( imagen2.GetImplementation()->GetX0Size(), imagen2.GetImplementation()->GetX1Size() );
  
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );

  MyPanel panel( &event_loop, imagen1.GetActor(), imagen2.GetActor(), "panel" );

  factory.CreateHomologous( imagen1.GetActor() );
  imagen1.GetActor()->SetPosition( 1, 40 );

  factory.CreateHomologous( imagen2.GetActor() );
  imagen2.GetActor()->SetPosition( 500, 40 );

  factory.RecursiveCreateHomologous( &panel );
  panel.SetPosition( 300, 100 );
  
  event_loop.Start();
};

