#include <actor_graphic_menu_bar.hpp>
#include <actor_graphic_2D_panel.hpp>
#include <actor_graphic_2D_file_dialog.hpp>
#include <event_loop_manager_qt.hpp>
#include <pixel_converter_qt.hpp>


bicotiHomologousFactoryQT< unsigned char, bicotiPixelConverterChar2QRGB > factory;

class Listener : public bicotiListenerMenu, public bicotiListenerFileDialog
{
private:
  bicotiActorGraphic2DFileDialog fd;

public:
  Listener()
    {fd.SetSize( 600, 300 );
    //fd.SetMainActor( true );
    //fd.SetFilter( "Archivos C++ (*.cpp)" );
    fd.AddListenerFileDialog( this );}

  bicotiEventLoopManagerQT * ptr_app;
  
  void ItemSelected( bicotiActor * ptr_act, char * item )
    {if( !strcmp( item, "Quit" ) )
      ptr_app->Stop();

    if( !strcmp( item, "cd /" ) )
      fd.SetDirectory( "/" );

    if( !strcmp( item, "File" ) )
      {if( fd.GetHomologous() == NULL )
	factory.CreateHomologous( &fd );
      else
	fd.SetVisible( true );}}

  void FileDialogFileSelected( bicotiActor * ptr_actor, const char * file )
    {
      cout << "Se selecciono el archivo " << file << endl;
    }

  void FileDialogFileHighlighted( bicotiActor * ptr_actor, const char * file )
    {
      cout << "Se highlightteo el archivo " << file << endl;
    }

  void FileDialogDirectoryChanged( bicotiActor * ptr_actor, const char * dir )
    {
      cout << "Se cambio el directorio a " << dir << endl;
    }
};


void main( int argc, char ** argv )
{
  bicotiActorGraphic2DPanel panel;
  panel.SetPosition( 100, 100 );
  panel.SetSize( 750, 30 );
  panel.SetMainActor( true );
  panel.SetBackgroundColor( bicotiRGBTools :: CreateRGBA( 0, 128, 0 ) );

  bicotiEventLoopManagerQT event_loop( argc, argv );
  Listener list;
  list.ptr_app = &event_loop;

  bicotiActorGraphicMenuBar menu( "MenuBar" );
  menu.AddItem( "File" );
  menu.AddItem( "cd /" );
  menu.AddSeparator();
  menu.AddItem( "Quit" );
  menu.AddListenerMenu( &list, "File" );
  menu.AddListenerMenu( &list, "cd /" );
  menu.AddListenerMenu( &list, "Quit" );

  panel.SetChild( &menu );

  factory.RecursiveCreateHomologous( &panel );
  
  event_loop.Start();
}  
