#include <actor_image_2D_rgb_char_qt.hpp>
#include <actor.hpp> 
#include <pixel_rgb_tools.hpp> 
    

const int ancho_boton = 250;
const int alto_boton = 70;

        
class Listener : public bicotiListenerPushButton
{
private:
  bool voy;

  bicotiActorGraphic2DPanel * ptr_panel_rojo;
  bicotiActorImage2DRGBCharQT :: Actor * ptr_imagen;
  bicotiActorGraphic2DPanel * ptr_panel;
  bicotiActorGraphic2DPushButton * ptr_button;

public:
  Listener( bicotiActorGraphic2DPanel * ptr_pa1, bicotiActorImage2DRGBCharQT :: Actor * ptr_pa2, bicotiActorGraphic2DPanel * ptr_p, bicotiActorGraphic2DPushButton * ptr_b )
    {
      ptr_panel_rojo = ptr_pa1;
      ptr_imagen = ptr_pa2;
      ptr_panel = ptr_p;
      ptr_button = ptr_b;

      voy = true;
    }
  
  void PushButtonClicked( bicotiActor * ptr_actor )
    {
      if( !strcmp( ptr_actor->GetActorDescriptor().GetActorName(), "boton1" ) )
	{ptr_imagen->SetPosition( 100, 100 );
	ptr_panel_rojo->SetChild( ptr_imagen );}

      if( !strcmp( ptr_actor->GetActorDescriptor().GetActorName(), "boton2" ) )
	ptr_panel_rojo->RemoveChild( ptr_imagen );
      
      if( !strcmp( ptr_actor->GetActorDescriptor().GetActorName(), "boton3" ) )
	{ptr_panel_rojo->SetPosition( 100, 100 );
	ptr_imagen->SetChild( ptr_panel_rojo );}
      
      if( !strcmp( ptr_actor->GetActorDescriptor().GetActorName(), "boton4" ) )
	{ptr_imagen->RemoveChild( ptr_panel_rojo );
	ptr_panel_rojo->SetBackgroundColor( bicotiRGBTools :: CreateRGBA( 128, 0, 0 ) );}

      if( !strcmp( ptr_actor->GetActorDescriptor().GetActorName(), "boton5" ) )
	{if( voy )
	  {ptr_panel->RemoveChild( ptr_button );
	  voy = false;
	  ptr_button->SetText( "Me Vuelvo" );}
	else
	  {ptr_button->SetPosition( 0, 4 * alto_boton );
	  ptr_button->SetSize( ancho_boton, alto_boton );
	  ptr_panel->SetChild( ptr_button );
	  voy = true;
	  ptr_button->SetText( "Me Voy" );}}
    }
};


void main( int argc, char **argv )  
{  
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );
  
  // PANELES
  bicotiActorGraphic2DPanel panel_rojo( "panel_rojo" );
  bicotiActorImage2DRGBCharQT imagen( 0, 0, "imagen" );
  
  imagen.BuildMapper();
  imagen.GetMapper()->BuildDeviceFile( "../Pictures/heidi.jpg" );
  imagen.GetMapper()->BuildMapperJPEGIJG();
  imagen.GetMapper()->Read();
  imagen.GetActor()->SetSize( imagen.GetImplementation()->GetX0Size(), imagen.GetImplementation()->GetX1Size() );
  imagen.DestroyMapper();
  
  panel_rojo.SetBackgroundColor( bicotiRGBTools :: CreateRGBA( 128, 0, 0 ) );
  panel_rojo.SetSize( 200, 200 );
  
  // BOTONERA
  bicotiActorGraphic2DPushButton boton1( "boton1" );
  boton1.SetText( "panel_rojo->SetChild( imagen )" );
  boton1.SetSize( ancho_boton, alto_boton );  
  boton1.SetPosition( 0, 0 );

  bicotiActorGraphic2DPushButton boton2( "boton2" );
  boton2.SetText( "panel_rojo->RemoveChild( imagen )" );
  boton2.SetSize( ancho_boton, alto_boton );
  boton2.SetPosition( 0, alto_boton );

  bicotiActorGraphic2DPushButton boton3( "boton3" );
  boton3.SetText( "imagen->SetChild( panel_rojo )" );
  boton3.SetSize( ancho_boton, alto_boton );
  boton3.SetPosition( 0, 2 * alto_boton );

  bicotiActorGraphic2DPushButton boton4( "boton4" );
  boton4.SetText( "imagen->RemoveChild( panel_rojo )" );
  boton4.SetSize( ancho_boton, alto_boton );
  boton4.SetPosition( 0, 3 * alto_boton );

  bicotiActorGraphic2DPushButton boton5( "boton5" );
  boton5.SetText( "Me voy" );
  boton5.SetSize( ancho_boton, alto_boton );
  boton5.SetPosition( 0, 4 * alto_boton );
  
  bicotiActorGraphic2DPanel botonera( "botonera" );
  botonera.SetSize( ancho_boton, 5 * alto_boton );
  botonera.SetBackgroundColor( bicotiRGBTools :: CreateRGBA( 30, 180, 0 ) );  
  botonera.SetChild( &boton1 );
  botonera.SetChild( &boton2 );
  botonera.SetChild( &boton3 );
  botonera.SetChild( &boton4 );
  botonera.SetChild( &boton5 );

  Listener list( &panel_rojo, imagen.GetActor(), &botonera, &boton5 );

  boton1.AddListenerPushButton( &list );
  boton2.AddListenerPushButton( &list );
  boton3.AddListenerPushButton( &list );
  boton4.AddListenerPushButton( &list );
  boton5.AddListenerPushButton( &list );  


  // CONSTRUCCION
  botonera.SetMainActor( true );

  bicotiActorImage2DRGBCharQT :: HomologousFactory factory;

  factory.CreateHomologous( &panel_rojo );
  factory.CreateHomologous( imagen.GetActor() );
  factory.RecursiveCreateHomologous( &botonera );

  event_loop.Start();
};  

 
