#include "load_interface.hpp"


LoadInterface :: LoadInterface( CurrentImageType * ptr_image )
{
  ptr_local_image = ptr_image;

  ptr_field = new bicotiActorGraphic2DField;
  ptr_field->SetFixedSize( field_width, field_height );
  ptr_field->SetPosition( panel_border, panel_border );

  ptr_field->SetFrame( true );
  ptr_field->SetEchoMode( EchoOn );
  ptr_field->SetText( "archivo" ); 
  ptr_field->SelectAll();
  ptr_field->AddListenerField( this );

  ptr_panel = new bicotiActorGraphic2DPanel;
  ptr_panel->SetChild( ptr_field );  
  ptr_panel->SetFixedSize( field_width + 2 * panel_border, field_height + 2 * panel_border );
  ptr_panel->SetBackgroundColor( bicotiRGBTools :: CreateRGBA( 200, 200, 200 ) );
  ptr_panel->SetVisible( false );
  
  CurrentImageType :: HomologousFactory local_factory;
  local_factory.RecursiveCreateHomologous( ptr_panel );

  //  ptr_field->SetCursorPosition( 0 );
  ptr_panel->SetVisible( true );
  ptr_panel->SetPosition( 250, 250 );
}


LoadInterface :: ~LoadInterface()
{
  delete ptr_panel;
  delete ptr_field;
}


void LoadInterface :: FieldReturnPressed( bicotiActor * ptr_actor )
{
  ptr_panel->SetVisible( false );
  ptr_local_image->BuildMapper();
  ptr_local_image->GetMapper()->BuildDeviceFile( ((bicotiActorGraphic2DField*)ptr_actor)->GetText() );
  ptr_local_image->GetMapper()->BuildMapperJPEGIJG();
  ptr_local_image->GetMapper()->Read();
  ptr_local_image->DestroyMapper();
  ptr_local_image->GetActor()->RefreshImage();
  ptr_local_image->GetActor()->SetVisible( true );
  ptr_local_image->GetActor()->SetSize( ptr_local_image->GetImplementation()->GetX0Size(), ptr_local_image->GetImplementation()->GetX1Size() );
}

void LoadInterface :: FieldTextChanged( bicotiActor * ptr_actor )
{}


void LoadInterface :: SetVisible()
{
  ptr_panel->SetVisible( true );
}

