#ifndef _curve_manager
#define _curve_manager


#include "basic_settings.hpp"


class CurveManager : public bicotiListenerGeometry
{
private:
  CurrentImageType * ptr_image;
  CurrentImageType * ptr_perfil;
  
  bool is_linear;
  bool is_simpson;
  bool is_spline;

  void PaintCurve();
  void UnPaintCurve();
  
  void PaintPerfil();

public:
  CurveManager( CurrentImageType * );
  ~CurveManager();

  static bool IsLinearPossible( CurrentImageType * );
  static bool IsSimpsonPossible( CurrentImageType * );
  static bool IsSplinePossible( CurrentImageType * );

  void ActorResized( bicotiActor *, const bicotiEventGeometry& );
  void ActorMoved( bicotiActor *, const bicotiEventGeometry& );

  bool IsCurrentPossible();

  void CreateLinear();
  void CreateSimpson();
  void CreateSpline();
  
  void RefreshCurve();
  void RefreshPerfil();
};


#endif
