#ifndef _main_window
#define _main_window


#include <actor_graphic_2D_panel.hpp>
#include <pixel_rgb_tools.hpp>
#include "basic_settings.hpp"
#include "menu_manager.hpp"
#include "curve_manager.hpp"
#include "cruz.hpp"



class MainWindow : public bicotiListenerGeometry, public bicotiListenerMouse, public bicotiListenerMouseMotion
{
private:
  MenuManager * ptr_menu_manager;
  CurveManager * ptr_curve_manager;

  CurrentImageType :: HomologousFactory factory;
  CurrentCruzType :: HomologousFactory cruz_factory;
  CurrentImageType :: EventLoopManager * ptr_event_loop;

  bicotiActorGraphic2DPanel * ptr_panel;
  CurrentImageType * ptr_imagen;

  static const int main_panel_width = 500;
  static const int main_panel_height = 300;
  static const int main_menu_height = 30;
  static const bicotiPixelColor background_red = 0;
  static const bicotiPixelColor background_green = 128;
  static const bicotiPixelColor background_blue = 0;
  
  void CreateMe();
  void ResetMe();

  bool agregando_puntos;
  bool sacando_puntos;
  bool moviendo_puntos;

  void DisableAddPoints();
  void DisableRemovePoints();
  void DisableMovePoints();

  Cruz * selected_cruz;

public:
  MainWindow( CurrentImageType :: EventLoopManager * );
  ~MainWindow();

  void ActorResized( bicotiActor *, const bicotiEventGeometry& );
  void ActorMoved( bicotiActor *, const bicotiEventGeometry& );

  void MousePressed( bicotiActor *, const bicotiEventMouse& );
  void MouseReleased( bicotiActor *, const bicotiEventMouse& );

  void MouseMoved( bicotiActor *, const bicotiEventMouseMotion& );

  void Stop();
  void LoadImage( const char * );
  void Recreate();
  void AddPoints();
  void RemovePoints();
  void MovePoints();

  void DestroyCurveManager();

  void CreateCurveLinear();
  void CreateCurveSimpson();
  void CreateCurveSpline();
};


#endif
