#include <coordinate.hpp>


/* Ejemplo de uso de operadores bsicos para coordenadas 2D */


void main()
{
  cout << endl << endl;
  cout << "_________________________________________________________________" << endl;
  cout << " Las coordenadas pueden crearse con componentes de cualquier tipo," << endl;
  cout << "en nuestro ejemplo usaremos enteros." << endl;
  cout << " Las componentes de las coordenadas pueden pasarse en el constructor." << endl << endl;;
  cout << "\t  bicotiCoordinate2D< int > coord1( 2, 1);" << endl;
  cout << "\t  bicotiCoordinate2D< int > coord2( 1, -1);" << endl << endl;

  bicotiCoordinate2D< int > coord1( 2, 1);
  bicotiCoordinate2D< int > coord2( 1, -1);

  cout << " En el siguiente caso creamos coord3 con los mismos valores de coord1." << endl;
  cout << " Para ello usamos el constructor de copia." << endl << endl;
  cout << "\t  bicotiCoordinate2D< int > coord3( coord1 );" << endl << endl;

  bicotiCoordinate2D< int > coord3( coord1 );

  cout << " Tambien es posible no asignar los valores en el momento de la construccin." << endl;
  cout << " Este constructor por defecto carga las coordenadas con ceros." << endl << endl;
  cout << "\t  bicotiCoordinate2D< int > coord4;" << endl << endl;

  bicotiCoordinate2D< int > coord4;

  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get();
  
  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  cout << " Se puede acceder a las componentes de las coordenadas usando las " << endl;
  cout << "funciones X0 o X1." << endl << endl;
  cout << "\t cout << \"coord1 = ( \" << coord1.X0() << \" , \" << coord1.X1() << \")\" << endl;" << endl << endl;

  cout << ">> coord1 = ( " << coord1.X0() << " , " << coord1.X1() << ")" << endl << endl;

  cout << " Tambien es posible acceder usando la interface estndar de las coordenadas." << endl;
  cout << " En este caso coord2.X0() es equivalente a coord2( 0 )." << endl << endl;
  cout << "\t coord2 = ( \" << coord2( 0 ) << \" , \" << coord2( 1 ) << \")\" << endl;" << endl << endl;

  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " )" << endl << endl;

  cout << " En ciertos casos la dimensin de la coordenada puede no ser conocida a priori" << endl;
  cout << "y hemos incluido la funcion GetDimension() para consultar por la misma." << endl << endl;
  cout << "\t cout << \"La dimensin de coord3 es \" << coord3.GetDimension() << endl;" << endl << endl;
  cout << ">> La dimensin de coord3 es " << coord3.GetDimension() << endl << endl;
  cout << " En virtud de lo anterior es posible mostrar una coordenada con cualquier tipo de" << endl;
  cout << "componentes y dimensin con las siguientes lineas de cdigo." << endl << endl;
  cout << "\t cout << \"( \";" << endl;
  cout << "\t for ( unsigned i=0; i<coord3.GetDimension(); i++) cout << coord3( i ) << \" \";" << endl;
  cout << "\t cout << \")\";" << endl << endl;
  
  cout << ">> ( "; 
  for ( unsigned i=0; i<coord3.GetDimension(); i++) cout << coord3( i ) << " ";
  cout << ")" << endl << endl;

  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get();

  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  cout << " Podemos usar el operador de asignacin para cargar una coordenada." << endl << endl;
  cout << "\t coord4 = coord2;" << endl << endl;

  coord4 = coord2;
  cout << ">> coord4 = ( " << coord4( 0 ) << " , " << coord4( 1 ) << ")" << endl << endl;
  
  cout << " Los operadores X0, X1 son bidireccionales. Esto es, tambin sirven para asignar " << endl;
  cout << "valores a las componentes." << endl << endl;;
  cout << "\t coord4.X0() = 0;" << endl;
  cout << "\t coord4.X1() = -3;" << endl << endl;

  coord4.X0() = 0;
  coord4.X1() = -3;

  cout << ">> coord4 = ( " << coord4( 0 ) << " , " << coord4( 1 ) << ")" << endl << endl;
  cout << " Lo mismo vale para el operator(). Esto es, lo anterior habria sido equivalente a" << endl << endl;
  cout << "\t coord4( 0 ) = 0;" << endl;
  cout << "\t coord4( 1 ) = -3;" << endl << endl;

  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get();

  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  cout << " Es posible sumar(restar, etc.) un double a una coordenada." << endl;
  cout << " El efecto es sumar el double a todas las componentes de la coordenada." << endl << endl;
  
  cout << "\t coord1 = coord2 + 1;" << endl << endl;
  coord1 = coord2 + 1;
  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " )" << endl;
  cout << ">> coord1 = ( " << coord1( 0 ) << " , " << coord1( 1 ) << " )" << endl << endl;

  cout << " Es posible sumar(restar, etc.) coordenadas entre s." << endl;
  cout << " El efecto es sumar componente a componente." << endl << endl;
  
  cout << "\t coord2 = coord3 + coord4;" << endl << endl;
  coord2 = coord3 + coord4;
  cout << ">> coord3 = ( " << coord3( 0 ) << " , " << coord3( 1 ) << " )" << endl;
  cout << ">> coord4 = ( " << coord4( 0 ) << " , " << coord4( 1 ) << " )" << endl;
  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " )" << endl << endl;

  cout << " Tambin existen los operadores del tipo +=, /=, etc. tanto de coordendas" << endl;
  cout << "como de doubles." << endl << endl;

  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " )" << endl << endl;
  cout << "\t coord2 += 2;" << endl << endl;
  coord2 += 2;
  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " )" << endl << endl;

  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get();

  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  cout << " Las coordenadas tambin pueden usarse como vectores." << endl;
  cout << " En particular es posible calcular la norma2 de una coordenada." << endl << endl;
  cout << "\t cout << \"La norma de coord4 es \" << coord4.Norm() << endl;" << endl << endl;

  cout << ">> coord4 = ( " << coord4( 0 ) << " , " << coord4( 1 ) << " )" << endl;
  cout << ">> La norma de coord4 es " << coord4.Norm() << endl << endl;

  cout << " Es posible calcular el producto escalar entre coordenadas." << endl << endl;
  
  cout << "\t cout << \"El producto escalar de coord1 y coord2 es \" << coord1.ScalarProduct( coord2 ) << endl;" << endl << endl;
  cout << ">> coord1 = ( " << coord1( 0 ) << " , " << coord1( 1 ) << " )" << endl;
  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " )" << endl;
  cout << ">> El producto escalar de coord1 y coord2 es " << coord1.ScalarProduct( coord2 ) << endl << endl;

  cout << " Para coordenadas 3D se pueden usar exactamente los mismos operadores," << endl;
  cout << "con el operador, coord.X2() que es equivalente a su vez a coord( 2 )" << endl << endl;
};
