#include <image_2D_array_char.hpp>
#include <actor_image_2D_rgb_char_qt.hpp>
#include <mapper.hpp>


typedef bicotiCoordinate2D< REAL > CT;
typedef bicotiRGB< unsigned char, REAL > PT;

void main( int argc, char ** argv )
{ 
  PT def_pix(255,0,0);
  bicotiImageImplementation2DArray< PT >* ptr_ima;
  ptr_ima = new bicotiImageImplementation2DArray< PT >(def_pix,0,0);
  
  bicotiDeviceFile device( "../Pictures/luna.jpg" );
  bicotiMapperJPEGIJG< PT, bicotiPixelConverterRGBChar2RGBA > mapper;
  mapper.SetDevice( &device );
  mapper.SetImplementation( ptr_ima );
  mapper.Read();

  bicotiActorImage2DRGBCharQT actor;
  actor.GetImplementation()->CopyMeFrom( ptr_ima );
  actor.GetActor()->SetSize( actor.GetImplementation()->GetX0Size(), actor.GetImplementation()->GetX1Size() );
  bicotiActorImage2DRGBCharQT :: HomologousFactory factory;
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );
  actor.GetActor()->SetMainActor( true );
  factory.CreateHomologous( actor.GetActor() );
  event_loop.Start();

  vector< CT > vect(7);

  vect[0].X0() = 116;
  vect[0].X1() = 31;

  vect[1].X0() = 168;
  vect[1].X1() = 59;

  vect[2].X0() = 181;
  vect[2].X1() = 107;

  vect[3].X0() = 156;
  vect[3].X1() = 147;

  vect[4].X0() = 106;
  vect[4].X1() = 154;

  vect[5].X0() = 67;
  vect[5].X1() = 122;

  vect[6].X0() = 64;
  vect[6].X1() = 71;

  bicotiCoordinateInterpolator1DClosed< CT > * ptr_coord_int;
  ptr_coord_int = new bicotiCoordinateInterpolator1DClosedSpline< CT >;

  bicotiImagePixelInterpolator< PT > * ptr_ima_int;
  ptr_ima_int = new bicotiImagePixelInterpolator2DLinear< PT >( ptr_ima );

  bicotiDexelCurveClosed< CT, PT > curve( ptr_ima,vect,ptr_coord_int,ptr_ima_int);

  bicotiPixelOperatorUnary< PT >* ptr_oper;
  ptr_oper = new bicotiPixelOperatorUnaryConstant< PT >( def_pix );

  curve.ModifyPixels( ptr_oper );

  curve.UpdateImageImplementation();
  
  actor.GetActor()->SetVisible( true );
  actor.GetImplementation()->CopyMeFrom( ptr_ima );
  actor.GetActor()->SetSize( actor.GetImplementation()->GetX0Size(), actor.GetImplementation()->GetX1Size() );
  actor.GetActor()->RefreshImage();
  event_loop.Start();

  delete ptr_ima;
  delete ptr_coord_int;
  delete ptr_ima_int;
  delete ptr_oper;
};
