#include <actor_image_2D_rgb_char_qt.hpp>

typedef bicotiActorImage2DRGBCharQT ImaT;
typedef ImaT :: Pixel PixT;
typedef ImaT :: RealCoordinate CoordT;

void DrawPoint( ImaT& image , int x_0, int x_1 )
{
  PixT rojo(255,0,0);

  image.GetImplementation()->SetPixel(x_0-2,x_1,rojo);
  image.GetImplementation()->SetPixel(x_0-1,x_1,rojo);
  image.GetImplementation()->SetPixel(x_0,x_1,rojo);
  image.GetImplementation()->SetPixel(x_0+1,x_1,rojo);
  image.GetImplementation()->SetPixel(x_0+2,x_1,rojo);

  image.GetImplementation()->SetPixel(x_0,x_1-2,rojo);
  image.GetImplementation()->SetPixel(x_0,x_1-1,rojo);
  image.GetImplementation()->SetPixel(x_0,x_1,rojo);
  image.GetImplementation()->SetPixel(x_0,x_1+1,rojo);
  image.GetImplementation()->SetPixel(x_0,x_1+2,rojo);
};
 

void DrawPoints(  ImaT& image , vector< CoordT >& vec )
{
  unsigned i;
  for( i=0 ; i < vec.size() ; i++ )
    DrawPoint( image, (int)vec[i].X0(), (int)vec[i].X1() );
};


void main( int argc, char **argv )
{

  ImaT ima;
  PixT rojo(255,0,0);
  PixT verde(0,255,0);
  PixT azul(0,0,255);

  ima.BuildMapper();
  ima.GetMapper()->BuildDeviceFile( "../Pictures/grid.jpg" );
  ima.GetMapper()->BuildMapperJPEGIJG();
  ima.GetMapper()->Read();
  
  // Vector de puntos por donde pasa la curva

  vector< CoordT > coord_vect(5);

  coord_vect[0].X0()=110;
  coord_vect[0].X1()=110;
  
  coord_vect[1].X0()=302;
  coord_vect[1].X1()=80;

  coord_vect[2].X0()=210;
  coord_vect[2].X1()=210;

  coord_vect[3].X0()=290;
  coord_vect[3].X1()=330;

  coord_vect[4].X0()=60;
  coord_vect[4].X1()=290;

  DrawPoints( ima, coord_vect );

  // Creo la fachada de Dexel
  ImaT::Dexel * ptr_dex;
  ptr_dex = ima.CreateDexel();

  // Creo una curva lineal Cerrada
  ptr_dex->BuildNewCurveClosedLinear( coord_vect );
  ptr_dex->GetCurveClosed(0)->DrawCurve(verde);

  // Creo una curva Simpson Cerrada
  ptr_dex->BuildNewCurveClosedSimpson( coord_vect );
  ptr_dex->GetCurveClosed(1)->DrawCurve(azul);

  // Creo una curva Spline Cerrada
  ptr_dex->BuildNewCurveClosedSpline( coord_vect );
  ptr_dex->GetCurveClosed(2)->DrawCurve(rojo);

  bicotiActorImage2DRGBCharQT :: HomologousFactory factory;
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );
  
  ima.GetActor()->SetMainActor( true );

  ima.GetActor()->SetSize( ima.GetImplementation()->GetX0Size(), ima.GetImplementation()->GetX1Size() );

  factory.CreateHomologous( ima.GetActor() );
  event_loop.Start();

  delete ptr_dex;

  // Borro la implementacin y vuelvo a leer la grilla 
  ima.BuildMapper();
  ima.GetMapper()->BuildDeviceFile( "../Pictures/grid.jpg" );
  ima.GetMapper()->BuildMapperJPEGIJG();
  ima.GetMapper()->Read();
  
  ptr_dex = ima.CreateDexel();

  // Creo una curva lineal Abierta
  ptr_dex->BuildNewCurveOpenLinear( coord_vect );
  ptr_dex->GetCurveOpen(0)->DrawCurve(verde);

  // Creo una curva Simpson Abierta
  ptr_dex->BuildNewCurveOpenSimpson( coord_vect );
  ptr_dex->GetCurveOpen(1)->DrawCurve(azul);

  // Creo una curva Spline Abierta
  ptr_dex->BuildNewCurveOpenSpline( coord_vect );
  ptr_dex->GetCurveOpen(2)->DrawCurve(rojo);

  ima.GetActor()->RefreshImage();
  ima.GetActor()->SetVisible( true );
  event_loop.Start();
  
  delete ptr_dex;
};
