#include <actor_image_2D_rgb_char_qt.hpp>
 
typedef bicotiCoordinate2D< REAL > CoordRealType;

void main( int argc, char ** argv )
{
  const unsigned coord_number = 100;

  CoordRealType centro( 180, 220 );
  const REAL radio = 100;

  bicotiActorImage2DRGBCharQT imagen;

  imagen.BuildMapper();
  imagen.GetMapper()->BuildDeviceFile( "../Pictures/heidi.jpg" );
  imagen.GetMapper()->BuildMapperJPEGIJG();
  imagen.GetMapper()->Read();
  imagen.GetActor()->SetSize( imagen.GetImplementation()->GetX0Size(), imagen.GetImplementation()->GetX1Size() );
  imagen.DestroyMapper();

  bicotiActorImage2DRGBCharQT :: HomologousFactory factory;  
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );
  
  imagen.GetActor()->SetMainActor( true );
  factory.CreateHomologous( imagen.GetActor() );
  event_loop.Start();
  
  // Construyo Dexel y defino un puntero para no tener que hacer GetDexel todas las veces
  imagen.BuildDexel();
  bicotiActorImage2DRGBCharQT :: Dexel * ptr_dex;
  bicotiActorImage2DRGBCharQT :: Pixel white_pix( 255, 255, 255 );
  ptr_dex = imagen.GetDexel();
  
  // Construyo un circulo en la imagen
  vector< CoordRealType > lista_coordenadas(coord_number);
  for( unsigned index = 0; index < coord_number; index++ )
    {lista_coordenadas[ index ].X0() = ( centro.X0() + radio * cos( (2*pi*index / (double)coord_number) ) );
    lista_coordenadas[ index ].X1() = ( centro.X1() + radio * sin( (2*pi*index / (double)coord_number) ) );}
  ptr_dex->BuildNewCurveClosedLinear(lista_coordenadas);
  
  // Seteo puntos en la imagen sobre la curva
  for( unsigned index = 0; index < 10 * coord_number; index++ )
    ptr_dex->GetCurveClosed(0)->SetPixel( (double)index / (10*coord_number) , white_pix );
  ptr_dex->GetCurveClosed(0)->UpdateImageImplementation();

  imagen.GetActor()->RefreshImage();
  imagen.GetActor()->SetVisible( true );
  event_loop.Start();
  
  // Deshago los cambios en la imagen
  ptr_dex->GetCurveClosed(0)->UndoUpdateImageImplementation();

  imagen.GetActor()->RefreshImage();
  imagen.GetActor()->SetVisible( true );
  event_loop.Start();
};
   
