#include <actor_image_2D_char_qt.hpp>

 
typedef unsigned char PixelType; 
typedef bicotiCoordinate2D< INTEGER > CoordType; 

 
void main( int argc, char ** argv ) 
{   
  cout << "  Ejemplo de Labeling. Se utiliza conectividad 4 vecinos y se buscan" << endl;
  cout << "los pixels que estan entre 105 y 255. La idea es detectar los arroces." << endl;
  cout << "Una vez construido el Labeling, cargo las regiones (candidatos a arroces)" << endl;
  cout << "y para cada regin construyo un objeto de propiedades. Pinto las regiones" << endl;
  cout << "de gris 128 mediante un bicotiPixelOperatorUnary. Con el objeto de propiedad " << endl;
  cout << "hallo los pixels del borde de cada regin y con esto construyo otra regin" << endl;
  cout << "(pero no desde una fachada), pinto de blanco el borde de cada regin. Para" << endl;
  cout << "cada regin calculada muestro en pantalla propiedades bsicas como contidad de pixels" << endl;
  cout << "en la regin y cantidad de pixels en el borde. " << endl << endl;
 
  cout << "Creamos una fachada de imagen 2D Char QT" << endl << endl;
  cout << "\t bicotiImage2DCharQT imagen;" << endl << endl;
  cout << "Leemos la foto de disco y la mostramos" << endl << endl;

  bicotiActorImage2DCharQT imagen; 
 
  imagen.BuildMapper();
  imagen.GetMapper()->BuildDeviceFile( "../Pictures/arroz.jpg" );
  imagen.GetMapper()->BuildMapperJPEGIJG();
  imagen.GetMapper()->Read();
  imagen.GetActor()->SetSize( imagen.GetImplementation()->GetX0Size(), imagen.GetImplementation()->GetX1Size() );
  
  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl << "----------------------------------------------------------------" << endl;
  

  bicotiActorImage2DCharQT :: HomologousFactory factory; 
  bicotiActorImage2DCharQT :: EventLoopManager event_loop( argc, argv ); 

  imagen.GetActor()->SetMainActor( true );
  factory.CreateHomologous( imagen.GetActor() );
  event_loop.Start();

  cout << "Constuiremos la fachada de Dexel y la asocio a un puntero" << endl << endl;
  cout << "\t imagen.BuildDexel();" << endl;
  cout << "\t bicotiActorImage2DCharQT :: Dexel * ptr_dex;" << endl;
  cout << "\t ptr_dex = imagen.GetDexel();" << endl << endl;
  

  imagen.BuildDexel(); 
  bicotiActorImage2DCharQT :: Dexel * ptr_dex;  
  ptr_dex = imagen.GetDexel(); 

  
  cout << "Fijamos el criterio de los pixeles a clasificar. (rango [105,255])." << endl << endl;
  cout << "\t ptr_dex->UsePixelLabelingCriterionRange(105,255);" << endl << endl;
  
  ptr_dex->UsePixelLabelingCriterionRange(105,255); 

  
  cout << "Fijamos el criterio de conectividad en vecindad 4." << endl << endl;
  cout << "\t ptr_dex->UseConnectivityLabelingStrategy4N();" << endl << endl;
  
  ptr_dex->UseConnectivityLabelingStrategy4N(); 

  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl << "----------------------------------------------------------------" << endl;

  cout << "Calculamos el Labeling y cargamos el resultado en la lista de regiones" << endl;
  cout << "de la fachada de Dexel." << endl << endl;
  cout << "\t ptr_dex->BuildLabeling();" << endl;
  cout << "\t ptr_dex->LoadRegionLabelingResult();" << endl << endl;
  
  
  ptr_dex->BuildLabeling(); 
  ptr_dex->LoadRegionLabelingResult(); 

  
  cout << "Construimos un objeto de propiedades para cada regin de la lista." << endl;
  cout << "Destruimos el objeto Labeling pues ya no es necesario." << endl << endl;
  cout << "\t ptr_dex->BuildRegionsProperties();" << endl;
  cout << "\t ptr_dex->DestroyLabeling();" << endl << endl;
  

  ptr_dex->BuildRegionsProperties(); 
  ptr_dex->DestroyLabeling(); 

  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl << "----------------------------------------------------------------" << endl;

  cout << "Consulto el nmero de Regiones halladas." << endl << endl;
  cout << "\t cout << \"El nmero de regiones es \" << ptr_dex->GetRegionsNumber() << endl;" << endl << endl;

  cout << ">> El nmero de regiones es " << ptr_dex->GetRegionsNumber() << endl << endl; 
 
  cout << "A continuacin, pongo en los pixeles de las regiones el valor 128." << endl;
  cout << "Primero creo el OperatorUnary a aplicar en los pixeles de las regiones," << endl;
  cout << "en este caso es un objeto que me da un valor constante." << endl << endl;
  
  cout << "\t bicotiPixelOperatorUnaryConstant< unsigned char > * ptr_pix_oper;" << endl;
  cout << "\t ptr_pix_oper = new bicotiPixelOperatorUnaryConstant< unsigned char >( 128 );" << endl << endl;
  

  bicotiPixelOperatorUnaryConstant< PixelType > * ptr_pix_oper; 
  ptr_pix_oper = new bicotiPixelOperatorUnaryConstant< PixelType >( 128 ); 
   
  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl << "----------------------------------------------------------------" << endl;
  

  bicotiDexelRegion< CoordType, PixelType > border_region( imagen.GetImplementation() ); 

  
  cout << "A continuacin para cada una de las regiones encontradas aplico" << endl << endl;
  cout << "\t ptr_dex->GetRegion( region_index )->ModifyPixels( ptr_pix_oper );" << endl << endl;
  cout << "para aplicar el operador en todos los pixeles de la region (pintar de gris)." << endl;
  cout << "Luego actualiza la implementacin" << endl << endl;
  cout << "\t ptr_dex->GetRegion( region_index )->UpdateImageImplementation();" << endl << endl;
  cout << "Muestro los pixeles en cada regin con" << endl << endl;
  cout << "\t ptr_dex->GetRegionProperty( region_index )->GetPixelsInRegionNumber()" << endl << endl;

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl << "----------------------------------------------------------------" << endl;

  cout << "Aplico FixInfo para ordenar los pixeles espacialmente" << endl << endl;
  cout << "\t ptr_dex->GetRegionProperty( region_index )->FixInfo();" << endl << endl;
  cout << "Hallo los pixeles de la frontera." << endl << endl;
  cout << "\t ptr_dex->GetRegionProperty( region_index )->ComputeBorder();" << endl << endl;
  cout << "Muestro la cantidad de pixeles en el borde" << endl << endl;
  cout << "\t ptr_dex->GetRegionProperty( region_index )->GetPixelsInBorderNumber()" << endl << endl;
  cout << "Cargo el borde en una nueva regin y los pinto de blanco 255" << endl << endl;
  cout << "\t border_region.GetRegion() =  ptr_dex->GetRegionProperty( region_index )->GetBorder();" << endl;
  cout << "\t ptr_pix_oper->Pixel() = 255;" << endl;
  cout << "\t border_region.ModifyPixels( ptr_pix_oper );" << endl;
  cout << "\t border_region.UpdateImageImplementation();" << endl << endl;

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl << "----------------------------------------------------------------" << endl;
  

  for( unsigned region_index = 0; region_index < ptr_dex->GetRegionsNumber(); region_index++ ) 
    { 
      ptr_pix_oper->Pixel() = 128; 
      
      cout << "Pintando region" << region_index << endl; 
      ptr_dex->GetRegion( region_index )->ModifyPixels( ptr_pix_oper ); 
      ptr_dex->GetRegion( region_index )->UpdateImageImplementation(); 
      
      cout << "Pixels in region " << ptr_dex->GetRegionProperty( region_index )->GetPixelsInRegionNumber() << endl; 
      cout << "Fixing info" << endl; 
      ptr_dex->GetRegionProperty( region_index )->FixInfo(); 
      cout << "Computing border" << endl; 
      ptr_dex->GetRegionProperty( region_index )->ComputeBorder(); 
      cout << "Pixels in border = " <<  ptr_dex->GetRegionProperty( region_index )->GetPixelsInBorderNumber() << endl; 
       
      border_region.GetRegion() =  ptr_dex->GetRegionProperty( region_index )->GetBorder(); 
      ptr_pix_oper->Pixel() = 255; 
      border_region.ModifyPixels( ptr_pix_oper ); 
      border_region.UpdateImageImplementation(); 
      cout << "Saliendo de region " << region_index << endl; 
    } 

  
  cout << endl << "Muestro el resultado." << endl;
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl << "----------------------------------------------------------------" << endl;
  

  imagen.GetActor()->RefreshImage();
  imagen.GetActor()->SetVisible( true );
  event_loop.Start();

  ptr_dex->DestroyRegions(); 
  imagen.DestroyDexel(); 

  delete ptr_pix_oper; 
}        
