#include <actor_image_2D_rgb_float_qt.hpp>

typedef bicotiActorImage2DRGBFloatQT ImaT;
typedef ImaT :: Pixel PixT;
          
void main( int argc, char ** argv )  
{ 
  unsigned frame_size = 5;

  ImaT ima; 

  ima.BuildMapper();
  ima.GetMapper()->BuildDeviceFile( "nfilter3.jpg" );
  ima.GetMapper()->BuildMapperJPEGIJG();
  ima.GetMapper()->Read();
  ima.GetActor()->SetSize( ima.GetImplementation()->GetX0Size(), ima.GetImplementation()->GetX1Size() );

  ImaT :: HomologousFactory factory;
  ImaT :: EventLoopManager event_loop( argc, argv );
  ima.GetActor()->SetMainActor( true );
  factory.CreateHomologous( ima.GetActor() );
  event_loop.Start();

  // Creo la Fachada del filtro
  ima.BuildNeighbourFilter();
  
  // Declaro un puntero a la fachada
  // esto es solo por comodidad, para no escribir ima.GetNeighbourFilter()
  ImaT :: NeighbourFilter * ptr_filt;
  ptr_filt = ima.GetNeighbourFilter();

  // Creo un filtro lineal
  ptr_filt->BuildMaximumFilter( frame_size );

  // Elijo estrategia de borde
  ptr_filt->UseExtrapolationStrategyEqual();

  // Filtro
  ptr_filt->Filter();
  
  // Cargo el resultado
  ima.LoadNeighbourFilterResult();
  
  // Borro la fachada de filtro
  ima.DestroyNeighbourFilter();
  // Obs : NO borrar ptr_filt, porque la funcin Destroy lo hizo

  ima.GetActor()->SetMainActor( true );
  ima.GetActor()->SetSize( ima.GetImplementation()->GetX0Size(), ima.GetImplementation()->GetX1Size() );

  factory.CreateHomologous( ima.GetActor() );
  event_loop.Start();
  ima.GetActor()->DestroyHomologous();
}
