#define IMAGE_2D_ARRAY_CHAR 
#include <bicoti.hpp>

//*******************************COMENTARIOS GENERALES*****************************
// La imagen abstracta esta compuesta de punteros a objetos que agrupan las 
// operaciones, implementaciones propiedades, etc. de la imagen. 
// La implementacion se crea automaticamente al construir la imagen y todos 
// los otros objetos se crean y destruyen por demanda del usuario usando alguna 
// funcion de la clase imagen del tipo "Create.." o "Destroy.." la imagen 
// controla los new's y delete's de todos sus objetos 
 
 
//**************************************EJEMPLOS************************************

typedef unsigned char PixelType;  // definimos el tipo de pixel 
 
void main() 
{ 
  cout << "Para usar una fachada hay que definir previamente su macro." << endl;
  cout << "En bicoti_basic estn todos los macros detallados." << endl << endl;

  cout << "Declaracion del objeto imagen abstracta ( nro_columnas, nro_filas )" << endl;
  cout << "La dimension, implementacion y el tipo de pixel quedan definidas en" << endl;
  cout << "la declaracion de la Clase " << endl;
  cout << "EJ: Image2DArrayChar -> imagen 2 dimensiones, pixel Char e implementacion Array" << endl << endl;

  cout << "\t const unsigned filas = 5;" << endl;
  cout << "\t const unsigned columnas = 6;" << endl;
  cout << "\t bicotiImage2DArrayChar imagen1( columnas, filas );" << endl << endl;
  
  const unsigned filas = 5; 
  const unsigned columnas = 6;  
  bicotiImage2DArrayChar imagen1( columnas, filas ); 
 
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << "--------------------------------------------------------" << endl << endl;

  cout << "Seteo de la Implementacion de la imagen" << endl;
  cout << "OJO: El orden es columna, fila y estas van de cero a tamao - 1  " << endl;
  cout << "imagen.GetImplementation() devuelve un puntero al objeto que tiene la  " << endl;
  cout << "implentacion de la imagen. " << endl;
  cout << "De este objeto mostramos algunas de las operaciones bsicas " << endl;
  cout << "Para setear (Set) o leer (Get) pixels de la imagen se usan las funciones " << endl;
  cout << "SetPixel( columna, fila, pixel )" << endl;
  cout << "y GetPixel( columna, fila ) retorna un pixel. " << endl << endl;
  
  cout << "\t unsigned columna, fila;" << endl;
  cout << "\t for( fila = 0; fila < filas; fila++ )" << endl;
  cout << "\t   for( columna = 0; columna < columnas; columna++ ) " << endl;
  cout << "\t     imagen1.GetImplementation()->SetPixel( columna, fila, rand()%10 );" << endl;
  cout << "\t cout << \"Datos en imagen\" << endl;" << endl << endl;
  cout << "\t for( fila = 0; fila < filas; fila++ )" << endl;
  cout << "\t   {for( columna = 0; columna < columnas; columna++ )" << endl;
  cout << "\t     cout << (int)imagen1.GetImplementation()->GetPixel( columna, fila ) << \" \";" << endl;
  cout << "\t   cout << endl;}" << endl << endl;

  unsigned columna, fila; 
  for( fila = 0; fila < filas; fila++ ) 
    for( columna = 0; columna < columnas; columna++ ) 
      imagen1.GetImplementation()->SetPixel( columna, fila, rand()%10 ); 
   
  cout << "Datos en imagen" << endl; 
  for( fila = 0; fila < filas; fila++ ) 
    {for( columna = 0; columna < columnas; columna++ ) 
      cout << (int)imagen1.GetImplementation()->GetPixel( columna, fila ) << " "; 
    cout << endl;} 
   
  // Tambien es posible preguntarle las dimensiones a la implementacion 
  // con las funciones GetX0Size() y GetX1Size(). 

  cout << "Nmero de columnas de la imagen = " << imagen1.GetImplementation()->GetX0Size() << endl; 
  cout << "Nmero de filas de la imagen    = " << imagen1.GetImplementation()->GetX1Size() << endl; 
  cout << endl; 
 
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << "--------------------------------------------------------" << endl << endl;
  cout << "Declaro una nueva imagen (imagen2). Para copiar los datos de" << endl;
  cout << "imagen en imagen2 uso CopyMeFrom." << endl << endl;

  cout << "\t bicotiImage2DArrayChar imagen2;" << endl;
  cout << "\t imagen2.GetImplementation()->CopyMeFrom( imagen1.GetImplementation() );" << endl << endl;

  bicotiImage2DArrayChar imagen2; 
  imagen2.GetImplementation()->CopyMeFrom( imagen1.GetImplementation() ); 
 
  cout << "Las operaciones punto a punto de varias imgenes en otra, estn agrupadas" << endl;
  cout << "en el OperatorMultiple." << endl;
  cout << "Estas incluyen entre otras Addition() ( suma ), Product() ( producto )," << endl;
  cout << "Subtraction() ( resta ), Division( cero, inf )." << endl;
  cout << "En el ltimo caso hay que pasar cual es el cero del tipo pixel." << endl;
  cout << "( no es trivial en RGB por ejemplo ) y que valor se espera al dividir por este." << endl;
  cout << "El resultado es devuelto en la primera de las imgenes " << endl;
  cout << "A continuacin voy a sumar imagen1 e imagen2 cargando el resultado en la primera" << endl << endl;

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << "--------------------------------------------------------" << endl << endl;

  cout << "Agrego una a una las implementaciones" << endl;
  cout << "a sumar, en este caso solo la de image2" << endl;

  cout << "\t imagen1.BuildOperatorMultiple();" << endl;
  cout << "\t imagen1.GetOperatorMultiple()->Append( imagen2.GetImplementation() );" << endl;
  cout << "\t imagen1.GetOperatorMultiple()->Addition(); // sumo las imagenes" << endl;
  cout << "\t // si ahora hiciera imagen1.GetOperatorMultiple()->Product() multiplicara el" << endl;
  cout << "\t // resultado anterior y sub_imagen2" << endl;
  cout << "\t imagen1.DestroyOperatorMultiple();  // Borro el operador" << endl << endl;

  imagen1.BuildOperatorMultiple();
  imagen1.GetOperatorMultiple()->Append( imagen2.GetImplementation() ); 
  imagen1.GetOperatorMultiple()->Addition(); // sumo las imagenes 
  // si ahora hiciera imagen1.GetOperatorMultiple()->Product() multiplicara el 
  // resultado anterior y sub_imagen2 
  imagen1.DestroyOperatorMultiple();  // Borro el operador

  cout << "Despues de sumar" << endl; 
  cout << "Datos en imagen1" << endl; 

  for( fila = 0; fila < imagen1.GetImplementation()->GetX1Size(); fila++ ) 
    {cout << ">> ";
    for( columna = 0; columna < imagen1.GetImplementation()->GetX0Size(); columna++ ) 
      cout << (int)imagen1.GetImplementation()->GetPixel( columna, fila ) << " "; 
    cout << endl;} 
  cout << endl; 

  cout << "Datos en imagen2" << endl; 
  for( fila = 0; fila < imagen2.GetImplementation()->GetX1Size(); fila++ ) 
    {cout << ">> ";
    for( columna = 0; columna < imagen2.GetImplementation()->GetX0Size(); columna++ ) 
      cout << (int)imagen2.GetImplementation()->GetPixel( columna, fila ) << " "; 
    cout << endl;} 
};

