#include <actor_image_2D_double_qt.hpp>

typedef bicotiActorImage2DDoubleQT ImaT;
          
void main( int argc, char ** argv )  
{ 
  cout << " Este es un ejemplo de operators usando imgenes reales" << endl;

  ImaT ima1; 
  
  ima1.BuildMapper();
  ima1.GetMapper()->BuildDeviceFile( "operator2.jpg" );
  ima1.GetMapper()->BuildMapperJPEGIJG();
  ima1.GetMapper()->Read();
  ima1.GetActor()->SetSize( ima1.GetImplementation()->GetX0Size(), ima1.GetImplementation()->GetX1Size() );

  cout << "La imagen original" << endl << endl;
  
  cout << "-----------------------------------------------------------" << endl;

  ImaT :: HomologousFactory factory;
  ImaT :: EventLoopManager event_loop( argc, argv );
  ima1.GetActor()->SetMainActor( true );
  factory.CreateHomologous( ima1.GetActor() );
  event_loop.Start();
  
  cout << "Creo la fachada de Operator Unary" << endl << endl;
  cout << "\t ima1.BuildOperatorUnary();" << endl << endl;
  
  ima1.BuildOperatorUnary();
  
  cout << "Declaro un puntero a la fachada" << endl;
  cout << "esto es solo por comodidad, para no escribir ima.GetOperatorUnary()" << endl << endl;

  cout << "\t bicotiImage2DArrayFloat::OperatorUnary * ptr_oper_un;" << endl;
  cout << "\t ptr_oper_un = ima1.GetOperatorUnary();" << endl << endl;

  ImaT :: OperatorUnary * ptr_oper_un;
  ptr_oper_un = ima1.GetOperatorUnary();

  cout << "Sumo 10 a los pixeles de la imagen" << endl;
  cout << "Se puede apreciar la saturacion en el resultado" << endl << endl;
  
  cout << "\t ptr_oper_un->Addition( 10 );" << endl << endl;

  ptr_oper_un->Addition( 10 );

  cout << "-----------------------------------------------------------" << endl;
  ima1.GetActor()->SetVisible( true );
  ima1.GetActor()->RefreshImage();
  event_loop.Start();

  cout << "Multiplico la imagen por 3" << endl;
  cout << "Se puede apreciar la saturacion en el resultado" << endl << endl;
  
  cout << "\t ptr_oper_un->Product( 3 );" << endl << endl;

  ptr_oper_un->Product( 3 );

  cout << "-----------------------------------------------------------" << endl;
  ima1.GetActor()->SetVisible( true );
  ima1.GetActor()->RefreshImage();
  event_loop.Start();

  cout << "Hago logaritmo de la imagen y la multiplico por 35 " << endl;
  cout << "para realzar el brillo" << endl << endl;

  cout << "\t ptr_oper_un->Logarithm();" << endl;
  cout << "\t ptr_oper_un->Product( 35 );" << endl << endl;

  ptr_oper_un->Logarithm();
  ptr_oper_un->Product( 35 );

  cout << "-----------------------------------------------------------" << endl;
  ima1.GetActor()->SetVisible( true );
  ima1.GetActor()->RefreshImage();
  event_loop.Start();
  
  cout << "Borro la fachada de Operator Unary" << endl << endl;
  cout << "\t ima1.DestroyOperatorUnary();" << endl << endl;

  ima1.DestroyOperatorUnary();
  // Obs : NO borrar ptr_oper_un, porque la funcin Destroy lo hizo

  ImaT ima2;
  cout << "Hacemos otras operaciones usando la fachada internamente." << endl;
  cout << "Definiremos otra imagen." << endl << endl;
  
  cout << "\t bicotiImage2DArrayFloat ima2" << endl << endl;
  
  cout << "Luego leemos la misma imagen del disco." << endl;

  ima2.BuildMapper();
  ima2.GetMapper()->BuildDeviceFile( "operator2.jpg" );
  ima2.GetMapper()->BuildMapperJPEGIJG();
  ima2.GetMapper()->Read();
  
  // Tambien es posible manejar las fachadas internamente
  cout << "La secuencia a continuacin:" << endl;
  cout << " _Crea el OperatorMultiple internamente." << endl;
  cout << " _Anexa la imagen 1 al conjunto sobre las que se opera." << endl;
  cout << " _Hace el producto entre ambas. El resultado queda en ima2." << endl;
  cout << " _Crea un OperatorUnary para ima2." << endl;
  cout << " _Multiplica ima por 1/255." << endl << endl;

  cout << "\t ima2.BuildOperatorMultiple();" << endl;
  cout << "\t ima2.GetOperatorMultiple()->Append( ima1.GetImplementation() );" << endl;
  cout << "\t ima2.GetOperatorMultiple()->Product();" << endl;
  cout << "\t ima2.BuildOperatorUnary();" << endl;
  cout << "\t ima2.GetOperatorUnary()->Product( 1.0/255 );" << endl << endl;

  ima2.BuildOperatorMultiple();
  
  // Anexo la imagen 1 a la 2
  ima2.GetOperatorMultiple()->Append( ima1.GetImplementation() );

  // Las multiplico entre si
  ima2.GetOperatorMultiple()->Product();
  
  //No es indispensable eliminar las fachadas explicitamente.
  ima2.BuildOperatorUnary();
  ima2.GetOperatorUnary()->Product( 1.0/255 );
  
  cout << "-----------------------------------------------------------" << endl;
  ima2.GetActor()->SetMainActor( true );
  ima2.GetActor()->SetSize( ima2.GetImplementation()->GetX0Size(), ima2.GetImplementation()->GetX1Size() );
  factory.CreateHomologous( ima2.GetActor() );
  event_loop.Start();
};
