#include <actor_image_2D_char_qt.hpp>
#include <histogram_painter.hpp>
 
typedef bicotiActorImage2DCharQT ImaT;
typedef bicotiHistogramPainter< ImaT :: Pixel > HisT;
          
void main( int argc, char ** argv )  
{ 
  ImaT imagen; 
  imagen.BuildMapper();
  imagen.GetMapper()->BuildDeviceFile( "histo2.jpg" );
  imagen.GetMapper()->BuildMapperJPEGIJG();
  imagen.GetMapper()->Read();
  imagen.GetActor()->SetSize( imagen.GetImplementation()->GetX0Size(), imagen.GetImplementation()->GetX1Size() );
  imagen.DestroyMapper();

  ImaT :: HomologousFactory factory;
  ImaT :: EventLoopManager event_loop( argc, argv );
  imagen.GetActor()->SetMainActor( true );
  factory.CreateHomologous( imagen.GetActor() );
  
  imagen.BuildProperty();
  imagen.GetProperty()->BuildHistogramExtended();

  HisT hist_tool;
  HisT :: actor_histogram histograma( 0, 512, 200 );
  histograma.SetSize( histograma.GetX0Size(), histograma.GetX1Size() );
  hist_tool.SetActorImage( &histograma );
  hist_tool.SetPropertyHistogram( imagen.GetProperty()->GetHistogram() );

  bicotiVerticalStrategyLinear vert_strat;
  bicotiHorizontalStrategyLinear< ImaT :: Pixel > horiz_strat;
  horiz_strat.SetRange( 255 );
  bicotiColorStrategyConstant< ImaT :: Pixel, ImaT :: Pixel > color_strat;
  color_strat.SetPencil( 255 );
  
  hist_tool.AddLayoutInformation( &vert_strat, &horiz_strat, &color_strat, 10, 10, 502, 190 );

  hist_tool.PaintBar();
  hist_tool.PaintAxes( 255 );

  factory.CreateHomologous( &histograma );
  
  event_loop.Start();
  histograma.SetVisible( false );

  imagen.GetProperty()->EqualizateHistogramSegmentation( 128, 0, 255 );
  imagen.GetActor()->RefreshImage();
  imagen.GetActor()->SetVisible( true );
  
  histograma.Resize( 512, 200 );
  hist_tool.PaintBar();
  hist_tool.PaintAxes( 255 );

  histograma.RefreshImage();
  histograma.SetVisible( true );

  event_loop.Start();
}  
