#include <actor_image_2D_double_qt.hpp> 
 

typedef bicotiActorImage2DDoubleQT ImaT; 
typedef ImaT :: Pixel PixT; 
typedef bicotiPixelComplex< PixT > ComT; 
typedef bicotiImageImplementation2DArray< ComT > ImpComT;
  

void main( int argc, char ** argv )
{ 
  const unsigned filas = 512;
  const unsigned columnas = 512;
  const unsigned ancho = 32;
  
  unsigned i, j; 
  unsigned radio;
  float angulo,paso;
  ComT zero(0, 0);
 
  ImaT imagen( columnas, filas, "ima1" ); 
  
  paso = pi/200;
  
  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (pi/2) ; angulo += paso ) 
      {  j = (unsigned)( radio*sin(angulo) );
      i = (unsigned)( radio*cos(angulo) );				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}
  
  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (pi/2) ; angulo += paso ) 
      {j = (unsigned)((columnas-1)-radio*sin(angulo));
      i = (unsigned)(radio*cos(angulo));				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}
  
  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (pi/2) ; angulo += paso ) 
      {  j = (unsigned)(radio*sin(angulo));
      i = (unsigned)((filas-1)-radio*cos(angulo));				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}
  
  for( radio = 0 ; radio < ancho ; radio++ ) 
    for( angulo = 0 ; angulo < (pi/2) ; angulo += paso ) 
      {  j = (unsigned)(columnas-1-radio*sin(angulo));
      i = (unsigned)(filas-1-radio*cos(angulo));				 
      imagen.GetImplementation()->SetPixel( i, j, 255 );}

  ImpComT * ptr_ima_dest; 
  ptr_ima_dest = new ImpComT( zero , 1, 1 );

  ImaT :: HomologousFactory factory;
  ImaT :: EventLoopManager event_loop( argc, argv );
  imagen.GetActor()->SetMainActor( true );
  imagen.GetActor()->SetSize( imagen.GetImplementation()->GetX0Size(), imagen.GetImplementation()->GetX1Size() );

  factory.CreateHomologous( imagen.GetActor() );
  event_loop.Start();
  
  bicotiTransformationFourier2D< PixT > trans( ptr_ima_dest, imagen.GetImplementation() );
  cout << "Transformando" << endl; 
  trans.Transform(); 
  cout << "Transformacion terminada" << endl; 
  
  cout << "Copiando resultado" << endl; 
  for( j = 0; j < filas; j++ ) 
    for( i = 0; i < columnas; i++ ) 
      imagen.GetImplementation()->SetPixel( i, j, (ptr_ima_dest->GetPixel(i, j)).Module() ); 
  
  // Para que sea visualizable
  imagen.BuildOperatorUnary(); 
  imagen.GetOperatorUnary()->Addition( 1 );
  imagen.GetOperatorUnary()->Logarithm(); 
  imagen.BuildProperty(); 
  imagen.GetProperty()->BuildStatistical(); 
  float max = (imagen.GetProperty()->GetStatistical())->MaximumValue(); 
  max = 255.0 / max; 
  imagen.GetOperatorUnary()->Product( max ); 
  imagen.DestroyProperty(); 
  imagen.DestroyOperatorUnary(); 
  
  imagen.GetActor()->RefreshImage();
  imagen.GetActor()->SetVisible( true );

  event_loop.Start();
  
  delete ptr_ima_dest; 
}  
