#include <source/actor/actor_graphic_2D.hpp>

//-------------------bicotiActorGraphic2D---------------------
bicotiActorGraphic2D :: bicotiActorGraphic2D( char * act_name ) : bicotiActorGraphic( act_name )
{  
  min_width = min_height = 0;
  max_width = max_height = 32767;
  
  x = y = 0;
  width = height = 0;

  dimension_case = _2D;
}


bicotiActorGraphic2D :: ~bicotiActorGraphic2D()
{
}


bool bicotiActorGraphic2D :: CheckPosition( int x_in, int y_in )
{
  if ( ( x_in != x ) || ( y_in != y ) )
    {x = x_in;
    y = y_in;
    return true;}
  
  return false;
}

bool bicotiActorGraphic2D :: CheckSize( int w, int h )
{
  if ( ( w != width ) || ( h != height ) )
    {if ( w < min_width )
      width = min_width;
    else
      {if ( w > max_width )
	width = max_width;
      else
	width = w;}
    
    if ( h < min_height )
      height = min_height;
    else
      {if ( h > max_height )
	height = max_height;
      else
	height = h;}
    return true;}
  
  return false;
}


void bicotiActorGraphic2D :: SetPosition( int x_in, int y_in )
{
  if ( ptr_homologous == NULL )
    FireActorMoved( this, x_in, y_in );
  else 
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetPosition( x_in, y_in );
}

void bicotiActorGraphic2D :: SetX( int x_in )
{
  if ( ptr_homologous == NULL )
    FireActorMoved( this, x_in, y );
  else 
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetPosition( x_in, y );
}

void bicotiActorGraphic2D :: SetY( int y_in )
{
  if ( ptr_homologous == NULL )
    FireActorMoved( this, x, y_in );
  else 
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetPosition( x, y_in );
}

void bicotiActorGraphic2D :: SetSize( int w, int h )
{
  if ( ptr_homologous == NULL )
    FireActorResized( this, w, h );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetSize( w, h );
}

void bicotiActorGraphic2D :: SetWidth( int w )
{
  if ( ptr_homologous == NULL )
    FireActorResized( this, w, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetSize( w, height );
}

void bicotiActorGraphic2D :: SetHeight( int h )
{
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, h );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetSize( width, h );
}

int bicotiActorGraphic2D :: GetX()
{return x;}

int bicotiActorGraphic2D :: GetY()
{return y;}


int bicotiActorGraphic2D :: GetWidth()
{return width;}


int bicotiActorGraphic2D :: GetHeight()
{return height;}


int bicotiActorGraphic2D :: GetMinimumWidth()
{return min_width;}


int bicotiActorGraphic2D :: GetMaximumWidth()
{return max_width;}


int bicotiActorGraphic2D :: GetMinimumHeight()
{return min_height;}


int bicotiActorGraphic2D :: GetMaximumHeight()
{return max_height;}


void bicotiActorGraphic2D :: SetMinimumWidth( int min_w )
{
  min_width = min_w;
  
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetMinimumWidth( min_width );
}


void bicotiActorGraphic2D :: SetMaximumWidth( int max_w )
{
  max_width = max_w;
  
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetMaximumWidth( max_width );
}


void bicotiActorGraphic2D :: SetMinimumHeight( int min_h )
{
  min_height = min_h;
  
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetMinimumHeight( min_height );
}


void bicotiActorGraphic2D :: SetMaximumHeight( int max_h )
{
  max_height = max_h;
  
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetMaximumHeight( max_height );
}


void bicotiActorGraphic2D :: SetFixedWidth( int w )
{
  min_width = max_width = w;
  
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetFixedWidth( min_width );
}


void bicotiActorGraphic2D :: SetFixedHeight( int h )
{
  min_height = max_height = h;
  
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetFixedHeight( min_height );
}


void bicotiActorGraphic2D :: SetFixedSize( int w, int h )
{
  min_width = max_width = w;  
  min_height = max_height = h;
  
  if ( ptr_homologous == NULL )
    FireActorResized( this, width, height );
  else
    ((bicotiHomologousGraphic2D*)ptr_homologous)->SetFixedSize( min_width, min_height );
}


//----------------bicotiHomologousGraphic2D-------------------
bicotiHomologousGraphic2D :: ~bicotiHomologousGraphic2D()
{}
