#include <source/actor/actor_graphic_2D_file_dialog.hpp>


//-----------------bicotiActorGraphic2DFileDialog------------------
bicotiActorGraphic2DFileDialog :: bicotiActorGraphic2DFileDialog( char * act_name ) : bicotiActorGraphic2D( act_name )
{
  actor_case = actor_file_dialog;
  current_directory = new char[ 1 ];
  current_directory[ 0 ] = '\0';

  current_filter = new char[ 2 ];
  current_filter[ 0 ] = '*';
  current_filter[ 1 ] = '\0';

  mode_existing_file = true;
}


bicotiActorGraphic2DFileDialog :: ~bicotiActorGraphic2DFileDialog()
{
  if( current_directory != NULL )
    delete current_directory;

  if( current_filter != NULL )
    delete current_filter;
}


bool bicotiActorGraphic2DFileDialog :: CheckCurrentDirectory( const char * newdir )
{
  if( !strcmp( current_directory, newdir ) )
    return false;
  else
    {if( current_directory != NULL )
      delete current_directory;
    current_directory = new char[strlen(newdir)+1];
    strcpy( current_directory, newdir );
    return true;}
}


void bicotiActorGraphic2DFileDialog :: SetDirectory( const char * direct )
{
  if ( ptr_homologous == NULL )
    FireFileDialogDirectoryChanged( this, direct );
  else 
    ((bicotiHomologousGraphic2DFileDialog*)ptr_homologous)->SetDirectory( direct );
}


void bicotiActorGraphic2DFileDialog :: SetFilter( const char * filter )
{
  if( current_filter != NULL )
    delete[] current_filter;
  
  current_filter = new char[ strlen(filter) + 1 ];
  strcpy( current_filter, filter );

  if( ptr_homologous != NULL )
    ((bicotiHomologousGraphic2DFileDialog*)ptr_homologous)->SetFilter( current_filter );
}


void bicotiActorGraphic2DFileDialog :: SetExistingFile( bool mode )
{
  mode_existing_file = mode;

  if( ptr_homologous != NULL )
    ((bicotiHomologousGraphic2DFileDialog*)ptr_homologous)->SetExistingFile( mode_existing_file );
}


const char * bicotiActorGraphic2DFileDialog :: GetDirectory()
{
  return current_directory;
}


const char * bicotiActorGraphic2DFileDialog :: GetFilter()
{
  return current_filter;
}


bool bicotiActorGraphic2DFileDialog :: GetExistingFile()
{
  return mode_existing_file;
}

