#ifndef _bicoti_actor_graphic_2D_push_button
#define _bicoti_actor_graphic_2D_push_button

#include <source/actor/actor_graphic_2D.hpp>
#include <source/interaction/interaction_push_button.hpp>

//---------------bicotiActorGraphic2DPushButton---------------

/** 
 * Proporciona un botn 
 *
 * Es fuente de eventos de botn
 *@see bicotiHomologousGraphic2DPushButton
 */
class bicotiActorGraphic2DPushButton : public bicotiActorGraphic2D , public bicotiInteractionSourcePushButton
{
private:
  char * local_text;

public:
  
  /** 
   * Constructor
   *
   * Construye un nuevo bicotiActorGraphic2DPushButton
   *@param act_name nombre del actor
   */
  bicotiActorGraphic2DPushButton( char * act_name = NULL );
  ~bicotiActorGraphic2DPushButton();

  /** 
   * Fija el texto del botn
   *
   *@param text texto para el botn
   */ 
  void SetText( char * text );

  /**
   * Devuelve el texto del botn
   *
   *@returns texto actual del botn
   */ 
 char * GetText();

  /** 
   * Simula por software un cliqueo sobre el botn.
   *
   * Si se invoca este mtodo el botn se comportar como si hubieran cliqueado sobre el con el mouse, lanzando inclusive un evento de botn. Esta caracterstica es til para demos.
   */
  void Click();
};

//-----------bicotiHomologousGraphic2DPushButton----------


/** 
 * Homlogo para bicotiActorGraphic2DPushButton
 */
class bicotiHomologousGraphic2DPushButton : public bicotiHomologousGraphic2D
{
public:
  /** Destructor */
  virtual ~bicotiHomologousGraphic2DPushButton();
  
  /** 
   * Simula por software un cliqueeo sobre el botn
   *
   *@see bicotiActorGraphic2DPushButton::Click
   */
  virtual void Click()=0;
  
  /** 
   * Fija el texto del botn  
   *
   *@param text texto para el botn
   *@see bicotiActorGraphic2DPushButton::SetText
   */ 
  virtual void SetText( char * text )=0;
};

#endif
