#ifndef _bicoti_actor_graphic_menu_bar
#define _bicoti_actor_graphic_menu_bar


#include <source/actor/actor_graphic_menu_popup.hpp>

//--------------------DECLARATIONS---------------------
//----------------bicotiActorGraphicMenu-----------------

/**
 * Proporciona una barra de men. 
 *
 * Esta clase representa una barra de men. Es fuente de eventos de men. Puede contener varias items o varios mens popups (submens) pero no puede contener otra barra de men. Al seleccionar un tem se dispara un evento de men.
 El bicotiActorGraphicMenuBar es un actor grfico pero no 2D por consiguiente no puede ser fijado su tamao ni su posicin. Al hacerlo hijo de otro actor (por ejemplo un bicotiActor2DPanel) se ubica en la parte superior  y ocupa todo el ancho del actor. Su tamao se reajusta automticamente para cumplir con la propiedad anterior.
 *@see bicotiHomologousGraphicMenuBar
 */
class bicotiActorGraphicMenuBar : public bicotiActorGraphicMenu
{
public:
  
  /**
   * Constructor.
   * 
   * Construye un nuevo bicotiActorGraphic.
   *@param act_name nombre del actor. 
   */
  bicotiActorGraphicMenuBar( char * act_name = NULL );
  
  /** Destructor */
  virtual ~bicotiActorGraphicMenuBar();
};


//-----------------bicotiHomologousMenuBar------------------

/**
 * Homologo del bicotiActorGraphicMenuBar.
 *
 *@see bicotiActorGraphicMenuBar
 */
class bicotiHomologousGraphicMenuBar : public bicotiHomologousGraphicMenu
{
public:

  /** Destructor **/
  virtual ~bicotiHomologousGraphicMenuBar();
};



#endif
