#include <source/bicoti_basic.hpp>

//-------------BICOTI EXCEPTION  IMPLEMENTATIONS----------------
//---------------------bicotiException--------------------------
bicotiException :: ~bicotiException()
{}

void bicotiException :: ConvertToString( vector< char >& word, int value )
{
  int local_value = value;
  int residue;
  vector< char > local_word;
  
  do
    {residue = local_value % 10;
    local_value /= 10;
    local_word.push_back( '0' + (char)residue );} while( local_value != 0 );
  
  while( !local_word.empty() )
    {word.push_back( local_word.back() );
    local_word.pop_back();}
};


bicotiException :: bicotiException( char * class_name, char * function_name, int error_code )
{
  local_class_name = class_name;
  local_function_name = function_name;
  local_error_code = error_code;
};



bicotiException :: bicotiException( const bicotiException& except_src )
{
  local_class_name = except_src.local_class_name;
  local_function_name = except_src.local_function_name;
  local_error_code = except_src.local_error_code;
};


void bicotiException :: operator=( const bicotiException& except_src )
{
  local_class_name = except_src.local_class_name;
  local_function_name = except_src.local_function_name;
  local_error_code = except_src.local_error_code;  
};


const char * bicotiException :: GetClassName()
{
  return( local_class_name );
};


const char * bicotiException :: GetFunctionName()
{
  return( local_function_name );
};


int bicotiException :: GetErrorCode()
{
  return( local_error_code );
};


void bicotiException :: What()
{
	/*
  ifstream ifile( _error_codes_path );
  istream_iterator< char > file_iter( ifile );
  istream_iterator< char > eof_iter;
  
  vector< char > source( file_iter, eof_iter );
  vector< char > :: iterator first1 = source.begin();
  vector< char > :: iterator last1 = source.end();

  vector< char > pattern;
  ConvertToString( pattern, local_error_code );
  pattern.push_back('_');
  vector< char > :: iterator first2 = pattern.begin();
  vector< char > :: iterator last2 = pattern.end();
  
  first1 = search( first1, last1, first2, last2 );
  
  cerr << endl;
  if( first1 != last1 )
    {cerr << "bicotiException: CLASS " << local_class_name << ": FUNCTION " << local_function_name << endl;
    cerr << "Error code: " << local_error_code << ". ";
    while( *first1++ != '_' );
    while( *first1 != '.' )
      cerr << *first1++;
    cerr << "." << endl;}
  else
    cerr << "Sorry, the error code doesn't exists." << endl;
  cerr << endl;
  */
};

