//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _coordinate_interpolator_function_basic
#define _coordinate_interpolator_function_basic



//*******************************DECLARATIONS***********************************
//------------------bicotiCoordinateInterpolatorFunction------------------------
template< class CoordType >
class bicotiCoordinateInterpolatorFunction : public bicotiFunction< double >
{
public:
  virtual ~bicotiCoordinateInterpolatorFunction(){};

  virtual double operator()( double ) = 0;
  virtual CoordType Evaluate( double ) = 0;
  virtual CoordType EvaluateDer( double ) = 0;
  virtual double EvaluateDerNorm( double ) = 0;
  virtual CoordType EvaluateDer2( double ) = 0;
  virtual CoordType EvaluateDer3( double ) = 0;
};


//-------------bicotiCoordinateInterpolatorFunctionDistance----------------------
template< class CoordType >
class bicotiCoordinateInterpolatorFunctionDistance : public bicotiFunction< double >
{
protected:
  bicotiCoordinateInterpolatorFunction< CoordType> * ptr_function;
  double fun_val, first_val;

public:
  virtual ~bicotiCoordinateInterpolatorFunctionDistance(){};

  virtual double operator()( double );
  virtual double Distance( double, double ) = 0;
  void SetFunction( bicotiCoordinateInterpolatorFunction< CoordType > * );
  void SetFirstVal( double );
  void SetFunVal( double );
};




//*****************************IMPLEMENTATIONS**********************************
//----------------bicotiCoordinateInterpolatorFunctionDistance------------------
template< class CoordType >
double bicotiCoordinateInterpolatorFunctionDistance< CoordType > :: operator()( double t )
{
  return( Distance( first_val, t ) - fun_val );
};


template< class CoordType >
void bicotiCoordinateInterpolatorFunctionDistance< CoordType > :: SetFunction( bicotiCoordinateInterpolatorFunction< CoordType > *  ptr_fun )
{
  ptr_function = ptr_fun;
};


template< class CoordType >
void bicotiCoordinateInterpolatorFunctionDistance< CoordType > :: SetFirstVal( double value )
{
  first_val = value;
};


template< class CoordType >
void bicotiCoordinateInterpolatorFunctionDistance< CoordType > :: SetFunVal( double value )
{
  fun_val = value;
};



#endif       
