#include <source/dexel/dexel_labeling/connectivity_labeling_strategy_basic.hpp>


//******************************IMPLEMENTATIONS**********************************
//--------------------bicotiConnectivityLabelingStrategy-------------------------
/* inline */ void bicotiConnectivityLabelingStrategy :: SetEquivalence( unsigned& equiv_1, unsigned& equiv_2 )
{

  if ( ( equiv_1 != 0 ) && ( equiv_2 != 0 ) && ( equiv_1 <= ptr_equiv_table->size() ) && ( equiv_2 <= ptr_equiv_table->size() ) ) 
    {if ( equiv_1 < equiv_2 ) 
	(*ptr_equiv_table)[ equiv_1 - 1 ].push_back( equiv_2 );
    else
        (*ptr_equiv_table)[ equiv_2 - 1 ].push_back( equiv_1 );}
   else
     throw bicotiException( "bicotiConnectivityLabelingStrategy", "SetEquivalence", 4 );
}


/* inline */ void bicotiConnectivityLabelingStrategy :: InsertInTable( unsigned& label)
{
 if ( label - ( ptr_equiv_table->size() ) == 1 )
   {vector< unsigned > aux_vect( 1 );
    aux_vect[ 0 ] = label;
    ptr_equiv_table->push_back( aux_vect );}
 else
     throw bicotiException( "bicotiConnectivityLabelingStrategy", "InsertInTable", 4 );
}


//----------------------bicotiConnectivityLabelingStrategy2D----------------------
/* inline */ bool bicotiConnectivityLabelingStrategy2D :: InImage( int  x_1, int  x_2 )
{
  return( ( 0 <= x_1 ) && ( 0 <= x_2 ) && ( x_1 < x1_size ) && ( x_2 < x2_size ) );
};


void bicotiConnectivityLabelingStrategy2D :: Initiate( bicotiImageDescriptor * ptr_desc, vector< vector < unsigned > > * ptr_eq_table )
{
  ptr_equiv_table = ptr_eq_table;

  if( ptr_desc->GetDimension() != 2 )
    throw bicotiException( "bicotiConnectivityLabelingStrategy2D", "Initiate()", 2 );

  x1_size = ptr_desc->Size( 0 );
  x2_size = ptr_desc->Size( 1 );
  
  if( ptr_matrix != NULL )
    delete ptr_matrix;
  
  ptr_matrix = new bicotiMatrix2D< unsigned >( 0, x1_size, x2_size );

  delete ptr_desc;
};


bicotiMatrix< unsigned >* bicotiConnectivityLabelingStrategy2D :: CreateResult()
{
  bicotiMatrix2D< unsigned > * ptr_aux;
  ptr_aux = ptr_matrix;
  ptr_matrix = NULL;
  
  return( ptr_aux );
};



//---------------------bicotiConnectivityLabelingStrategy3D-----------------------
/* inline */ bool bicotiConnectivityLabelingStrategy3D :: InImage( int x_1, int x_2, int x_3 )
{
  return( ( 0 <= x_1 ) && ( 0 <= x_2 ) && ( 0 <= x_3 ) && ( x_1 < x1_size ) && ( x_2 < x2_size ) && ( x_3 < x3_size ) );
};


void bicotiConnectivityLabelingStrategy3D :: Initiate( bicotiImageDescriptor * ptr_desc, vector< vector < unsigned > > * ptr_eq_table )
{
  ptr_equiv_table = ptr_eq_table;

  if( ptr_desc->GetDimension() != 3 )
    throw bicotiException( "bicotiConnectivityLabelingStrategy3D", "Initiate()", 2 );

  x1_size = ptr_desc->Size( 0 );
  x2_size = ptr_desc->Size( 1 );
  x3_size = ptr_desc->Size( 2 );
  
  if( ptr_matrix != NULL )
    delete ptr_matrix;
  
  ptr_matrix = new bicotiMatrix3D< unsigned >( 0, x1_size, x2_size, x3_size );

  delete ptr_desc;
};


bicotiMatrix< unsigned > * bicotiConnectivityLabelingStrategy3D :: CreateResult()
{
  bicotiMatrix3D< unsigned > * ptr_aux;
  ptr_aux = ptr_matrix;
  ptr_matrix = NULL;
  
  return( ptr_aux );
};

