//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _pixel_labeling_criterion_vectorial_range
#define _pixel_labeling_criterion_vectorial_range



#include <source/dexel/dexel_labeling/pixel_labeling_criterion_basic.hpp>



//********************************DECLARATIONS***********************************
//-------------------bicotiPixelLabelingCriterionVectorialRange------------------
template< class PixelType >
class bicotiPixelLabelingCriterionVectorialRange :  public bicotiPixelLabelingCriterionVectorial< PixelType >
{
private:
  PixelType start_pixel, end_pixel;
  unsigned colors_number;

public:
  bicotiPixelLabelingCriterionVectorialRange( PixelType, PixelType, bool = true );
  bool operator() ( PixelType );
};



//******************************IMPLEMENTATIONS**********************************
//------------------bicotiPixelLabelingCriterionVectorialRange-------------------
template< class PixelType >
bicotiPixelLabelingCriterionVectorialRange< PixelType > :: bicotiPixelLabelingCriterionVectorialRange( PixelType start_pix, PixelType end_pix, bool val_dir ) 
{

  if ( start_pix.GetColorsNumber() == end_pix.GetColorsNumber() )
    { unsigned i;
      for( i = 0; i < start_pix.GetColorsNumber(); i++)
	if ( start_pix(i) > end_pix(i) )
	   throw bicotiException( "bicotiPixelLabelingCriterionVectorialRange", "Constructor", 4 );}
  else
    throw bicotiException( "bicotiPixelLabelingCriterionVectorialRange", "Constructor", 3 );
    
  start_pixel = start_pix;
  end_pixel = end_pix;
  colors_number = start_pix.GetColorsNumber();
  direct = val_dir;
};


template< class PixelType >
inline bool bicotiPixelLabelingCriterionVectorialRange< PixelType > :: operator() ( PixelType value )
{
  bool in_range = true;
  unsigned i;

#ifdef TOTAL_CHECK
  if ( value.GetColorsNumber() != colors_number )
   throw bicotiException( "bicotiPixelLabelingCriterionVectorialRange", "operator ()", 2 );
#endif

  for( i = 0; i < colors_number; i++ )
    in_range = ( start_pixel( i ) <= value( i ) ) && ( value( i ) <= end_pixel( i ) ) && in_range;    

  if( direct )
    return ( in_range );
  else
    return( !in_range );
};


#endif
