#ifndef _bicoti_event_loop_manager_basic
#define _bicoti_event_loop_manager_basic


#include <source/interaction/interaction_process.hpp>


//--------------------DECLARATIONS---------------------
//---------------bicotiEventLoopManager----------------
/**
 * Controla el loop de eventos
 *
 * Existe una especializacin para cada biblioteca grfica usada.
 */
class bicotiEventLoopManager : public bicotiInteractionSourceProcess
{
protected:

  /**
   * Fija el event loop para todos los actores
   *
   * Permite que los actores que son main actor puedan conocer el loop de eventos
   *@para ptr_el puntero al loop de eventos
   */
  void SetCurrentEventLoop( bicotiEventLoopManager * ptr_el );

public:
  /**
   * Comienza el loop de eventos
   * 
   * Hasta no comenzar el loop de eventos no se recibirn eventos
   *@see #Stop
   */
  virtual void Start()=0;

  /**
   * Finaliza el event loop
   *
   *@see #Start
   */
  virtual void Stop()=0;
};


#endif
