#include <source/event_loop_manager/qt/actor_image_2D_char_qt.hpp>


//********************IMPLEMENTATIONS*************************
bicotiActorImage2DCharQT :: bicotiActorImage2DCharQT( unsigned x0_size, unsigned x1_size, char * name )
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< unsigned char >( 0, x0_size, x1_size, 1, single, name );
}


bicotiActorImage2DCharQT :: bicotiActorImage2DCharQT()
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< unsigned char >( 0, 0, 0, 1, single);
}


bicotiActorImage2DCharQT :: ~bicotiActorImage2DCharQT()
{
  DeleteMe();
  
  if( ptr_mapper != NULL )
    delete ptr_mapper;
}


bicotiActorGraphic2DImage< unsigned char > * bicotiActorImage2DCharQT :: GetActor()
{
  return( (bicotiActorGraphic2DImage< unsigned char > *)(ptr_implementation) );
}


void bicotiActorImage2DCharQT :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  DestroyMapper(); // NO VA

  ptr_implementation = new bicotiActorGraphic2DImage< unsigned char >( 0, x0_size, x1_size, 1, single);
}


void bicotiActorImage2DCharQT :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;

  ptr_mapper = new bicotiMapperFacade2D< unsigned char , bicotiPixelConverterChar2RGBA >( GetImplementation() );
}

