#ifndef _actor_image_2D_char_qt
#define _actor_image_2D_char_qt

#include <source/image/image_2D_single.hpp>
#include <source/image/actor_image_2D.hpp>
#include <source/event_loop_manager/qt/pixel_converter_qt.hpp>
#include <source/event_loop_manager/qt/event_loop_manager_qt.hpp>



//**********************DECLARATIONS**************************

/** Fachada para implementacin QT de bicotiActorImage para pixel tipo char*/

class bicotiActorImage2DCharQT : public bicotiActorImage2D< unsigned char, bicotiHomologousFactoryQT< unsigned char, bicotiPixelConverterChar2QRGB >, bicotiEventLoopManagerQT, bicotiPixelConverterChar2QRGB >, public bicotiImage2DSingle< bicotiActorGraphic2DImage< unsigned char > , unsigned char, bicotiPixelConverterChar2RGBA >
{
public:

 /** 
   * Constructor 
   *
   *@param x0_size ancho de la imagen
   *@param x1_size altura de la imagen
   *@param name nombre del actor
   */
  bicotiActorImage2DCharQT( unsigned, unsigned, char * );
  
  /** Constructor por defecto */
  bicotiActorImage2DCharQT();
  
  /** Destructor */
  ~bicotiActorImage2DCharQT();

 /** 
   * Devuelve un puntero al actor
   *
   *@returns puntero al actor
   */  
  bicotiActorGraphic2DImage< unsigned char > * GetActor();
  
  /**
   * Construye una implementacin de imagen
   *
   *@param x0_size ancho de la imagen 
   *@param x1_size altura de la imagen
   */
  void BuildImplementation( unsigned, unsigned );
  
  /** Construye una fachada de mapper */
  void BuildMapper();
};



#endif
