#include <source/event_loop_manager/qt/actor_image_2D_double_qt.hpp>


//********************IMPLEMENTATIONS*************************
bicotiActorImage2DDoubleQT :: bicotiActorImage2DDoubleQT( unsigned x0_size, unsigned x1_size, char * name )
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< double >( 0, x0_size, x1_size, 1, single, name );
}


bicotiActorImage2DDoubleQT :: bicotiActorImage2DDoubleQT()
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< double >( 0, 0, 0, 1, single);
}


bicotiActorImage2DDoubleQT :: ~bicotiActorImage2DDoubleQT()
{
  DeleteMe();
  
  if( ptr_mapper != NULL )
    delete ptr_mapper;
}


bicotiActorGraphic2DImage< double > * bicotiActorImage2DDoubleQT :: GetActor()
{
  return( (bicotiActorGraphic2DImage< double > *)(ptr_implementation) );
}


void bicotiActorImage2DDoubleQT :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  DestroyMapper();

  ptr_implementation = new bicotiActorGraphic2DImage< double >( 0, x0_size, x1_size, 1, single);
}


void bicotiActorImage2DDoubleQT :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;

  ptr_mapper = new bicotiMapperFacade2D< double , bicotiPixelConverterDouble2RGBA >( GetImplementation() );
}

