#ifndef _actor_image_2D_double_qt
#define _actor_image_2D_double_qt

#include <source/image/image_2D_single.hpp>
#include <source/image/actor_image_2D.hpp>
#include <source/event_loop_manager/qt/pixel_converter_qt.hpp>
#include <source/event_loop_manager/qt/event_loop_manager_qt.hpp>



//**********************DECLARATIONS**************************

/** Fachada para implementacin QT de bicotiActorImage para pixel tipo double */
class bicotiActorImage2DDoubleQT : public bicotiActorImage2D< double, bicotiHomologousFactoryQT< double, bicotiPixelConverterDouble2QRGB >, bicotiEventLoopManagerQT, bicotiPixelConverterDouble2QRGB >, public bicotiImage2DSingle< bicotiActorGraphic2DImage< double > , double, bicotiPixelConverterDouble2RGBA >
{
public:
 
 /** 
   * Constructor 
   *
   *@param x0_size ancho de la imagen
   *@param x1_size altura de la imagen
   *@param name nombre del actor
   */
  bicotiActorImage2DDoubleQT( unsigned, unsigned, char * );
 

  /** Constructor por defecto */
  bicotiActorImage2DDoubleQT();
  
  /** Destructor */
  ~bicotiActorImage2DDoubleQT();

  
  /** 
   * Devuelve un puntero al actor
   *
   *@returns puntero al actor
   */
  bicotiActorGraphic2DImage< double > * GetActor();
  
  /**
   * Construye una implementacin de imagen
   *
   *@param x0_size ancho de la imagen 
   *@param x1_size altura de la imagen
   */
  void BuildImplementation( unsigned, unsigned );
  
  /** Construye una fachada de mapper */
  void BuildMapper();
};



#endif
