#include <source/event_loop_manager/qt/actor_image_2D_hsv_int_qt.hpp>


//********************IMPLEMENTATIONS*************************
bicotiActorImage2DHSVIntQT :: bicotiActorImage2DHSVIntQT( unsigned x0_size, unsigned x1_size, char * name )
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiHSV< unsigned int, REAL > >( bicotiHSV< unsigned int, REAL >(0,0,0), x0_size, x1_size, 1, vectorial, name );
}


bicotiActorImage2DHSVIntQT :: bicotiActorImage2DHSVIntQT()
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiHSV< unsigned int, REAL > >( bicotiHSV< unsigned int, REAL >(0,0,0), 0, 0, 1, vectorial );
}


bicotiActorImage2DHSVIntQT :: ~bicotiActorImage2DHSVIntQT()
{
  DeleteMe();
  
  if( ptr_mapper != NULL )
    delete ptr_mapper;
}


bicotiActorGraphic2DImage< bicotiHSV< unsigned int, REAL > > * bicotiActorImage2DHSVIntQT :: GetActor()
{
  return( (bicotiActorGraphic2DImage< bicotiHSV< unsigned int, REAL > > *)(ptr_implementation) );
}


void bicotiActorImage2DHSVIntQT :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  DestroyMapper();

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiHSV< unsigned int, REAL > >( bicotiHSV< unsigned int, REAL >(0,0,0), x0_size, x1_size, 1, vectorial );  
}


void bicotiActorImage2DHSVIntQT :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;

  ptr_mapper = new bicotiMapperFacade2D< bicotiHSV< unsigned int, REAL > , bicotiPixelConverterHSVInt2RGBA >( GetImplementation() );
}

