#include <source/event_loop_manager/qt/actor_image_2D_rgb_char_qt.hpp>


//********************IMPLEMENTATIONS*************************
bicotiActorImage2DRGBCharQT :: bicotiActorImage2DRGBCharQT( unsigned x0_size, unsigned x1_size, char * name )
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiRGB< unsigned char, REAL > >( bicotiRGB< unsigned char, REAL >(0,0,0), x0_size, x1_size, 1, vectorial, name );
}


bicotiActorImage2DRGBCharQT :: bicotiActorImage2DRGBCharQT()
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiRGB< unsigned char, REAL > >( bicotiRGB< unsigned char, REAL >(0,0,0), 0, 0, 1, vectorial );
}


bicotiActorImage2DRGBCharQT :: ~bicotiActorImage2DRGBCharQT()
{
  DeleteMe();
  
  if( ptr_mapper != NULL )
    delete ptr_mapper;
}


bicotiActorGraphic2DImage< bicotiRGB< unsigned char, REAL > > * bicotiActorImage2DRGBCharQT :: GetActor()
{
  return( (bicotiActorGraphic2DImage< bicotiRGB< unsigned char, REAL > > *)(ptr_implementation) );
}


void bicotiActorImage2DRGBCharQT :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  DestroyMapper();

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiRGB< unsigned char, REAL > >( bicotiRGB< unsigned char, REAL >(0,0,0), x0_size, x1_size, 1, vectorial );  
}


void bicotiActorImage2DRGBCharQT :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;

  ptr_mapper = new bicotiMapperFacade2D< bicotiRGB< unsigned char, REAL > , bicotiPixelConverterRGBChar2RGBA >( GetImplementation() );
}

