#include <source/event_loop_manager/qt/actor_image_2D_rgb_float_qt.hpp>


//********************IMPLEMENTATIONS*************************
bicotiActorImage2DRGBFloatQT :: bicotiActorImage2DRGBFloatQT( unsigned x0_size, unsigned x1_size, char * name )
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiRGB< float, REAL > >( bicotiRGB< float, REAL >(0,0,0), x0_size, x1_size, 1, vectorial, name );
}


bicotiActorImage2DRGBFloatQT :: bicotiActorImage2DRGBFloatQT()
{
  ResetPointers();
  ptr_mapper = NULL;

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiRGB< float, REAL > >( bicotiRGB< float, REAL >(0,0,0), 0, 0, 1, vectorial );
}


bicotiActorImage2DRGBFloatQT :: ~bicotiActorImage2DRGBFloatQT()
{
  DeleteMe();
  
  if( ptr_mapper != NULL )
    delete ptr_mapper;
}


bicotiActorGraphic2DImage< bicotiRGB< float, REAL > > * bicotiActorImage2DRGBFloatQT :: GetActor()
{
  return( (bicotiActorGraphic2DImage< bicotiRGB< float, REAL > > *)(ptr_implementation) );
}


void bicotiActorImage2DRGBFloatQT :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  DestroyMapper();

  ptr_implementation = new bicotiActorGraphic2DImage< bicotiRGB< float, REAL > >( bicotiRGB< float, REAL >(0,0,0), x0_size, x1_size, 1, vectorial );  
}


void bicotiActorImage2DRGBFloatQT :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;

  ptr_mapper = new bicotiMapperFacade2D< bicotiRGB< float, REAL > , bicotiPixelConverterRGBFloat2RGBA >( GetImplementation() );
}

