#ifndef _bicoti_homologous_qt_2D_field
#define _bicoti_homologous_qt_2D_field


#include <qlineedit.h>
#include <qstring.h>
#include <source/actor/actor_graphic_2D_field.hpp>
#include <source/event_loop_manager/qt/homologous_qt_caster.hpp>


//-----------------bicotiQT2DField------------------

/** Implementacin QT de bicotiHomologousGraphic2DField */
class bicotiQT2DField : public QLineEdit,  public bicotiHomologousGraphic2DField
{
private:

  /**@#-*/
Q_OBJECT
/**@#+*/

public /**@#-*/ slots /**@#+*/ :

/**
 * Slot: se ejecuta cuando se modifica el contenido del campo
 *
 *@param new_text texto modificado
 */  
  void FieldChanged( const char * new_text);

  /**
   * Slot: se ejecuta cuando se presiona enter
   *
   */
  void ReturnPressed();
 
public:
   /**
   * Constructor
   *
   *@param parent widget padre
   *@param name nombre del homlogo
   */
  bicotiQT2DField( QWidget * parent=0, const char * name=0 );
  
  /** Destructor */
  ~bicotiQT2DField();

  void SetText( const char  * );
  
  void SetFrame( bool );
  void SetEchoMode( bicotiEchoMode );
  void SetCursorPosition( int );
  int GetCursorPosition();
  void SetMaxLength( int );
  void SelectAll();

#include <source/event_loop_manager/qt/homologous_qt_graphic.hpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_2D.hpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic2.hpp>
};


#endif
