#ifndef _bicoti_homologous_qt_2D_file_dialog
#define _bicoti_homologous_qt_2D_file_dialog


#include <source/actor/actor_graphic_2D_file_dialog.hpp>
#include <source/event_loop_manager/qt/homologous_qt_caster.hpp>
#include <qfiledialog.h>


//--------------------DECLARATIONS---------------------
//------------------bicotiQT2DFileDialog--------------------

/** Implementacin QT de bicotiHomologousGraphic2DFileDialog */
class bicotiQT2DFileDialog : public QFileDialog, public bicotiHomologousGraphic2DFileDialog
{
  /**@#-*/
Q_OBJECT
/**@#+*/

public /**@#-*/ slots /**@#+*/ :

/** 
 * Slot: se ejecuta cuando se selecciona una carpeta 
 *
 * Este slot no funciona debido a un bug de QT 
 *@param new_dir nombre de la carpeta seleccionada
 */
  void DirEntered( const char * new_dir );
 
  /**
   * Slot: se ejecuta cuando se destaca un archivo
   *
   *@param file nombre del archivo destacado
   */ 
  void FileHighlighted( const char * file );
  
  /**
   * Slot: se ejecuta cuando se selecciona un archivo
   *
   *@param file nombre del archivo seleccionado
   */
  void FileSelected( const char * file );
  
public:
  
  /**
   * Constructor 
   *
   *@param parent widget padre
   *@param name nombre del widget
   */
  bicotiQT2DFileDialog( QWidget * parent=0, const char * name=0 );
 
  /** Destructor */
  ~bicotiQT2DFileDialog();

  void MousePress( int, int, char );
  void MouseRelease( int, int, char );

  void SetDirectory( const char * );
  void SetFilter( const char * );
  void SetExistingFile( bool );

#include <source/event_loop_manager/qt/homologous_qt_graphic.hpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_2D.hpp>
};


#endif
