#ifndef _pixel_converter
#define _pixel_converter


#include <source/actor/actor.hpp>
#include <source/pixel/pixel.hpp>
#include <qimage.h>

/** Mapea un pixel RGBA de bicoti en un QRGB de QT  y viceversa */
class bicotiPixelConverterRGBA2QRGB
{
public:
  static const QRgb Convert( const bicotiPixelRGBA& );
  static const bicotiPixelRGBA Unconvert( const QRgb& );
};

/** Mapea un pixel Char de bicoti en un QRGB de QT  y viceversa */
class bicotiPixelConverterChar2QRGB
{
public:
  static const QRgb Convert( const unsigned char );
  static const unsigned char Unconvert( const QRgb );
};

/** Mapea un pixel Double de bicoti en un QRGB de QT  y viceversa */
class bicotiPixelConverterDouble2QRGB
{
public:
  static const QRgb Convert( const double );
  static const double Unconvert( const QRgb );
};

/** Mapea un pixel RGBChar  de bicoti en un QRGB de QT  y viceversa */
class bicotiPixelConverterRGBChar2QRGB
{
public:
  static const QRgb Convert( const bicotiRGB< unsigned char, REAL > );
  static const bicotiRGB< unsigned char, REAL > Unconvert( const QRgb );
};

/** Mapea un pixel Float de bicoti en un QRGB de QT  y viceversa */
class bicotiPixelConverterRGBFloat2QRGB
{
public:
  static const QRgb Convert( const bicotiRGB< float, REAL > );
  static const bicotiRGB< float, REAL > Unconvert( const QRgb );
};

/** Mapea un pixel HSVInt de bicoti en un QRGB de QT  y viceversa */
class bicotiPixelConverterHSVInt2QRGB
{
private:
  static unsigned int Maximum( unsigned int, unsigned int, unsigned int );

public:
  static const QRgb Convert( const bicotiHSV< unsigned int, REAL > );
  static const bicotiHSV< unsigned int, REAL > Unconvert( const QRgb );
};




#endif
