#ifndef _actor_image_2D
#define _actor_image_2D


#include <source/actor/actor_graphic_2D_image.hpp>


//**********************DECLARATIONS**************************

/** 
 *Fachada de imagen para bicotiActorGraphic2DImage 
 *
 *@see bicotiActorImage2DCharQT
 *@see bicotiActorImage2DDoubleQT
 *@see bicotiActorImage2DHSVIntQT
 *@see bicotiActorImage2DRGBCharQT
 *@see bicotiActorImage2DRGBFloatQT
 */
template< class PixelType, class FactoryType, class EventLoopManagerType, class PixelConverterFactory >
class bicotiActorImage2D
{
public:

  /** Tipo adecuado de la instancia de bicotiActorGraphic2DImage */

  typedef bicotiActorGraphic2DImage< PixelType > Actor;
  
  /** Tipo adecuado del Factory 
   *
   *@see bicotiHomologousFactory
   */
  typedef FactoryType HomologousFactory;
  
  /** 
   * Tipo adecuado del EventLoopManager 
   *
   *@see bicotiEventLoopManager
   */
  typedef EventLoopManagerType EventLoopManager;

  /** Devuelve un puntero al actor */
  virtual bicotiActorGraphic2DImage< PixelType > * GetActor() = 0;
};





#endif
