#include <source/image/image_2D_array_char.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage2DArrayChar :: bicotiImage2DArrayChar(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DArray< unsigned char >( 0, x0_size, x1_size, 1, single);
};


bicotiImage2DArrayChar :: bicotiImage2DArrayChar()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DArray< unsigned char >( 0, 0, 0, 1, single);
};


bicotiImage2DArrayChar :: ~bicotiImage2DArrayChar()
{
  DeleteMe();
};


void bicotiImage2DArrayChar :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  
  ptr_implementation = new bicotiImageImplementation2DArray< unsigned char >( 0, x0_size, x1_size, 1, single );
};


void bicotiImage2DArrayChar :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< unsigned char , bicotiPixelConverterChar2RGBA >( GetImplementation() );
}

