#include <source/image/image_2D_array_double.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage2DArrayDouble :: bicotiImage2DArrayDouble(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();
  
  ptr_implementation = new bicotiImageImplementation2DArray< double >( 0, x0_size, x1_size, 1, single );
};


bicotiImage2DArrayDouble :: bicotiImage2DArrayDouble()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DArray< double >( 0, 0, 0, 1, single );
};


bicotiImage2DArrayDouble :: ~bicotiImage2DArrayDouble()
{
  DeleteMe();
};


void bicotiImage2DArrayDouble :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();

  ptr_implementation = new bicotiImageImplementation2DArray< double >( 0, x0_size, x1_size, 1, single );
};



void bicotiImage2DArrayDouble :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< double , bicotiPixelConverterDouble2RGBA >( GetImplementation() );
}

