#include <source/image/image_2D_array_hsv_int.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage2DArrayHSVInt :: bicotiImage2DArrayHSVInt(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();

  bicotiHSV< unsigned int, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DArray< bicotiHSV< unsigned int, REAL > >( def_pix, x0_size, x1_size, 1, vectorial);
}


bicotiImage2DArrayHSVInt :: bicotiImage2DArrayHSVInt()
{
  ResetPointers();

  bicotiHSV< unsigned int, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DArray< bicotiHSV< unsigned int, REAL > >( def_pix, 0, 0, 1, vectorial);
}


bicotiImage2DArrayHSVInt :: ~bicotiImage2DArrayHSVInt()
{
  DeleteMe();
}


void bicotiImage2DArrayHSVInt :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();

  bicotiHSV< unsigned int, REAL > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation2DArray< bicotiHSV< unsigned int, REAL > >( def_pix, x0_size, x1_size, 1, vectorial );
}


void bicotiImage2DArrayHSVInt :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< bicotiHSV< unsigned int, REAL >, bicotiPixelConverterHSVInt2RGBA >( GetImplementation() );
}

