#include <source/image/image_2D_sparse_char.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage2DSparseChar :: bicotiImage2DSparseChar(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DSparse< unsigned char >( 0, x0_size, x1_size, 1, single);
};


bicotiImage2DSparseChar :: bicotiImage2DSparseChar()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DSparse< unsigned char >( 0, 0, 0, 1, single);
};


bicotiImage2DSparseChar :: ~bicotiImage2DSparseChar()
{
  DeleteMe();
};


void bicotiImage2DSparseChar :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  
  ptr_implementation = new bicotiImageImplementation2DSparse< unsigned char >( 0, x0_size, x1_size, 1, single );
};


void bicotiImage2DSparseChar :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< unsigned char , bicotiPixelConverterChar2RGBA >( GetImplementation() );
}

