#include <source/image/image_2D_sparse_float.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage2DSparseFloat :: bicotiImage2DSparseFloat(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();
  
  ptr_implementation = new bicotiImageImplementation2DSparse< float >( 0, x0_size, x1_size, 1, single );
};


bicotiImage2DSparseFloat :: bicotiImage2DSparseFloat()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DSparse< float >( 0, 0, 0, 1, single );
};


bicotiImage2DSparseFloat :: ~bicotiImage2DSparseFloat()
{
  DeleteMe();
};


void bicotiImage2DSparseFloat :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();

  ptr_implementation = new bicotiImageImplementation2DSparse< float >( 0, x0_size, x1_size, 1, single );
};


void bicotiImage2DSparseFloat :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< float , bicotiPixelConverterFloat2RGBA >( GetImplementation() );
}

