//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _image_2D_vectorial 
#define _image_2D_vectorial 

 
 
#include <source/image/image_2D.hpp>
 
 
 
//**********************DECLARATIONS************************** 
template< class ImageType, class ColorType, class PixelConverterMapper, class PixelType, class PrecisionType = PixelType >
class bicotiImage2DVectorial : public bicotiImage2D< ImageType, ColorType, PixelConverterMapper, PixelType, PrecisionType >
{ 
public: 
  void BuildProperty(); 
  bicotiPropertyFacade< bicotiCoordinate2D< INTEGER >, ColorType, PixelType, PrecisionType >* CreateProperty(); 
   
  void BuildNeighbourFilter(); 
  bicotiNeighbourFilterFacade2D< PixelType, PrecisionType >* CreateNeighbourFilter(); 
  void BuildDexel(); 
  bicotiDexelFacade2DVectorial< PixelType >* CreateDexel(); 
}; 
 

 
 
//********************IMPLEMENTATIONS************************* 
template< class ImageType, class ColorType, class PixelConverterMapper, class PixelType, class PrecisionType > 
void bicotiImage2DVectorial< ImageType, ColorType, PixelConverterMapper, PixelType, PrecisionType > :: BuildProperty() 
{ 
  if( ptr_property != NULL ) 
    delete ptr_property; 
   
  ptr_property = new bicotiPropertyFacadeVectorial< bicotiCoordinate2D< INTEGER >, ColorType ,PixelType ,PrecisionType >( ptr_implementation ); 
}
 
 
template< class ImageType, class ColorType, class PixelConverterMapper, class PixelType, class PrecisionType > 
bicotiPropertyFacade< bicotiCoordinate2D< INTEGER >, ColorType, PixelType, PrecisionType >* bicotiImage2DVectorial< ImageType, ColorType, PixelConverterMapper, PixelType, PrecisionType > :: CreateProperty() 
{ 
  return ( new bicotiPropertyFacadeVectorial< bicotiCoordinate2D< INTEGER >, ColorType, PixelType, PrecisionType >( ptr_implementation )); 
}; 
 
 
template< class ImageType, class ColorType, class PixelConverterMapper, class PixelType, class PrecisionType > 
void bicotiImage2DVectorial< ImageType, ColorType, PixelConverterMapper, PixelType, PrecisionType > :: BuildNeighbourFilter() 
{ 
  if( ptr_neighbour_filter != NULL ) 
    delete ptr_neighbour_filter; 
 
  ptr_neighbour_filter = new bicotiNeighbourFilterFacade2DVectorial< ColorType, PixelType, PrecisionType > ( ptr_implementation ); 
}; 
 
 
template< class ImageType, class ColorType, class PixelConverterMapper, class PixelType, class PrecisionType > 
bicotiNeighbourFilterFacade2D< PixelType, PrecisionType >* bicotiImage2DVectorial< ImageType, ColorType, PixelConverterMapper, PixelType, PrecisionType > :: CreateNeighbourFilter() 
{ 
  return( new bicotiNeighbourFilterFacade2DVectorial< ColorType, PixelType, PrecisionType > ( ptr_implementation ) ); 
}; 
 
 
template< class ImageType, class ColorType, class PixelConverterMapper, class PixelType, class PrecisionType > 
void bicotiImage2DVectorial< ImageType, ColorType, PixelConverterMapper, PixelType, PrecisionType > :: BuildDexel() 
{ 
  if( ptr_dexel != NULL ) 
    delete ptr_dexel; 
 
  ptr_dexel = new bicotiDexelFacade2DVectorial< PixelType >( ptr_implementation ); 
 
}; 
 

template< class ImageType, class ColorType, class PixelConverterMapper, class PixelType, class PrecisionType > 
bicotiDexelFacade2DVectorial< PixelType > * bicotiImage2DVectorial< ImageType, ColorType, PixelConverterMapper, PixelType, PrecisionType > :: CreateDexel() 
{ 
  return( new bicotiDexelFacade2DVectorial< PixelType >( ptr_implementation ) ); 
}; 
 
#endif 
