//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _image_extrapolation_strategy_2D_simetric
#define _image_extrapolation_strategy_2D_simetric



#include <source/image_implementation/image_extrapolation_strategy_2D.hpp>

 
 
//***********************************DECLARATIONS***********************************
//--------------------bicotiImageExtrapolationStrategy2DSimetric--------------------
template< class PixelType >  
class bicotiImageExtrapolationStrategy2DSimetric : public bicotiImageExtrapolationStrategy2D< PixelType > 
{ 
public: 
  bicotiImageExtrapolationStrategy2DSimetric(){}; 
  ~bicotiImageExtrapolationStrategy2DSimetric(){}; 
   
  PixelType operator() ( int, int ); 
}; 
 



//*********************************IMPLEMENTATIONS********************************************
//------------------------------bicotiImageExtrapolationStrategy2DSimetric--------------------
template< class PixelType >  
PixelType bicotiImageExtrapolationStrategy2DSimetric< PixelType > :: operator() ( int x_0, int x_1 ) 
{ 
  if ( ( 0 <= x_0 ) && ( 0 <= x_1 ) && ( x_0 < ptr_image->GetX0Size() ) && ( x_1 < ptr_image->GetX1Size() ) ) 
    return ( ptr_image->GetPixel( x_0, x_1 ) ); 
  else 
    {if ( x_0 < 0 ) 
      {if ( x_1 < 0 ) 
	return ( ptr_image->GetPixel( -x_0 , -x_1 ) ); 
      else 
	{if ( x_1 >= ptr_image->GetX1Size() ) 
	  return ( ptr_image->GetPixel( -x_0, 2 * ptr_image->GetX1Size() - x_1 - 2 ) );
	else 
	  return ( ptr_image->GetPixel( -x_0 , x_1 ) );}} 
    else 
      {if ( x_0 >= ptr_image->GetX0Size() ) 
	{if ( x_1 < 0 ) 
	  return ( ptr_image->GetPixel( 2 * ptr_image->GetX0Size() - x_0 - 2, -x_1 ) ); 
	else 
	  {if ( x_1 >= ptr_image->GetX1Size() ) 
	    return ( ptr_image->GetPixel( 2 * ptr_image->GetX0Size() - x_0 - 2, 2 * ptr_image->GetX1Size() - x_1 - 2) ); 
	  else 
	    return ( ptr_image->GetPixel( 2 * ptr_image->GetX0Size() - x_0 - 2, x_1) );}} 
      else 
	{if ( x_1 < 0 ) 
	  return ( ptr_image->GetPixel( x_0, -x_1 ) ); 
	else 
	  return ( ptr_image->GetPixel( x_0, 2 * ptr_image->GetX1Size() - x_1 - 2) );}}} 
   
};


#endif
