//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _image_extrapolation_strategy_3D_ciclic
#define _image_extrapolation_strategy_3D_ciclic



#include <source/image_implementation/image_extrapolation_strategy_3D.hpp>



//***********************************DECLARATIONS************************************
//-------------------bicotiImageExtrapolationStrategy3DCiclic------------------------
template< class PixelType >   
class bicotiImageExtrapolationStrategy3DCiclic : public bicotiImageExtrapolationStrategy3D< PixelType >  
{  
public:  
  bicotiImageExtrapolationStrategy3DCiclic(){};  
  ~bicotiImageExtrapolationStrategy3DCiclic(){};  
  
  PixelType operator() ( int, int, int );  
};  
  


//*********************************IMPLEMENTATIONS***********************************
//--------------------bicotiImageExtrapolationStrategy3DCiclic-----------------------
template< class PixelType >  
PixelType bicotiImageExtrapolationStrategy3DCiclic< PixelType > :: operator() ( int x_0, int x_1, int x_2 ) 
{ // Pensar en un chequeo mas estricto
  if ( ( 0 <= x_0 ) && ( 0 <= x_1 ) && ( 0 <= x_2 ) && ( x_0 < ptr_image->GetX0Size() ) && ( x_1 < ptr_image->GetX1Size() )   && ( x_2 < ptr_image->GetX2Size() ) ) 
    return ( ptr_image->GetPixel( x_0, x_1, x_2 ) );
  else
    {if ( x_0 < 0  )
      {if ( x_1 < 0 )
	{if ( x_2 < 0 ) 
	  return( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0, ptr_image->GetX1Size() + x_1, ptr_image->GetX2Size() + x_2 ) ); 
	else  
	  {if ( x_2 >= ptr_image->GetX2Size() )
	    return( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0, ptr_image->GetX1Size() + x_1, x_2 - ptr_image->GetX2Size() ) ); 
	  else  
	    return ( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0, ptr_image->GetX1Size() + x_1, x_2 ) );}} 
      else
	{ if ( x_1 >= ptr_image->GetX2Size() )
	  {if ( x_2 < 0 )
	    return( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0, x_1 - ptr_image->GetX1Size(), ptr_image->GetX2Size() + x_2 ) ); 
	  else  
	    {if ( x_2 >= ptr_image->GetX2Size() )
	      return ( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0, x_1 - ptr_image->GetX1Size(), x_2 - ptr_image->GetX2Size() ) ); 
	    else  
	      return ( ptr_image->GetPixel(ptr_image->GetX0Size() + x_0, x_1 - ptr_image->GetX1Size(), x_2 ) );}} 
	else  
	  {if ( x_2 < 0 ) 
	    return ( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0, x_1, ptr_image->GetX2Size() + x_2 ) ); 
	  else 
	    {if ( x_2 >= ptr_image->GetX2Size() )
	      return ( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0 , x_1, x_2 - ptr_image->GetX2Size() ) ); 
	    else  
	      return ( ptr_image->GetPixel( ptr_image->GetX0Size() + x_0 , x_1, x_2 ) );}}}} 
    else 
      {if ( x_0 >= ptr_image->GetX0Size() )
	{if ( x_1 < 0 )
	  {if ( x_2 < 0 ) 
	    return( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), ptr_image->GetX1Size() + x_1, ptr_image->GetX2Size() + x_2 ) ); 
	  else 
	    {if ( x_2 >= ptr_image->GetX2Size() )
	      return ( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), ptr_image->GetX1Size() + x_1, x_2 - ptr_image->GetX2Size() ) ); 
	    else 
	      return ( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), ptr_image->GetX1Size() + x_1, x_2 ) );}} 
	else  
	  {if ( x_1 >= ptr_image->GetX2Size() )
	    {if ( x_2 < 0 )  
	      return ( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), x_1 - ptr_image->GetX1Size(), ptr_image->GetX2Size() + x_2 ) ); 
	    else 
	      {if ( x_2 >= ptr_image->GetX2Size() )
		return ( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), x_1 - ptr_image->GetX1Size(), x_2 - ptr_image->GetX2Size() ) ); 
	      else 
		return ( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), x_1 - ptr_image->GetX1Size(), x_2 ) );}} 
	  else 
	    {if ( x_2 < 0 )
	      return( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), x_1, ptr_image->GetX2Size() + x_2 ) ); 
	    else 
	      {if ( x_2 >= ptr_image->GetX2Size() )
		return ( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size(), x_1, x_2 - ptr_image->GetX2Size() ) ); 
	      else 
		return ( ptr_image->GetPixel( x_0 - ptr_image->GetX0Size() , x_1, x_2 ) );}}}} 
      else
	{if ( x_1 < 0 )
	  {if ( x_2 < 0 )
	    return ( ptr_image->GetPixel( x_0, ptr_image->GetX1Size() + x_1, ptr_image->GetX2Size() + x_2 ) ); 
	  else 
	    {if ( x_2 >= ptr_image->GetX2Size() )
	      return ( ptr_image->GetPixel( x_0, ptr_image->GetX1Size() + x_1, x_2 - ptr_image->GetX2Size() ) ); 
	    else
	      return ( ptr_image->GetPixel( x_0, ptr_image->GetX1Size() + x_1, x_2 ) );}} 
	else
	  {if ( x_1 >= ptr_image->GetX2Size() )
	    {if ( x_2 < 0 )
	      return ( ptr_image->GetPixel( x_0, x_1 - ptr_image->GetX1Size(), ptr_image->GetX2Size() + x_2 ) ); 
	    else 
	      {if ( x_2 >= ptr_image->GetX2Size() )
		return ( ptr_image->GetPixel( x_0, x_1 - ptr_image->GetX1Size(), x_2 - ptr_image->GetX2Size() ) ); 
	      else 
		return ( ptr_image->GetPixel( x_0, x_1 - ptr_image->GetX1Size(), x_2 ) );}} 
	  else
	    {if ( x_2 < 0 )
	      return ( ptr_image->GetPixel( x_0, x_1, ptr_image->GetX2Size() + x_2 ) ); 
	    else 
	      return ( ptr_image->GetPixel( x_0 , x_1, x_2 - ptr_image->GetX2Size() ) );}}}}}       
}; 



#endif
