//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _image_extrapolation_strategy_3D_constant
#define _image_extrapolation_strategy_3D_constant



#include <source/image_implementation/image_extrapolation_strategy_3D.hpp>



//*************************************DECLARATIONS**********************************
//---------------------bicotiImageExtrapolationStrategy3DConstant--------------------
template< class PixelType >   
class bicotiImageExtrapolationStrategy3DConstant : public bicotiImageExtrapolationStrategy3D< PixelType >  
{  
private:  
  PixelType default_pixel;  
  
public:  
  bicotiImageExtrapolationStrategy3DConstant( PixelType );  
  ~bicotiImageExtrapolationStrategy3DConstant(){};  
  
  PixelType operator() ( int, int, int );  
};  
  



//*********************************IMPLEMENTATIONS***********************************
//--------------------bicotiImageExtrapolationStrategy3DConstant---------------------
template< class PixelType >   
bicotiImageExtrapolationStrategy3DConstant< PixelType > :: bicotiImageExtrapolationStrategy3DConstant( PixelType def_pix )  
{  
  default_pixel = def_pix;  
};  
  
  
template< class PixelType >   
PixelType bicotiImageExtrapolationStrategy3DConstant< PixelType > :: operator() ( int x_0, int x_1, int x_2 )  
{  
  if ( ( 0 <= x_0 ) && ( 0 <= x_1 ) && ( 0 <= x_2 ) && ( x_0 < ptr_image->GetX0Size() ) && ( x_1 < ptr_image->GetX1Size() ) && ( x_2 < ptr_image->GetX2Size() ) )  
    return ( ptr_image->GetPixel( x_0, x_1, x_2 ) );  
  else  
    return ( default_pixel );  
};  


#endif
