//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _image_implementation_2D_bylayers 
#define _image_implementation_2D_bylayers 

 
#include <source/image_implementation/image_implementation_2D.hpp>


//**************************DECLARATIONS************************** 
/* 
//---ByLayers--- 
template<class Pixel> struct Component2D 
{ImageImp2DSimple<Pixel> * image; 
 int start_row, start_column, deep;}; 
 
 
 
template<class Pixel> class ImageImp2DByLayers : public ImageImp2D<Pixel> 
{public: 
  ImageImp2DByLayers(Pixel, unsigned=0, unsigned=0, int=0, int=0, int=0); 
  ~ImageImp2DByLayers(); 
 	 
  void Resize(unsigned , unsigned ); 
  void Append(ImageImp2DSimple<Pixel> * , int , int , int); 
  Component2D * Top(unsigned , unsigned);	 
  void Remove(Component2D *); 
	 
  int& StartRow(); 
  int& StartColumn(); 
  int& Deep(); 
 
 private: 
  int start_row , start_column , deep; 
  Component2D<Pixel> * ptr_components; 
  unsigned components_number;}; 
*/ 
 
 

//************************IMPLEMENTATIONS*************************
//---------------------------ByLayers-----------------------------
/* 
template<class Pixel> ImageImp2DByLayers<Pixel>::ImageImp2DByLayers(Pixel def_pixel, 
                        unsigned rows, unsigned columns, int startrow,  
                        int startcolumn, int deeplevel) 
{ 
 default_pixel=def_pixel; 
 window_rows=rows; 
 window_cols=columns; 
 start_row=startrow; 
 start_column=startcolumn; 
 deep=deeplevel; 
 components_number=0; 
 
 description=IMAGE2D; 
 implementation2D_type=BYLAYERS2D;}; 
	 
 
template<class Pixel> ImageImp2DByLayers<Pixel>::~ImageImp2DByLayers() 
{if (components_number>0) 
	delete [] ptr_components;}; 
 
template<class Pixel> void ImageImp2DByLayers<Pixel>::Resize( 
                        unsigned newrowsnumber, unsigned newcolumnsnumber) 
{window_rows=newrowsnumber; 
 window_cols=newcolumnsnumber;}; 
 
 
template<class Pixel> void ImageImp2DByLayers<Pixel>::Append( 
                        ImageImp2DSimple<Pixel> *image, int startrow,  
                        int startcolumn, int deep) 
{int count=0, cond1, cond2, cond3, cond4, cond5, found; 
 Component2D<Pixel> * ptr_components_aux; 
 
 if (components_number==0) 
 {ptr_components=new Component2D<Pixel>; 
  ptr_components->image=image; 
  ptr_components->start_row=startrow; 
  ptr_components->start_column=startcolumn; 
  ptr_components->deep=deep; 
 
  components_number++;} 
 else 
 {do 
  {cond1=(deep==ptr_components[count].deep); 
   cond2=(startcolumn<=ptr_components[count].start_column)&& 
			(ptr_components[count].start_column<= 
			(startcolumn+(int)image->WindowCols()-1)); 
   cond3=(ptr_components[count].start_column<=startcolumn)&& 
			(startcolumn<=(ptr_components[count].start_column+ 
			(int)ptr_components[count].image->WindowCols()-1)); 
   cond4=(startrow<=ptr_components[count].start_row)&& 
			(ptr_components[count].start_row<= 
			(startrow +(int)image->WindowRows()-1)); 
   cond5=(ptr_components[count].start_row<=startrow)&&(startrow<= 
			(ptr_components[count].start_row+ 
			(int)ptr_components[count].image->WindowRows()-1)); 
   found=cond1 && (cond2||cond3) && (cond4||cond5); 
 
   count++;}while ((!found) && (count<(int)components_number)); 
 
  if (found) 
  {printf("ERROR: La posicin donde se pretende insertar interfiere "); 
   printf("con otros componentes\n");} 
  else 
  {ptr_components_aux=ptr_components; 
   ptr_components=new Component2D<Pixel> [components_number+1]; 
 
  for (unsigned i=0;i<components_number;i++) 
	ptr_components[i]=ptr_components_aux[i]; 
				 
  ptr_components[components_number].image=image; 
  ptr_components[components_number].start_row=startrow; 
  ptr_components[components_number].start_column=startcolumn; 
  ptr_components[components_number].deep=deep; 
 
  components_number++; 
 
  delete [] ptr_components_aux;}}}; 
 
 
	 
template<class Pixel> Component2D<Pixel> * ImageImp2DByLayers<Pixel>::Top( 
                        unsigned row, unsigned column) 
{int count=0, cond1, cond2, cond3, found; 
 int best_deep; 
 Component2D<Pixel> * ptr_result; 
 
 
 if (components_number==0) 
	return NULL; 
 else 
 {do 
  {cond1= ptr_components[count].deep>=deep; 
   cond2=(ptr_components[count].start_column<=(start_column+ 
			(int)column))&&((start_column+(int)column)<= 
			(ptr_components[count].start_column+ 
			(int)ptr_components[count].image->WindowCols()-1)); 
   cond3=(ptr_components[count].start_row<=start_row+(int)row)&& 
			(start_row+(int)row<=(ptr_components[count].start_row+ 
			(int)ptr_components[count].image->WindowRows()-1)); 
   found=cond1 && cond2 && cond3; 
 
   count++;}while ((!found) && (count<(int)components_number)); //OJO 
 
   if (!found) 
	return NULL; 
   else 
   {ptr_result=ptr_components+count-1; 
    best_deep=ptr_components[count-1].deep; 
 
    while (count<(int)components_number) 
    {cond1=(ptr_components[count].deep<best_deep)&& 
			(ptr_components[count].deep>=deep); 
     cond2=(ptr_components[count].start_column<=start_column+(int)column)&& 
			(start_column+(int)column<= 
			(ptr_components[count].start_column+ 
			(int)ptr_components[count].image->WindowCols()-1)); 
     cond3=(ptr_components[count].start_row<=start_row+(int)row)&& 
			(start_row+(int)row<=(ptr_components[count].start_row+ 
			(int)ptr_components[count].image->WindowRows()-1)); 
     found=cond1 && cond2 && cond3; 
 
     if (found) 
     {best_deep=ptr_components[count].deep; 
      ptr_result=ptr_components+count;} 
				 
     count++;} 
 
     return ptr_result;}}  
 }; 
 
 
template<class Pixel> void ImageImp2DByLayers<Pixel>::Remove( 
                       Component2D<Pixel> * component) 
					//Habria que ver si chequear errores 
{Component2D<Pixel> * ptr_components_aux; 
 
 if (component != NULL) 
 {ptr_components_aux= new Component2D<Pixel>[components_number-1]; 
  unsigned count=0; 
 
  while (component != (ptr_components+count)) 
  {ptr_components_aux[count]=ptr_components[count]; 
   count++;} 
 
  while (count<(components_number-1)) 
  {ptr_components_aux[count]=ptr_components[count+1]; 
   count++;} 
 
  delete [] ptr_components; 
 
  ptr_components=ptr_components_aux; 
 
  components_number --;} 
}; 
 
/*template<class Pixel> int ImageImp2DByLayers<Pixel>::StartRow()  
                         {return start_row;}; 
template<class Pixel> int& ImageImp2DByLayers<Pixel>::StartColumn()  
                         {return start_column;}; // Cambiar Column por Col 
template<class Pixel> int& ImageImp2DByLayers<Pixel>::Deep() {return deep;};*/ 

 

 
#endif 
