#include <source/image_implementation/image_implementation_basic.hpp>

//---------------------bicotiImageDescriptor---------------------
bicotiImageDescriptor :: bicotiImageDescriptor( unsigned img_dim, double ima_sc, PixelCases pix_case )
{
  scale = ima_sc;
  pixel_case = pix_case;

  for(unsigned i = 0; i < img_dim; i++ )
    dimensions_list.push_back(0);
};


void bicotiImageDescriptor :: operator=( const bicotiImageDescriptor& ima_desc_src )
{
  dimensions_list = ima_desc_src.dimensions_list;
  scale = ima_desc_src.scale;
  pixel_case = ima_desc_src.pixel_case;
};


unsigned bicotiImageDescriptor :: GetDimension()
{
  return ( (unsigned) (dimensions_list.size()) );
};


unsigned& bicotiImageDescriptor :: Size( int dim_index )
{
  if ( ( dim_index < 0 ) || ( (int)(dimensions_list.size() ) <= dim_index ) )
    throw bicotiException( "bicotiImageDescriptor", "Size()", 1 );

  return( dimensions_list[ (unsigned)dim_index ] );
};


double bicotiImageDescriptor :: GetScale()
{
  return( scale );
};


PixelCases bicotiImageDescriptor :: GetPixelCase()
{
  return ( pixel_case );
};



