//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _image_pixel_interpolator_3D
#define _image_pixel_interpolator_3D



#include <source/image_pixel_interpolator/image_pixel_interpolator_basic.hpp>



//***********************DECLARATIONS*****************************
//---------------bicotiImagePixelInterpolator3D-------------------
template< class PixelType >  
class bicotiImagePixelInterpolator3D : public bicotiImagePixelInterpolator< PixelType >
{ 
protected:
  bicotiImageImplementation3D< PixelType > * ptr_image_imp; 
  
  bool InImage( bicotiCoordinate3D< REAL >& );  
  bool InBorder( bicotiCoordinate3D< REAL >& );  

public:
  void SetImageImplementation( bicotiImageImplementation< PixelType >* );
};  



//**********************IMPLEMENTATIONS***************************
//----------------bicotiImagePixelInterpolator3D------------------
template< class PixelType >  
void bicotiImagePixelInterpolator3D< PixelType > :: SetImageImplementation( bicotiImageImplementation< PixelType >* ptr_image)  
{
  ptr_image_imp = (bicotiImageImplementation3D< PixelType >*)ptr_image;
};


template< class PixelType >  
inline bool bicotiImagePixelInterpolator3D< PixelType > :: InImage( bicotiCoordinate3D< REAL >& coord )  
{    
  return( ( 0 <= coord.X0() ) && ( coord.X0() <=  ptr_image_imp->GetX0Size() - 1 ) &&
	  ( 0 <= coord.X1() ) && ( coord.X1() <=  ptr_image_imp->GetX1Size() - 1 ) && 
	  ( 0 <= coord.X2() ) && ( coord.X2() <=  ptr_image_imp->GetX2Size() - 1 ) );
};


template< class PixelType >  
inline bool bicotiImagePixelInterpolator3D< PixelType > :: InBorder( bicotiCoordinate3D< REAL >& coord )  
{  
  return( ( (int)coord.X0() == ( ptr_image_imp->GetX0Size() - 1 ) ) || 
	  ( (int)coord.X1() == ( ptr_image_imp->GetX1Size() - 1 ) ) ||
	  ( (int)coord.X2() == ( ptr_image_imp->GetX2Size() - 1 ) ) );
};



#endif            
