//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _image_pixel_interpolator_basic
#define _image_pixel_interpolator_basic



#include <source/image_implementation/image_implementation.hpp>



//*************************DECLARATIONS***************************
//-------------------bicotiCoordinateDistance---------------------
template< class CoordType >
class bicotiCoordinateDistance
{
public:
  CoordType internal_coord;
  CoordType external_coord;

  REAL distance;

  bicotiCoordinateDistance(){};

  void Update();
};


template< class CoordType >
class bicotiCoordinateDistanceCriterion
{
public:
  bool operator() ( const bicotiCoordinateDistance< CoordType >&, const bicotiCoordinateDistance< CoordType >& );
};



//-----------------bicotiImagePixelInterpolator-------------------
template< class PixelType >  
class bicotiImagePixelInterpolator 
{  
public:   
  virtual ~bicotiImagePixelInterpolator() {};
  virtual void SetImageImplementation( bicotiImageImplementation< PixelType > * ) = 0;

  virtual PixelType operator() ( bicotiCoordinate< REAL >& ) = 0; 
};   




//**********************IMPLEMENTATIONS***************************
//------------------bicotiCoordinateDistance----------------------
template< class CoordType >
inline void bicotiCoordinateDistance< CoordType > :: Update()
{
  CoordType aux_coord( internal_coord );
  aux_coord -= external_coord;
  distance = aux_coord.Norm();
};


template< class CoordType >
inline bool bicotiCoordinateDistanceCriterion< CoordType > :: operator() ( const bicotiCoordinateDistance< CoordType >& coord_1, const bicotiCoordinateDistance< CoordType >& coord_2 )
{
  return( coord_1.distance <= coord_2.distance );
};



#endif           
