#include <source/interaction/interaction_menu.hpp>


//------------------IMPLEMENTATIONS--------------------
//-----------bicotiInteractionSourceMenu-----
void bicotiInteractionSourceMenu :: AddListenerMenu( bicotiListenerMenu * ptr_listener, char * item )
{
  if( CheckItem( item ) )
    listener_menu.push_back( InternalPair( ptr_listener, item ) );
  else
    throw bicotiException( "bicotiInteractionSourceMenu" , "AddListenerMenu" , 4);       
}

void bicotiInteractionSourceMenu :: RemoveListenerMenu( bicotiListenerMenu * ptr_listener, char * item )
{
  vector< InternalPair > :: iterator iter;
  iter = find( listener_menu.begin(), listener_menu.end(), InternalPair( ptr_listener, item ) );
  listener_menu.erase( iter );
}

void bicotiInteractionSourceMenu :: FireItemSelected( bicotiActor * ptr_act, char * item )
{
  if( CheckItem( item ) )
    {for( int i = 0; i < listener_menu.size(); i++ )
      if( !strcmp( listener_menu[ i ].item_name, item ) )
	listener_menu[ i ].listener->ItemSelected( ptr_act, item );}
  else
        throw bicotiException( "bicotiInteractionSourceMenu" , "FireItemSelected" , 4);
}


bicotiInteractionSourceMenu :: InternalPair :: InternalPair( bicotiListenerMenu * ptr_list, char * item )
{
  listener = ptr_list;
  item_name = item;
}


bool bicotiInteractionSourceMenu :: InternalPair :: operator==( const InternalPair& ip ) const
{
  return( ( listener == ip.listener ) && ( item_name == ip.item_name ) );
}
