#include <source/interaction/interaction_scroll_bar.hpp>


//------------------IMPLEMENTATIONS--------------------
//-----------------bicotiEventScrollBarRange-----------------
bicotiEventScrollBarRange :: bicotiEventScrollBarRange( int minimum, int maximum )
{
  min = minimum;
  max = maximum;
}


int bicotiEventScrollBarRange :: GetMinimum() const
{
  return min;
}


int bicotiEventScrollBarRange :: GetMaximum() const
{
  return max;
}


//-----------------bicotiEventScrollBarRange-----------------
bicotiEventScrollBarStep :: bicotiEventScrollBarStep( int ls, int ps )
{
  line_step = ls;
  page_step = ps;
}


int bicotiEventScrollBarStep :: GetLineStep() const
{
  return line_step;
}


int bicotiEventScrollBarStep :: GetPageStep() const
{
  return page_step;
}


//-----------bicotiInteractionSourceScrollBar-----
void bicotiInteractionSourceScrollBar :: AddListenerScrollBar( bicotiListenerScrollBar * ptr_listener )
{
  listener_scroll_bar.push_back( ptr_listener );
}


void bicotiInteractionSourceScrollBar :: RemoveListenerScrollBar( bicotiListenerScrollBar * ptr_listener )
{
  vector< bicotiListenerScrollBar * > :: iterator iter;
  iter = find( listener_scroll_bar.begin(), listener_scroll_bar.end(), ptr_listener );
  listener_scroll_bar.erase( iter );
}


void bicotiInteractionSourceScrollBar :: FireScrollBarValueChanged( bicotiActor * ptr_act, int val )
{
  if ( CheckScrollBarValue( val ) )
    {for( int i = 0; i < listener_scroll_bar.size(); i++ )
      listener_scroll_bar[ i ]->ScrollBarValueChanged( ptr_act, val );}
}


void bicotiInteractionSourceScrollBar :: FireScrollBarRangeChanged( bicotiActor * ptr_act, int min, int max )
{
  if ( CheckScrollBarRange( min, max ) )
    {bicotiEventScrollBarRange event( min, max );
    for( int i = 0; i < listener_scroll_bar.size(); i++ )
      listener_scroll_bar[ i ]->ScrollBarRangeChanged( ptr_act, event );}
}


void bicotiInteractionSourceScrollBar :: FireScrollBarStepChanged( bicotiActor * ptr_act, int line, int page )
{
  if ( CheckScrollBarStep( line, page ) )
    {bicotiEventScrollBarStep event( line, page );
    for( int i = 0; i < listener_scroll_bar.size(); i++ )
      listener_scroll_bar[ i ]->ScrollBarStepChanged( ptr_act, event );}
}


void bicotiInteractionSourceScrollBar :: FireScrollBarSliderPressed( bicotiActor * ptr_act, int val )
{
  for( int i = 0; i < listener_scroll_bar.size(); i++ )
    listener_scroll_bar[ i ]->ScrollBarSliderPressed( ptr_act, val );
}



void bicotiInteractionSourceScrollBar :: FireScrollBarSliderReleased( bicotiActor * ptr_act, int val )
{
  for( int i = 0; i < listener_scroll_bar.size(); i++ )
    listener_scroll_bar[ i ]->ScrollBarSliderReleased( ptr_act, val );
}
