/**********************************************************************
** funciones de io manager para la libjpeg
***********************************************************************/

/*******************************************************************
ADMINISTRADOR DE DESTINO CON SUSPENCION 
********************************************************************/
#include <stdio.h>
#include <jpeglib.h>
#include <source/mapper/jpeg_io_mgr.h>

char work_buffer[WORK_BUFFER_SIZE];
long bytes_to_skip;
long byte_count;

void dest_buff_init(struct jpeg_compress_struct *cinfo)
{
  cinfo->dest->free_in_buffer =  WORK_BUFFER_SIZE;
  cinfo->dest->next_output_byte = work_buffer;
}


boolean dest_buff_empty(struct jpeg_compress_struct *cinfo)
{
  return FALSE;
}

void dest_buff_term(struct jpeg_compress_struct *cinfo)
{
}

void jpeg_buff_dest(struct jpeg_compress_struct *cinfo)
     
{
  struct jpeg_destination_mgr *destino;
  destino =(struct jpeg_destination_mgr *) malloc(sizeof(struct jpeg_destination_mgr));
  destino->init_destination    =  dest_buff_init;
  destino->empty_output_buffer =  dest_buff_empty;
  destino->term_destination    =  dest_buff_term;
  cinfo->dest = destino;
}
/*******************************************************************
	   ADMINISTRADOR DE FUENTE CON SUSPENCION 
********************************************************************/

void src_buff_init(struct jpeg_decompress_struct *cinfo)
{
  cinfo->src->bytes_in_buffer =  0;
  cinfo->src->next_input_byte = work_buffer;
}

boolean src_buff_fill(struct jpeg_decompress_struct *cinfo)
{
  return FALSE;
}

void src_buff_term(struct jpeg_decompress_struct *cinfo)
{
}

void src_buff_skip_data(struct jpeg_decompress_struct *cinfo, long num_bytes)
{if ( num_bytes > 0 )
  if ( cinfo->src->bytes_in_buffer < num_bytes  )
    {bytes_to_skip = num_bytes - cinfo->src->bytes_in_buffer;
    cinfo->src->bytes_in_buffer = 0;}
  else
    {cinfo->src->next_input_byte += num_bytes;
    cinfo->src->bytes_in_buffer -= num_bytes;}
}

void jpeg_buff_src(struct jpeg_decompress_struct *cinfo)
{
  struct jpeg_source_mgr *fuente;
  fuente =(struct jpeg_source_mgr *) malloc(sizeof(struct jpeg_source_mgr));
  fuente->init_source    =     src_buff_init;
  fuente->fill_input_buffer =  src_buff_fill;
  fuente->skip_input_data   =  src_buff_skip_data;
  fuente->resync_to_restart   = jpeg_resync_to_restart;
  fuente->term_source   =    src_buff_term;
  cinfo->src = fuente;
}
