#ifndef _bicoti_mapper_jpeg_ijg
#define _bicoti_mapper_jpeg_ijg

#include <source/mapper/mapper_jpeg.hpp>
#include <stdio.h>

extern "C"
{
#include <jpeglib.h>
#include <source/mapper/jpeg_io_mgr.h>
}


//----------------bicotiMapperJPEGIJG------------------

/**
 * Mapper tiff implementado sobre jpglib de IJG
 *
 * Permite leer y escribir imagenes jpeg
 */
template< class PixelType, class PixelConverter >
class bicotiMapperJPEGIJG : public bicotiMapperJPEG< PixelType >
{
private:
  void reload_buffer( bicotiDevice * , char * ,struct jpeg_decompress_struct * );
 J_COLOR_SPACE ColorSpaceConvert( bicotiColorSpace cs );
 J_DITHER_MODE DitherModeConvert( bicotiDitherMode dm ); 
  
public:
  /** Constructor */
  bicotiMapperJPEGIJG();
  
  /** 
   * Lee una imagen jpeg y la guarda en una bicotiImage
   *
   *@exception bicotiException, si no hay implementacin de imagen o device  
   */
  void Read();
  
  /** 
   *Escribe una imagen jpeg a partir de bicotiImage 
   *
   *@exception bicotiException, si no hay implementacin de imagen o device  
   */
  void Write();
};


#endif
