//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _neighbour_function_linear
#define _neighbour_function_linear




#include <source/neighbour_filter/neighbour_function_basic.hpp>



//**********************DECALARATIONS*****************************
//---------------bicotiNeighbourFunctionLinear--------------------
template< class PixelType, class PrecisionType >
class bicotiNeighbourFunctionLinear : public bicotiNeighbourFunction< PixelType >
{
private:
  bicotiFrame< PrecisionType > * ptr_kernel_frame;
  
public :
  bicotiNeighbourFunctionLinear( bicotiFrame< PrecisionType > * );
  PixelType operator()( bicotiFrame< PixelType > * );  
};




//*********************IMPLEMENTATIONS****************************
//----------------bicotiNeighbourFunctionLinear-------------------
template< class PixelType, class PrecisionType >
bicotiNeighbourFunctionLinear< PixelType, PrecisionType > :: bicotiNeighbourFunctionLinear( bicotiFrame< PrecisionType >* ptr_k_fr)
{
  ptr_kernel_frame = ptr_k_fr;
};


template< class PixelType, class PrecisionType >
PixelType bicotiNeighbourFunctionLinear< PixelType, PrecisionType > :: operator()( bicotiFrame< PixelType >* ptr_frame )
{
  ptr_kernel_frame->First();
  ptr_frame->First();
  
  PrecisionType sum = ( ( ptr_kernel_frame->CurrentPixel() ) * ( ptr_frame->CurrentPixel() ) );
  ptr_kernel_frame->Next();
  ptr_frame->Next();
  
  while (!(ptr_kernel_frame->IsDone())) 
    {
      sum = sum + ( ptr_kernel_frame->CurrentPixel() ) * ( ptr_frame->CurrentPixel() );
      ptr_kernel_frame->Next();
      ptr_frame->Next();
    };
  
  return( (PixelType)sum );
};   



#endif
