//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _neighbour_function_minimum
#define _neighbour_function_minimum



#include <source/neighbour_filter/neighbour_function_basic.hpp>



//**********************DECALARATIONS******************************
//------------bicotiNeighbourFunctionMinimumSingle-----------------
template<class PixelType>
class bicotiNeighbourFunctionMinimumSingle : public bicotiNeighbourFunction<PixelType>
{
  PixelType operator()( bicotiFrame< PixelType >* ); 
};


//--------------bicotiNeighbourFunctionMinimumVectorial------------
template<class PixelType>
class bicotiNeighbourFunctionMinimumVectorial : public bicotiNeighbourFunction<PixelType>
{
  PixelType operator()( bicotiFrame< PixelType >* ); 
};




//*********************IMPLEMENTATIONS*****************************
//------------bicotiNeighbourFunctionMinimumSingle-----------------
template<class PixelType>
PixelType bicotiNeighbourFunctionMinimumSingle<PixelType> :: operator()( bicotiFrame<PixelType>* ptr_frame )
{
  ptr_frame->First();
  PixelType min_value = ptr_frame->CurrentPixel();
  ptr_frame->Next();
  
  while (!(ptr_frame->IsDone())) 
    {if( ( ptr_frame->CurrentPixel() ) < min_value )
      min_value = ptr_frame->CurrentPixel();
    ptr_frame->Next();};
  
  return( min_value );
};



//----------bicotiNeighbourFunctionMinimumVectorial----------------
template< class PixelType >
PixelType bicotiNeighbourFunctionMinimumVectorial< PixelType > :: operator()( bicotiFrame< PixelType >* ptr_frame )
{
  unsigned index; 

  ptr_frame->First();
  PixelType min_value =( ptr_frame->CurrentPixel() );
  ptr_frame->Next();
  
  while ( !ptr_frame->IsDone() ) 
    {for( index = 0; index < min_value.GetColorsNumber(); index++ )
      {if( ( ptr_frame->CurrentPixel() )( index ) < min_value( index ) )
	min_value( index ) = ( ptr_frame->CurrentPixel() )( index );}
    ptr_frame->Next();}
  
  return( min_value );
};      



#endif
