//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _operator_unary
#define _operator_unary



#include <source/operator_unary/operator_unary_basic.hpp>



//************************DECLARATION******************************
template< class Pixel >
class bicotiOperatorUnaryFacade 
{
private:
  bicotiOperatorUnary< Pixel > * ptr_oper_unary;

public:
  bicotiOperatorUnaryFacade( bicotiImageImplementation< Pixel > * );
  ~bicotiOperatorUnaryFacade();
  
  void Product( double );
  void AbsoluteValue();
  void Logarithm();
  void Addition( Pixel );
  void Constant( Pixel );
};




//**********************IMPLEMENTATION*****************************
template< class Pixel >
bicotiOperatorUnaryFacade< Pixel > :: bicotiOperatorUnaryFacade( bicotiImageImplementation< Pixel > * ptr_ima_imp )
{
  ptr_oper_unary = new bicotiOperatorUnary< Pixel >( ptr_ima_imp );
};


template< class Pixel >
bicotiOperatorUnaryFacade< Pixel > :: ~bicotiOperatorUnaryFacade()
{
  delete ptr_oper_unary;
};


template< class Pixel >
void bicotiOperatorUnaryFacade< Pixel > :: Product( double scalar )
{
  bicotiPixelOperatorUnaryProduct< Pixel > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorUnaryProduct< Pixel >( scalar );

  ptr_oper_unary->Apply( ptr_oper );

  delete ptr_oper;
};


template< class Pixel >
void bicotiOperatorUnaryFacade< Pixel > :: AbsoluteValue()
{
  bicotiPixelOperatorUnaryAbsoluteValue< Pixel > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorUnaryAbsoluteValue< Pixel >;
  
  ptr_oper_unary->Apply( ptr_oper );
  
  delete ptr_oper;
};


template< class Pixel >
void bicotiOperatorUnaryFacade< Pixel > :: Logarithm()
{
  bicotiPixelOperatorUnaryLogarithm< Pixel > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorUnaryLogarithm< Pixel >;
  
  ptr_oper_unary->Apply( ptr_oper );

  delete ptr_oper;
};


template< class Pixel >
void bicotiOperatorUnaryFacade< Pixel > :: Addition( Pixel pix )
{
  bicotiPixelOperatorUnaryAddition< Pixel > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorUnaryAddition< Pixel >( pix );
  
  ptr_oper_unary->Apply( ptr_oper );

  delete ptr_oper;
};


template< class Pixel >
void bicotiOperatorUnaryFacade< Pixel > :: Constant( Pixel pix )
{
  bicotiPixelOperatorUnaryConstant< Pixel > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorUnaryConstant< Pixel >( pix );
  
  ptr_oper_unary->Apply( ptr_oper );
  
  delete ptr_oper;
};      


#endif
