//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _operator_unary_basic
#define _operator_unary_basic



#include <source/abstract_image.hpp>



//***********************DECLARATIONS******************************
//----------------------------base---------------------------------
template<class Pixel>
class bicotiOperatorUnary
{
protected:
  bicotiImageImplementation<Pixel> * ptr_image_imp;

public:
  bicotiOperatorUnary( bicotiImageImplementation< Pixel > * );

  void Apply( bicotiPixelOperatorUnary< Pixel > * );
};




//**********************IMPLEMENTATIONS****************************
//----------------------------base---------------------------------
template<class Pixel>
bicotiOperatorUnary< Pixel > :: bicotiOperatorUnary( bicotiImageImplementation< Pixel > * ptr_ima_imp )
{
  ptr_image_imp = ptr_ima_imp;
};


//----------------------------Apply--------------------------------
template<class Pixel>
void bicotiOperatorUnary< Pixel > :: Apply( bicotiPixelOperatorUnary< Pixel > * ptr_oper )
{
  bicotiImageIterator<Pixel> * ptr_iter;
  
  ptr_iter = ptr_image_imp->CreateIterator();
  
  for( ptr_iter->First(); !ptr_iter->IsDone(); (*ptr_iter)++ )
    (**ptr_iter) = ( *ptr_oper )( **ptr_iter );
  
  delete ptr_iter;
};     



#endif
