//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_attribute_selector_hsv
#define _pixel_attribute_selector_hsv

#include <source/pixel/pixel_attribute_selector_basic.hpp>



//**********************DECLARATIONS*******************************
//--------------bicotiPixelAttributeSelectorColorHue---------------
template< class AttributeType, class PrecisionType >
class bicotiPixelAttributeSelectorColorHue : public bicotiPixelAttributeSelector< AttributeType, bicotiHSV< AttributeType, PrecisionType > >
{
public:
  AttributeType operator() ( bicotiHSV< AttributeType, PrecisionType > );
  bicotiHSV< AttributeType, PrecisionType > Inverse( bicotiHSV< AttributeType, PrecisionType >, AttributeType );
};




//*********************IMPLEMENTATIONS*****************************
//------------bicotiPixelAttributeSelectorColorHue-----------------
template< class AttributeType, class PrecisionType >
AttributeType bicotiPixelAttributeSelectorColorHue< AttributeType, PrecisionType > :: operator() ( bicotiHSV< AttributeType, PrecisionType > pix_val )
{
  return ( pix_val.Hue() );
};


template< class AttributeType, class PrecisionType >
bicotiHSV< AttributeType, PrecisionType > bicotiPixelAttributeSelectorColorHue< AttributeType, PrecisionType > :: Inverse( bicotiHSV< AttributeType, PrecisionType > pix_val, AttributeType col_val )
{
  pix_val.Hue() = col_val;

  if( col_val == 361 )
    {pix_val.Value() = 0;
    pix_val.Saturation() = 0;
    pix_val.Undefined() = true;}
  
  return ( pix_val );
};

#endif
