//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_attribute_selector_vectorial
#define _pixel_attribute_selector_vectorial


#include <source/pixel/pixel_attribute_selector_basic.hpp>



//***********************DECLARATIONS******************************
//-----------bicotiPixelAttributeSelectorColorVectorial------------
template< class AttributeType, class PixelType >
class bicotiPixelAttributeSelectorColorVectorial : public bicotiPixelAttributeSelector< AttributeType, PixelType >
{
private:
  unsigned color_index;
  
public:
  bicotiPixelAttributeSelectorColorVectorial( unsigned );

  AttributeType operator() ( PixelType );
  PixelType Inverse( PixelType, AttributeType );
};



//********************IMPLEMENTATIONS******************************
//---------bicotiPixelAttributeSelectorColorVectorial--------------
template< class AttributeType, class PixelType >
bicotiPixelAttributeSelectorColorVectorial< AttributeType, PixelType > :: bicotiPixelAttributeSelectorColorVectorial( unsigned col_index )
{
  color_index = col_index;
};


template< class AttributeType, class PixelType >
inline AttributeType bicotiPixelAttributeSelectorColorVectorial< AttributeType, PixelType > :: operator() ( PixelType pix_val )
{
#ifdef TOTAL_CHECK
  if ( pix_val.GetColorsNumber() <= color_index )
    throw bicotiException( "bicotiPixelAttributeSelectorColorVectorial", "operator()", 1 );
#endif

  return ( pix_val(color_index) );
};


template< class AttributeType, class PixelType >
inline PixelType bicotiPixelAttributeSelectorColorVectorial< AttributeType, PixelType > :: Inverse( PixelType pix_val, AttributeType col_val)
{
#ifdef TOTAL_CHECK
  if ( pix_val.GetColorsNumber() <= color_index )
    throw bicotiException( "bicotiPixelAttributeSelectorColorVectorial", "Inverse", 1 );
#endif
  
  pix_val(color_index) = col_val;
  return ( pix_val );
};           

#endif
