#ifndef _bicoti_pixel_converter_rgba
#define _bicoti_pixel_converter_rgba

#include <source/pixel/pixel.hpp>

typedef unsigned int bicotiPixelRGBA;

class bicotiPixelConverterChar2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const unsigned char );
  static const unsigned char Unconvert( const bicotiPixelRGBA );
};

class bicotiPixelConverterInt2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const unsigned int );
  static const unsigned int Unconvert( const bicotiPixelRGBA );
};

class bicotiPixelConverterFloat2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const float );
  static const float Unconvert( const bicotiPixelRGBA );
};

class bicotiPixelConverterDouble2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const double );
  static const double Unconvert( const bicotiPixelRGBA );
};

class bicotiPixelConverterRGBChar2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const  bicotiRGB< unsigned char , REAL > );
  static const bicotiRGB< unsigned char , REAL > Unconvert( const bicotiPixelRGBA );
};


class bicotiPixelConverterRGBFloat2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const  bicotiRGB< float , REAL > );
  static const bicotiRGB< float , REAL > Unconvert( const bicotiPixelRGBA );
};


class bicotiPixelConverterHSVInt2RGBA
{
private:
  static unsigned int Maximum( unsigned int, unsigned int, unsigned int );

public:
  static const bicotiPixelRGBA Convert( const  bicotiHSV< unsigned int, REAL > );
  static const bicotiHSV< unsigned int, REAL > Unconvert( const bicotiPixelRGBA );
};

#endif
