//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_binary_division
#define _pixel_operator_binary_division

#include <source/pixel/pixel_operator_binary_basic.hpp>



//***********************DECLARATIONS******************************
//--------------bicotiPixelOperatorBinaryDivision------------------
template< class PixelType >
class bicotiPixelOperatorBinaryDivision : public bicotiPixelOperatorBinary< PixelType >
{
private:
  PixelType pixel_zero, pixel_infinite;

public:
  bicotiPixelOperatorBinaryDivision( PixelType, PixelType);

  PixelType operator() ( PixelType, PixelType );
};



//*********************IMPLEMENTATIONS*****************************
//-------------bicotiPixelOperatorBinaryDivision-------------------
template< class PixelType >
bicotiPixelOperatorBinaryDivision< PixelType > :: bicotiPixelOperatorBinaryDivision( PixelType zero, PixelType infinite)
{
  pixel_zero = zero;
  pixel_infinite = infinite;
};


template< class PixelType >
inline PixelType bicotiPixelOperatorBinaryDivision< PixelType > :: operator() ( PixelType pix_1, PixelType pix_2)
{
  if( pix_2 == pixel_zero)
    return( pixel_infinite );
  else
    return( (PixelType) (pix_1 / pix_2) );
};      

#endif
