//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_unary_addition
#define _pixel_operator_unary_addition

#include <source/pixel/pixel_operator_unary_basic.hpp>



//***********************DECLARATIONS******************************
//--------------------------Addition-------------------------------
template< class PixelType >
class bicotiPixelOperatorUnaryAddition : public bicotiPixelOperatorUnary< PixelType >
{
private:
  PixelType pixel;

public:
  bicotiPixelOperatorUnaryAddition(){};
  bicotiPixelOperatorUnaryAddition( PixelType );
  
  PixelType& Pixel();
  PixelType operator() ( PixelType );
};




//**********************IMPLEMENTATIONS****************************
//---------------------------Addition------------------------------
template< class PixelType >
bicotiPixelOperatorUnaryAddition< PixelType > :: bicotiPixelOperatorUnaryAddition( PixelType pixel_value )
{
  pixel = pixel_value;
};


template< class PixelType > 
inline PixelType& bicotiPixelOperatorUnaryAddition< PixelType > :: Pixel()
{
  return( pixel );
};

template< class PixelType > 
inline PixelType bicotiPixelOperatorUnaryAddition< PixelType > :: operator() ( PixelType pix_val )
{
  return ( (PixelType) ( pix_val + pixel ) );
};    

#endif
