//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_unary_product
#define _pixel_operator_unary_product

#include <source/pixel/pixel_operator_unary_basic.hpp>



//***********************DECLARATIONS******************************
//--------------------------Product--------------------------------
template< class PixelType >
class bicotiPixelOperatorUnaryProduct : public bicotiPixelOperatorUnary< PixelType >
{
private:
  double scalar;

public:
  bicotiPixelOperatorUnaryProduct( double = 0 );
  
  double& Scalar();
  PixelType operator() ( PixelType );
};



//**********************IMPLEMENTATIONS****************************
//----------------------------Product------------------------------
template< class PixelType >
bicotiPixelOperatorUnaryProduct< PixelType > :: bicotiPixelOperatorUnaryProduct( double scalar_value )
{
  scalar = scalar_value;
};


template<class PixelType> 
inline double& bicotiPixelOperatorUnaryProduct< PixelType > :: Scalar()
{
  return ( scalar );
};


template<class PixelType> 
inline PixelType bicotiPixelOperatorUnaryProduct< PixelType > :: operator() ( PixelType pix_val )
{
  return ( (PixelType) ( pix_val * scalar ) );
};    

#endif
