//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_unary_segmentation_range
#define _pixel_operator_unary_segmentation_range

#include <source/pixel/pixel_operator_unary_basic.hpp>



//***********************DECLARATIONS******************************
//---------------------SegmentationRange---------------------------
template< class ColorType >
class bicotiPixelOperatorUnarySegmentationRange : public bicotiPixelOperatorUnary< ColorType >
{
private:
  ColorType threshold_value;
  ColorType lower_threshold;
  ColorType upper_threshold;

public:
  bicotiPixelOperatorUnarySegmentationRange( ColorType, ColorType, ColorType );
  bicotiPixelOperatorUnarySegmentationRange(){};

  ColorType LowerThreshold();
  ColorType UpperThreshold();
  ColorType ThresholdValue();

  ColorType operator() ( ColorType );
};



//**********************IMPLEMENTATIONS****************************
//---------------------SegmentationRange---------------------------
template< class ColorType >
bicotiPixelOperatorUnarySegmentationRange< ColorType > :: bicotiPixelOperatorUnarySegmentationRange( ColorType the_value, ColorType low_value, ColorType upp_value )
{
  threshold_value = the_value;
  lower_threshold = low_value;
  upper_threshold = upp_value;
};


template< class ColorType >
ColorType bicotiPixelOperatorUnarySegmentationRange< ColorType > :: LowerThreshold()
{
  return( lower_threshold );
};


template< class ColorType >
ColorType bicotiPixelOperatorUnarySegmentationRange< ColorType > :: UpperThreshold()
{
  return( upper_threshold );
};


template< class ColorType >
ColorType bicotiPixelOperatorUnarySegmentationRange< ColorType > :: ThresholdValue()
{
  return( threshold_value );
};


template< class ColorType >
ColorType bicotiPixelOperatorUnarySegmentationRange< ColorType > :: operator() ( ColorType pix_value )
{
  if ( ( lower_threshold <= pix_value ) && ( pix_value <= upper_threshold ) )
    return ( threshold_value );
  else
    return ( pix_value );
};        

#endif
