//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_unary_uniform
#define _pixel_operator_unary_uniform

#include <source/pixel/pixel_operator_unary_basic.hpp>



//***********************DECLARATIONS******************************
//----------------bicotiPixelOperatorUnaryUniform------------------

template< class CoordType, class ColorType, class PixelType >
class bicotiDexelHistogram;


template< class CoordType, class ColorType, class PixelType = ColorType >
class bicotiPixelOperatorUnaryUniform : public bicotiPixelOperatorUnary< ColorType >
{
private:
  bicotiDexelHistogram< CoordType, ColorType, PixelType > * ptr_dexel;

  unsigned number_of_pixels;
  ColorType max_color_value;
  unsigned pixel_acumulator;

public:
  bicotiPixelOperatorUnaryUniform( bicotiDexelHistogram< CoordType, ColorType, PixelType > * = NULL );

  void Initiate(  bicotiDexelHistogram< CoordType, ColorType, PixelType > * );
  ColorType operator() ( ColorType );
};




//**********************IMPLEMENTATIONS****************************
//-----------------bicotiPixelOperatorUnaryUniform-----------------
template< class CoordType, class ColorType, class PixelType >
bicotiPixelOperatorUnaryUniform< CoordType, ColorType, PixelType > :: bicotiPixelOperatorUnaryUniform( bicotiDexelHistogram< CoordType, ColorType, PixelType > * ptr_dex )
{
  number_of_pixels = pixel_acumulator = 0;
  if ( ptr_dex != NULL )
    Initiate( ptr_dex );
};


template< class CoordType, class ColorType, class PixelType >
void bicotiPixelOperatorUnaryUniform< CoordType, ColorType, PixelType > :: Initiate(  bicotiDexelHistogram< CoordType, ColorType, PixelType > * ptr_dex)
{
  ptr_dexel = ptr_dex;
  number_of_pixels = pixel_acumulator = 0;

  for ( ptr_dexel->First(); !ptr_dexel->IsDone(); ptr_dexel->Next() )
    {max_color_value = ptr_dexel->GetCurrentColor();
    number_of_pixels += ptr_dexel->GetCurrentPointsNumber();}
};


template< class CoordType, class ColorType, class PixelType >
ColorType bicotiPixelOperatorUnaryUniform< CoordType, ColorType, PixelType > :: operator() ( ColorType pix_value )
{
  pixel_acumulator += ptr_dexel->GetCurrentPointsNumber();
  return ( ( ColorType ) ( ( max_color_value * pixel_acumulator ) / number_of_pixels ) );
};          

#endif
