#include <source/pixel/pixel_rgb_tools.hpp>


bicotiPixelColor bicotiRGBTools :: GetRed( bicotiPixelRGBA pixel )
{
  return( ( pixel & red ) >> 24 );
}


bicotiPixelColor bicotiRGBTools :: GetGreen( bicotiPixelRGBA pixel )
{
  return( ( pixel & green ) >> 16 );
}

bicotiPixelColor bicotiRGBTools :: GetBlue( bicotiPixelRGBA pixel )
{
  return( ( pixel & blue ) >> 8 );
}

bicotiPixelColor bicotiRGBTools :: GetAlpha( bicotiPixelRGBA pixel )
{
  return( pixel & alpha );
}

bicotiPixelRGBA bicotiRGBTools :: SetRed( bicotiPixelRGBA pixel, bicotiPixelColor color )
{
  return( ( pixel & redc ) | ( ( color & alpha ) << 24 ) );
}

bicotiPixelRGBA bicotiRGBTools :: SetGreen( bicotiPixelRGBA pixel, bicotiPixelColor color )
{
  return( ( pixel & greenc ) | ( ( color & alpha ) << 16 ) );
}

bicotiPixelRGBA bicotiRGBTools :: SetBlue( bicotiPixelRGBA pixel, bicotiPixelColor color )
{
  return( ( pixel & bluec ) | ( ( color & alpha ) << 8 ) );
}

bicotiPixelRGBA bicotiRGBTools :: SetAlpha( bicotiPixelRGBA pixel, bicotiPixelColor color )
{
  return( ( pixel & alphac ) | ( color & alpha ) );
}

bicotiPixelRGBA bicotiRGBTools :: CreateRGBA( bicotiPixelColor color_r, bicotiPixelColor color_g, bicotiPixelColor color_b, bicotiPixelColor color_a )
{
  return( ( ( color_r & alpha ) << 24 ) | ( ( color_g & alpha ) << 16 ) | ( ( color_b & alpha ) << 8 ) | ( color_a & alpha ) );
}

bicotiPixelRGBA bicotiRGBTools :: CreateGrayscale( bicotiPixelColor color, bicotiPixelColor color_a )
{
  bicotiPixelColor aux = ( color & alpha );
  return( ( aux << 24 ) | ( aux << 16 ) | ( aux << 8 ) | ( color_a & alpha ) );
}

/*
const bicotiPixelRGBA bicotiPixelConverterChar2RGBA :: Convert( const unsigned char pixel )
{
  return( bicotiRGBTools :: CreateRGBA( pixel, pixel, pixel ) );
}

const unsigned char bicotiPixelConverterChar2RGBA :: Unconvert( const bicotiPixelRGBA pixel )
{
  return( (unsigned char)(0.299 * (bicotiRGBTools :: GetRed( pixel )) + 0.587 * (bicotiRGBTools :: GetGreen( pixel )) + 0.114 * (bicotiRGBTools :: GetBlue( pixel ))) );
}


const bicotiPixelRGBA bicotiPixelConverterDouble2RGBA :: Convert( const double pixel )
{
  return( bicotiRGBTools :: CreateRGBA( pixel, pixel, pixel ) );
}

const double bicotiPixelConverterDouble2RGBA :: Unconvert( const bicotiPixelRGBA pixel )
{
  return( (double)(0.299 * (bicotiRGBTools :: GetRed( pixel )) + 0.587 * (bicotiRGBTools :: GetGreen( pixel )) + 0.114 * (bicotiRGBTools :: GetBlue( pixel ))) );
}



const bicotiPixelRGBA bicotiPixelConverterRGBChar2RGBA :: Convert( const bicotiRGB< unsigned char , REAL >  pixel )
{
  return( bicotiRGBTools :: CreateRGBA( pixel.Red() , pixel.Green() , pixel.Blue() ) );
}

const bicotiRGB< unsigned char, REAL > bicotiPixelConverterRGBChar2RGBA :: Unconvert( const bicotiPixelRGBA pixel )
{
  return( bicotiRGB< unsigned char, REAL >( (bicotiRGBTools :: GetRed( pixel )), (bicotiRGBTools :: GetGreen( pixel )), (bicotiRGBTools :: GetBlue( pixel ))) );
}



const bicotiPixelRGBA bicotiPixelConverterRGBFloat2RGBA :: Convert( const bicotiRGB< float , REAL >  pixel )
{
  return( bicotiRGBTools :: CreateRGBA( pixel.Red() , pixel.Green() , pixel.Blue() ) );
}

const bicotiRGB< float, REAL > bicotiPixelConverterRGBFloat2RGBA :: Unconvert( const bicotiPixelRGBA pixel )
{
  return( bicotiRGB< float, REAL >( (bicotiRGBTools :: GetRed( pixel )), (bicotiRGBTools :: GetGreen( pixel )), (bicotiRGBTools :: GetBlue( pixel ))) );
}
*/
