#ifndef _bicoti_rgb_tools
#define _bicoti_rgb_tools

#include <source/pixel/pixel.hpp>

typedef unsigned int bicotiPixelColor;
typedef unsigned int bicotiPixelRGBA;

class bicotiRGBTools
{
private:
  static const bicotiPixelColor red = 0xFF000000;
  static const bicotiPixelColor redc = 0x00FFFFFF;
  static const bicotiPixelColor green = 0x00FF0000;
  static const bicotiPixelColor greenc = 0xFF00FFFF;
  static const bicotiPixelColor blue = 0x0000FF00;
  static const bicotiPixelColor bluec = 0xFFFF00FF;
  static const bicotiPixelColor alpha = 0x000000FF;
  static const bicotiPixelColor alphac = 0xFFFFFF00;

public:
  static bicotiPixelColor GetRed( bicotiPixelRGBA );
  static bicotiPixelColor GetGreen( bicotiPixelRGBA );
  static bicotiPixelColor GetBlue( bicotiPixelRGBA );
  static bicotiPixelColor GetAlpha( bicotiPixelRGBA );

  static bicotiPixelRGBA SetRed( bicotiPixelRGBA, bicotiPixelColor );
  static bicotiPixelRGBA SetGreen( bicotiPixelRGBA, bicotiPixelColor );
  static bicotiPixelRGBA SetBlue( bicotiPixelRGBA, bicotiPixelColor );
  static bicotiPixelRGBA SetAlpha( bicotiPixelRGBA, bicotiPixelColor );

  static const bicotiPixelColor full_transparency = 0;
  static const bicotiPixelColor full_opacity = 255;

  static bicotiPixelRGBA CreateRGBA( bicotiPixelColor, bicotiPixelColor, bicotiPixelColor, bicotiPixelColor = full_opacity );
  static bicotiPixelRGBA CreateGrayscale( bicotiPixelColor, bicotiPixelColor = full_opacity );
};

/*
class bicotiPixelConverterChar2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const unsigned char );
  static const unsigned char Unconvert( const bicotiPixelRGBA );
};

class bicotiPixelConverterDouble2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const double );
  static const double Unconvert( const bicotiPixelRGBA );
};

class bicotiPixelConverterRGBChar2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const  bicotiRGB< unsigned char , REAL > );
  static const bicotiRGB< unsigned char , REAL > Unconvert( const bicotiPixelRGBA );
};


class bicotiPixelConverterRGBFloat2RGBA
{
public:
  static const bicotiPixelRGBA Convert( const  bicotiRGB< float , REAL > );
  static const bicotiRGB< float , REAL > Unconvert( const bicotiPixelRGBA );
};

*/
#endif
