//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_weight_value
#define _pixel_weight_value

#include <source/pixel/pixel_weight_basic.hpp>



//************************DECLARATIONS*****************************
template< class PixelType >
class bicotiPixelWeightValue : public bicotiPixelWeight< PixelType >
{
public:
  virtual double operator() ( PixelType ) = 0;
};


template< class PixelType >
class bicotiPixelWeightValueSingle : public bicotiPixelWeightValue< PixelType >
{
public:
  double operator() ( PixelType );
};


template< class PixelType >
class bicotiPixelWeightValueVectorial : public bicotiPixelWeightValue< PixelType >
{
public:
  double operator() ( PixelType );
};



//***********************IMPLEMENTATIONS***************************
template< class PixelType >
inline double bicotiPixelWeightValueSingle< PixelType > :: operator() ( PixelType pixel )
{
  return( (double)fabs( pixel ) );
};


template< class PixelType >
inline double bicotiPixelWeightValueVectorial< PixelType > :: operator() ( PixelType pixel )
{
  double return_val = 0;

  for( unsigned index = 0; index < pixel.GetColorsNumber(); index++ )
    return_val += (double)fabs( pixel( index ) );
  
  return( return_val );
};                 

#endif
