//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _histogram_equalizator
#define _histogram_equalizator


#include <source/property/property_histogram.hpp>


//************************DECLARATIONS********************
//--------------------bicotiHistogramEqualizator----------------
template< class CoordType, class ColorType, class PixelType = ColorType >
class bicotiHistogramEqualizator
{
private:
  bicotiPropertyHistogramExtended< CoordType, ColorType, PixelType > * ptr_proper_histo;
  vector< bicotiPixelOperatorUnary< ColorType > * > operators_list;

public:
  bicotiHistogramEqualizator( bicotiPropertyHistogramExtended< CoordType, ColorType, PixelType > *, const vector< bicotiPixelOperatorUnary< ColorType > * >& );

  void operator() ();
};



//**********************IMPLEMENTATIONS*******************
//--------------------bicotiHistogramEqualizator----------------
template< class CoordType, class ColorType, class PixelType > 
bicotiHistogramEqualizator< CoordType, ColorType, PixelType > :: bicotiHistogramEqualizator( bicotiPropertyHistogramExtended< CoordType, ColorType, PixelType > * ptr_prop_histo, const vector< bicotiPixelOperatorUnary< ColorType > * >& op_list )
{
  if ( ptr_prop_histo->GetHistogramsNumber() != op_list.size() )
    throw bicotiException( "bicotiHistogramEqualizator", "Constructor", 4 );
  
  ptr_proper_histo = ptr_prop_histo;
  operators_list = op_list;
};


//------------------------Equalizate----------------------
template< class CoordType, class ColorType, class PixelType > 
void bicotiHistogramEqualizator< CoordType, ColorType, PixelType > :: operator() ()
{
  unsigned index;
  bicotiDexelHistogram< CoordType, ColorType, PixelType > * ptr_dexel_temp;
  ColorType new_color_value;
  
  for( index = 0; index < ptr_proper_histo->GetHistogramsNumber(); index++ )
    {ptr_dexel_temp = ( ptr_proper_histo->ptr_dexels )[ index ];
    for ( ptr_dexel_temp->First(); !ptr_dexel_temp->IsDone(); ptr_dexel_temp->Next() )
      {new_color_value = ( *( ptr_dexel_temp->first ) ).ColorValue();
      new_color_value = ( *( operators_list[ index ] ) )( new_color_value );
      ( *( ptr_dexel_temp->first ) ).ColorValue() =  new_color_value;};
      ptr_dexel_temp->SelfFit();
      ptr_dexel_temp->UpdateImageImplementation();}
};          




#endif
